// 网络层事件
export class NetworkEvent {
    // 网络遮罩计数
    public static readonly WAIT = 'WAIT';
    // 关闭网络遮罩
    public static readonly WAIT_CLOSE = 'WAIT_CLOSE';
    // 登录请求失败
    public static readonly LOGIN_FAILED = 'LOGIN_FAILED';
    // 超时
    public static readonly ON_TIME_OUT = 'ON_TIME_OUT';
    // 请求回调数据异常
    public static readonly ON_EXCEPTION = 'ON_EXCEPTION';
    public static readonly NETWAIT_MASK = "NetworkEvent.NETWAIT_MASK";    // 强制要求先后顺序的请求时,打开遮罩
    public static readonly NET_MSG_REGISTER = "NetworkEvent.NET_MSG_REGISTER";    // 注册网络消息
}
// UI事件
export class GUIEvent {
    public static readonly SHOW_MASK = 'GUIEvent.SHOW_MASK'//UI遮罩
    public static readonly CLOSE_AUTO_OPEN_UI = 'GUIEvent.CLOSE_AUTO_OPEN_UI' // 自动打开的窗口-关闭通知
    public static readonly SHOW_EMPTY_MASK = 'GUIEvent.SHOW_EMPTY_MASK'//UI空白遮罩
}

// 游戏事件
export class GameEvent {
    public static readonly LOGIN_ACCOUNT_SUCC = 'GameEvent.LOGIN_ACCOUNT_SUCC'; // 账号登录成功
    public static readonly LOGIN_ACCOUNT_FAIL = 'GameEvent.LOGIN_ACCOUNT_FAIL'; // 账号登录失败
    public static readonly LOGIN_USER_SUCC = 'GameEvent.LOGIN_USER_SUCC'; // 角色登录成功
    public static readonly LOGIN_USER_FAIL = 'GameEvent.LOGIN_USER_FAIL'; // 角色登录失败
    public static readonly UP_RED_DOT = 'GameEvent.UP_RED_DOT'; // 刷新红点
    public static readonly UP_ACT_RWD_OPT = 'GameEvent.UP_ACT_RWD_OPT'; // 杂项奖励更新
    public static readonly ON_CLICK = 'GameEvent.ON_CLICK'; // 点击事件
    public static readonly PAGE_CHANGED = 'GameEvent.PAGE_CHANGED'; // 页面变化,打开和关闭时均会触发
    public static readonly CLICK_SERVER_TAG = 'GameEvent.CLICK_SERVER_TAG' // 点击切换服务器标签
    public static readonly ON_REFRESH_COLOR = 'GameEvent.ON_REFRESH_COLOR' // 渐变色刷新
    public static readonly CLOSE_GZH = 'GameEvent.CLOSE_GZH' // 关闭公众号界面,登录按钮归位
    public static readonly WX_AUTH_SUCC = 'GameEvent.WX_AUTH_SUCC' // 用户授权成功(去掉所有授权按钮)
    public static readonly ON_SHOW_APP = 'GameEvent.ON_SHOW_APP' // 应用激活时触发(比如从广告回来,分享回来)
    public static readonly SHOW_TASK_NODE_ANI = "SHOW_TASK_NODE_ANI";    // BASE_POP.Battle类型界面的打开|隐藏时主界面上的快捷任务节点动画
    public static readonly UP_HD_RED = "GameEvent.UP_HD_RED";    // 更新活动红点
    public static readonly UP_GONGGAO_LIST = "GameEvent.UP_GONGGAO_LIST";    // 刷新公告列表
}
// 加载事件
export class LoadEvent {
    public static readonly LOAD_PROGRESS = "LoadEvent.LOAD_PROGRESS" // 加载页进度变化
    public static readonly LOAD_POLICY_AGREE = "LoadEvent.LOAD_POLICY_AGREE" // 同意或拒绝操作
    public static readonly LOAD_POLICY_TIP_AGREE = "LoadEvent.LOAD_POLICY_TIP_AGREE" // 首页同意或拒绝操作
    public static readonly LOAD_MESSAGE = "LoadEvent.LOAD_MESSAGE" // 显示加载页面的消息(测试用)
    public static readonly LOAD_ENTER = "LoadEvent.LOAD_ENTER" // 显示加载页面的消息(测试用)
    public static readonly SHOW_LOGIN_BTN = "LoadEvent.SHOW_LOGIN_BTN" // 显示登录按钮(SDK登录窗口消失时，可调用，显示登录按钮，点击再拉起SDK登录)
}
// 区服事件
export class ServerEvent {
    public static readonly SET_LOGIN_SID = "LoadEvent.SET_LOGIN_SID" // 设定登录游戏的区服ID
    public static readonly CLOSE_SERVER_VIEW = "LoadEvent.CLOSE_SERVER_VIEW" // 关闭服务器选择界面
}
// 时间回调事件
export class TimeEvent {
    public static readonly TIME_CD = "TimeEvent.TIME_CD"
    public static readonly FIGHT_TIME_CD = "TimeEvent.FIGHT_TIME_CD"
    public static readonly TIME_FRAME_CD = "TimeEvent.TIME_FRAME_CD"
}
// 窗口事件
export class WindowEvent {
    public static readonly POP_MSG = 'WindowEvent.POP_MSG';//文字提示
    public static readonly POP_ITEM = 'WindowEvent.POP_ITEM';//道具飘窗
    public static readonly SHOW_MSG_CUBE = 'WindowEvent.SHOW_MSG_CUBE';//文字提示(黑色底举行典礼弹窗)
    public static readonly POP_EP_ITEM = 'WindowEvent.POP_EP_ITEM';//属性变化飘窗
    public static readonly SHOW_SYS_DIALOG = 'WindowEvent.SHOW_SYS_DIALOG';//显示系统弹窗
    public static readonly CLOSE_UI = 'WindowEvent.CLOSE_UI';// 关闭界面
    public static readonly SHOW_DEBUG = 'WindowEvent.SHOW_DEBUG';//显示调试面板
}
//玩家信息事件
export class UserEvent {
    public static readonly UP_USER = 'UserEvent.UP_USER' // 角色数据更新
    public static readonly UP_USER_EPS = 'UserEvent.UP_USER_EPS' // 角色Eps数据更新
    public static readonly SHOW_HAND = 'UserEvent.SHOW_HAND' // 显示手势
    public static readonly HIDE_HAND = 'UserEvent.HIDE_HAND' // 隐藏手势
    public static readonly UP_LEVEL = 'UserEvent.UP_LEVEL' // 显示手势
    public static readonly SET_NAME_SUCC = 'UserEvent.SET_NAME_SUCC' // 修改名字成功
    public static readonly CHARGESUCC = 'UserEvent.CHARGESUCC' // 充值成功
    public static readonly SELECTHEAD = 'UserEvent.SELECTHEAD' // 选中头像
    public static readonly BTNTOUCHEND = 'UserEvent.BTNTOUCHEND'// 按钮点击结束
    public static readonly BTNTOUCHDISABLE = 'UserEvent.BTNTOUCHDISABLE'// 按钮点击事件移除
}
//平台事件
export class PlatEvent {
    public static readonly GOT_USER_INFO = "PvwEvent.GOT_USER_INFO" // 获取到了个人信息
    public static readonly ON_SCENE_CHANGED = "PvwEvent.ON_SCENE_CHANGED" // 场景值变化
}

//订阅事件
export class SubscribeEvent {
    public static readonly ON_SUBSCRIBE = "SubscribeEvent.ON_SUBSCRIBE" // 订阅消息开关变化时
}
// 头像事件
export class setHeadEvent {
    public static readonly SETHEAD_SELECT_HEAD = 'setHeadEvent.SETHEAD_SELECT_HEAD'; // 选择头像
    public static readonly SETHEAD_UPDATE_SELECT = 'setHeadEvent.SETHEAD_UPDATE_SELECT'; // 更新选择框
}
// 引导事件
export class GuideEvent {
    public static readonly GUIDE_EVENT = 'GuideEvent.GUIDE_EVENT';
    public static readonly GUIDE_SLOT = 'GuideEvent.GUIDE_SLOT'; //触发剧情引导
    public static readonly CLOSE_GUIDE = 'GuideEvent.CLOSE_GUIDE';
    public static readonly UPDATE_TXTMSG = 'GuideEvent.UPDATE_TXTMSG';
    public static readonly HIDE_HAND = 'GuideEvent.HIDE_HAND' // 隐藏手势
    public static readonly SHOW_HAND = 'GuideEvent.SHOW_HAND' // 显示手势
    public static readonly HANDMASK_SHOW = 'GuideEvent.HANDMASK_SHOW';
}

export class WeekGuideEvent {
    public static readonly GUIDE_EVENT = 'WeekGuideEvent.GUIDE_EVENT'; //触发弱引导手指
    public static readonly TRIGGER_GUIDE = 'WeekGuideEvent.TRIGGER_GUIDE'; //弱引导触发分发事件
}
// 主线事件
export class TaskMainEvent {
    public static readonly UP_INFO = "TaskMainEvent.UP_INFO" // 刷新所有数据
    public static readonly TASK_FINISH = "TaskMainEvent.TASK_FINISH" // 任务完成事件
    public static readonly TASk_POP_CLOSE = "TaskMainEvent.TASK_POP_CLOSE" // 关闭任务弹窗
    public static readonly TASk_RWD_SUC = "TaskMainEvent.TASk_RWD_SUC" // 主线任务领取成功
}
// 未解锁事件
export class UnlockEvent {
    public static readonly SHOW_UNLOCK_ANIM = 'UnlockEvent.SHOW_UNLOCK_ANIM';
    public static readonly UNLOCK_TYPE = 'UnlockEvent.UNLOCK_TYPE'; //功能开启
}
// 战力事件
export class ZhanLiEvent {
    public static readonly ZHANLI_UP_HOME_ZHANLI = 'ZHANLIEVENT.ZHANLI_UP_HOME_ZHANLI'; // 更新首页战力
    public static readonly ZHANLI_SHOW_ZHANLI_BANNER = 'ZHANLIEVENT.ZHANLI_SHOW_ZHANLI_BANNER'; // 显示战力横幅
}

// 道具事件
export class ItemEvent {
    public static readonly UP_ITEM = 'ItemEvent.UP_ITEM' // 背包更新
    public static readonly SHOW_ITEM_DETAIL = 'ItemEvent.SHOW_ITEM_DETAIL' // 背包更新
    public static readonly SELECT_ITEM_ID = 'ItemEvent.SELECT_ITEM_ID' // 选中背包自选道具
}

export class ShopEvent {
    public static readonly SHOP_DAOJU = 'ShopEvent.SHOP_DAOJU'//商店-道具
    public static readonly SHOP_GEM = 'ShopEvent.SHOP_GEM'//商店-钻石
    public static readonly SHOP_VOUCHER = 'ShopEvent.SHOP_VOUCHER'//商店-代金券
    public static readonly SWITCH_TAG = 'ShopEvent.SWITCH_TAG'//切换商城标签  0,1,2
}

export class ChatEvent {
    public static readonly UP_CHAT_INFO = "ChatEvent.UP_CHAT_INFO" // 更新聊天信息
    public static readonly UP_ZHULI_INFO = "ChatEvent.UP_ZHULI_INFO" // 更新助力信息
    public static readonly SWITCH_CHANNEL = "ChatEvent.SWITCH_CHANNEL" // 切换聊天频道
    public static readonly MSG_AT = "ChatEvent.MSG_AT" // @人
}

// 日常任务
export class DailyTaskEvent {
    public static readonly UP_INFO = "DailyTaskEvent.UP_INFO";
    public static readonly UP_SCORE = "DailyTaskEvent.UP_SCORE";
}

// fgui提示信息事件
export class FguiEvent {
    public static readonly SHOWTIPS = "FguiEvent_SHOWTIPS";
    public static readonly SHOWSIDETIPS = "FguiEvent_SHOWSIDETIPS";
}
