/** animation动画配置 */
export interface AnimationConfig {
    bundle: string,
    atlas: string,
    key: string,
    frames: number[],
    wrapMode: number,
    sample: number,
    anchor?: cc.Vec2,
    diffPos?: cc.Vec2
    isHeight?: boolean,
    heightScale?: number
}
/**
 * 资源配置表
 */
export class GameResUrl {
    /** buff动画资源配置 */
    public static BuffConfig: { [key: string]: AnimationConfig } = {
        effect_i_1: {//沉默
            bundle: "spriteAtlas",
            atlas: "chenmo",
            key: "buff_1-stand",
            frames: [0, 1, 2, 3],
            wrapMode: 2,
            sample: 5,
            isHeight: true,
            diffPos: cc.v2(68, -60)
        },
        // effect_i_2: {//回血
        //     bundle: "spriteAtlas",
        //     atlas: "zhenyi",
        //     key: "buff_4-stand",
        //     frames: [0, 1, 2, 3, 4, 5],
        //     wrapMode: 2,
        //     sample: 5
        // },
        effect_i_3: {//眩晕
            bundle: "spriteAtlas",
            atlas: "xuanyun",
            key: "buff_1-stand",
            frames: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14],
            wrapMode: 2,
            sample: 5,
            isHeight: true
        },
        effect_i_4: {//灼烧
            bundle: "spriteAtlas",
            atlas: "zhuoshao",
            key: "buff_1-stand",
            frames: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
            wrapMode: 2,
            sample: 10,
            heightScale: 0.5,
        },
        effect_i_5: {//冰冻
            bundle: "spriteAtlas",
            atlas: "bingdong",
            key: "buff_1-stand",
            frames: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
            wrapMode: 1,
            sample: 5,
            diffPos: cc.v2(0, 100)
        },
        effect_i_7: {//寒意
            bundle: "spriteAtlas",
            atlas: "hanyi",
            key: "buff_7-stand",
            frames: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14],
            wrapMode: 2,
            sample: 5,
            heightScale: 0.5
        },
        effect_i_8: {//真意
            bundle: "spriteAtlas",
            atlas: "zhenyi",
            key: "buff_1-stand",
            frames: [0, 1, 2, 3, 4, 5, 6, 7],
            wrapMode: 2,
            sample: 10,
            heightScale: 0.5
        },
        effect_i_9: {//护体
            bundle: "spriteAtlas",
            atlas: "huti",
            key: "buff_1-stand",
            frames: [0, 1, 2, 3, 4, 5],
            wrapMode: 2,
            sample: 5,
            diffPos: cc.v2(0, 100)
        }
    }

    /** 技能动画资源配置 */
    public static SkillAnimConfig: { [key: string]: AnimationConfig } = {
        skill_1: {
            bundle: "spriteAtlas",
            atlas: "skill_20003",
            key: "08_fashupugong",
            frames: [1, 2, 3, 4, 5, 6, 7, 8, 9],
            wrapMode: 1,
            sample: 20
        },

    }
}
