
/**基础道具,三个状态*/
export enum BaseItemType {
    /**点击无效果 */
    empty,
    /**点击显示道具详情 */
    detail,
    /**点击选中道具 */
    select
}

/**游戏平台枚举*/
export enum PlatFormDevType {
    // 默认
    default = "default",
    // 本地
    local = "local",
    /**Android设备 */
    android = "android",
    /**	iOS设备(包含 iPhone、iPad) */
    ios = "ios",
    // Windows设备
    windows = "windows",
    // macOS设备
    mac = "mac",
    // 微信小游戏开发者工具
    devtools = "devtools",

    androidH5 = "androidH5",
    iosH5 = "iosH5"
}

//道具背包类型
export enum ItemKind {
    money = 1, //货币 资产类
}

//背包使用类型
export enum BagUseType {
    empty = 0, // 不使用
    directUse = 1, // 直接使用
    randomUse = 2, // 随机使用
    selectUse = 3, // 自选使用
    synthesis = 4, // 道具合成
}

//玩家性别
export enum UserSex {
    woman = 0,
    man = 1
}

export enum TaskKind {
    DaGuai = "101",//在地图上击败{0}个怪物
    
}

export enum GuideType {
    new = "evt_guide_new",
}

export enum WeekGuideId {

}

export enum WeekGuideType {

}

// 弹窗
export interface ItemBaseCfg {
    id: string,
    name: string,
    icon: string,
    pinzhi: number,
    desc: string,
    type: string,
    detailType: string,
    from: number[],
    param: { "items"?: number[][], "nums"?: number[], "kv"?: { [key: string]: number }, "count"?: number },
    iconUrl?: string,
    level?: number,
    nengliang?: number,
    iconshowtype?: number,
    kind?: number
}

export enum InGame {
    no,     // 未登录
    loginAccount,  // 平台账号登录成功
    loginUser, // 角色(服务器)登录成功
    home,    // 到了主城
    // battle  // 战斗中
}

export enum Lang {
    lang_zh_cn = "cn",
    lang_zh_tw = "tw",
    lang_ja_jp = "jp",
    lang_ko_kr = "kr"
}

export enum AudioConst {
    empty = "0",
    // 音乐-所有的音乐资源,前缀为bgm
    bgm_base = "1", //普通背景音乐


    // 音效-所有的音效资源,前缀为effect
    effect_click = "1001", // 点击音效
}


// 战斗类型
export enum FightType {
    pve = "pve",
}

// 战斗类型背景
export enum FightTypeMap {
    pve = "pve"
}

export enum HelpType {
    empty = "",//空

}

/**头像框颜色*/
export enum HeadBgType {
    red = 0,
    blue = 1,
    purple = 2,
}

export class ConstItem {
    static gem = [1, 102] // 钻石
    static coin = [1, 101] // 金币
    static sp = [1, 103] // 体力
}

export enum PlatformType {
    local = "local", // local
    localbt = "localbt", // localbt
    wechat = "wechat", // 微信官方
    huo = "huo",    // 今鸿SDK
    // tiktok = "tiktok", // 
    ylWechat = "ylWechat", // 影流-微信平台
    ylTiktok = "ylTiktok", // 影流-抖音平台
    zhiling = "zhiling", // 智灵sdk(h5)
    zlWechat = "qiuwan", // 俅玩sdk
    bt = "bt", // 电魂变态版
    bth5 = "bth5", // quickH5变态版
    DHMini = "DHMini", // 电魂专属h5变态版
    DHWeChat = "DHWeChat", // 电魂专属变态版微信小游戏
    haituoH5 = "haituoH5", // 海拓H5
    haituoMini = "haituoMini", // 海拓小游戏
    wan17H5 = "wan17H5", // 17玩h5sdk
    taobao = "taobao", // 淘宝小游戏
    wan17 = "wan17",//17玩SDK
    wan17MiniGame = "wan17MiniGame",//17玩小游戏SDK(VIVO OPPO 小米)
    XXGame = "XXGame",//闲闲游戏SDK
    fenyou = "fenyou", // 奋游sdk(h5)
}

//功能开启的类型
export enum CheckOpenType {
    level = 1, //根据玩家等级开启
    task = 4, //根据任务数量开启
    zhenFa = 5,// 阵法抽取次数
    jingjie = 6,//境界等级
    zhenFaLv = 7,// 阵法等级
    clubOpen = 8,// 宗门开启时间
}

export enum OpenType {
    home = "0", // 主页
}

// 平台个人数据
export interface PlatUserInfo {
    nickName: string,
    avatarUrl: string
}

// 上报角色事件
export enum ReportRoleType {
    online = 1,      //角色登录
    create = 2,      //创建角色
    levelup = 3,     //提升等级
    offline = 4,     //角色退出
    other = 5,       //其他
    delete = 6,      //删除角色
    pay = 7,         //支付
    changeName = 8,         //改名
}
// 下单时传入的商品信息
export interface PayProductParam {
    price: number    // 价格
    productId: string   // 商品ID(不是订单ID,是配置ID)
    productName: string // 商品名称
    productDesc: string // 商品描述
}

// 红点类型
export enum RedDotType {
    
}
// 公告类型
export enum NoticeType {
    outside = "outside", // 登录页公告
    inside = "inside"   // 游戏内公告
}

// 隐私协议类型
export enum AgreementType {
    privacy = "privacy", // 隐私协议
    user = "user"  //用户协议
}

// 角色头像点击类型
export enum UserHeadType {
    empty = 0,  // 无操作
    detail = 1  // 显示角色信息
}

// 授权角色头像
export enum WechatUserBtnType {
    head = "head",  // 点击主页头像
    chat = "chat",  // 点击聊天输入框
    pvp = "pvp"  // 点击斗法挑战
}

// 订阅类型
export enum SubscribeType {
    boxLv = "1", //	阵法升级完成
}

// 错误码
export enum GameErrCode {
    errPlatInit = 10000, // sdk初始化失败
    errPlatLogin = 10010, // sdk登录失败
    errGamePlatLogin = 10020, // 游戏平台登录
    errGameLoginPlayer = 10030, // 用户登录
    errGameLoginUser = 100040, // 游戏角色登录
}

// 今日不再提醒key
export enum DayTipsKey {
}

// 每日首次红点类型
export enum DailyRedType {
}


// 战斗TeamId
export enum BattleTeamId {
    role1 = "10",  // 己方
    xianlv1 = "11",  //己方仙侣
    role2 = "20",  // 敌方
    xianlv2 = "21",  // 敌方仙侣
}


export enum RedUtilType {
    // 红点类型
}
