/// #pkgName FGUI包名
/// #prefabName ui预制名字
/// #viewName uiview名字
/// #UIName ui的名字，prefabName首字母转大写
/// 该脚本由模板创建，不可修改
/// created by chenwb 2024

import { FguiView } from "../../../../frameWork/fgui/mvc/FguiView";
import { FguiViewModel } from "../../../../frameWork/fgui/mvc/FguiViewModel";
import { IUIController } from "../../../../frameWork/fgui/mvc/IUIController";
import { ViewZOrder } from "../../../../data/const/ViewZOrder";
import { BattleMainCtrl } from "./BattleMainCtrl";
import { BattleMainVM } from "./BattleMainVM";

export class BattleMainView extends FguiView {
    /**
     * fgui的包名
     */
    protected static pkgName = "Battle";
    /**
     * fgui包内的UI名字
     */
    protected static prefabName = "BattleMain";
    /**
     * 类名，用于给UI命名
     */
    protected static viewName = "BattleMainView";

    /**
     * view层级
     */
    public zOrder: number = ViewZOrder.UI;

    protected createVM(panel: fgui.GComponent): FguiViewModel {
        return new BattleMainVM(panel);
    }
    protected CreateCtrl(): IUIController {
        return new BattleMainCtrl();
    }

}