/// #pkgName FGUI包名
/// #prefabName ui预制名字
/// #viewName uiview名字
/// #UIName ui的名字，prefabName首字母转大写
/// 该脚本由模板创建，不可修改
/// created by chenwb 2024

import { ViewZOrder } from "../../../../data/const/ViewZOrder";
import { FguiView } from "../../../../frameWork/fgui/mvc/FguiView";
import { FguiViewModel } from "../../../../frameWork/fgui/mvc/FguiViewModel";
import { IUIController } from "../../../../frameWork/fgui/mvc/IUIController";
import { DialogViewCtrl } from "./DialogViewCtrl";
import { DialogViewVM } from "./DialogViewVM";

export class DialogViewView extends FguiView {
    /**
     * fgui的包名
     */
    protected static pkgName = "Common";
    /**
     * fgui包内的UI名字
     */
    protected static prefabName = "DialogView";
    /**
     * 类名，用于给UI命名
     */
    protected static viewName = "DialogViewView";

    /**
     * view层级
     */
    public zOrder: number = ViewZOrder.UI;

    protected createVM(panel: fgui.GComponent): FguiViewModel {
        return new DialogViewVM(panel);
    }
    protected CreateCtrl(): IUIController {
        return new DialogViewCtrl();
    }

}