/// #pkgName FGUI包名
/// #prefabName ui预制名字
/// #viewName uiview名字
/// #UIName ui的名字，prefabName首字母转大写
/// 该脚本由模板创建，不可修改
/// created by chenwb 2024

import { ViewZOrder } from "../../../../data/const/ViewZOrder";
import { FguiView } from "../../../../frameWork/fgui/mvc/FguiView";
import { FguiViewModel } from "../../../../frameWork/fgui/mvc/FguiViewModel";
import { IUIController } from "../../../../frameWork/fgui/mvc/IUIController";
import { InputViewCtrl } from "./InputViewCtrl";
import { InputViewVM } from "./InputViewVM";

export class InputViewView extends FguiView {
    /**
     * fgui的包名
     */
    protected static pkgName = "Common";
    /**
     * fgui包内的UI名字
     */
    protected static prefabName = "InputView";
    /**
     * 类名，用于给UI命名
     */
    protected static viewName = "InputViewView";

    /**
     * view层级
     */
    public zOrder: number = ViewZOrder.UI;

    protected createVM(panel: fgui.GComponent): FguiViewModel {
        return new InputViewVM(panel);
    }
    protected CreateCtrl(): IUIController {
        return new InputViewCtrl();
    }

}