//更新/覆盖协议
export interface UpList<T> {
    a?: T; //整个覆盖 (默认 单独协议全部覆盖 , sevBackPro协议 第2级覆盖)
    u?: T; //递归更新
    d?: { [id: string]: boolean }; //删除
}
export type KindItem = number[]; //【总类，道具ID，数量】
export interface TypeMsg {
    type: number;
    msg: string;
    data: any;
}

//输出总列表
export interface SevBack {
    type?: SevBackType; //逻辑成败返回
    time?: number; //同步服务器时间
    other?: Other; //服务器其他同步数据
    win?: SC_Win; //提示模块

    qufuList?: { [id: string]: QufuInfo }; //区服列表
    orderList?: { [dc: string]: OrderList }; //充值档次配置
    //player
    playerInfo?: PlayInfo; //账号基础信息
    switch?: { [key: string]: any }; //开关
    noticeWais?: Notices[]; //游戏公告（登陆界面）
    notices?: Notices[]; //游戏公告(内部)
    diyChengHao?: { [key: string]: DiyChengHao }; //游戏公告(内部)

    // user
    weChatDY?: WeChatDyInfo[]; //微信订阅

    //模块
    userInfo?: UpList<UserInfo>; //角色基础信息
    mailList?: UpList<{ [id: string]: MailInfo }>; //邮件列表

    //洞天
    actDongTian?: UpList<ActDongTian>; //我的洞天信息
    factDongTian?: ActDongTian_fuser; //他人洞天信息
    nearsActDongTian?: UpList<{ [fuuid: string]: ActDongTian_fuser }>; //附近洞天列表
    enemyActDongTian?: UpList<{ [fuuid: string]: ActDongTian_fuser }>; //仇人洞天列表
    actDongTianLog?: UpList<{ [id: string]: ActDongTianLog }>; //洞天日志

    //act
    actChenghao?: UpList<ActChenghao>; //称号
    actDayRwd?: UpList<ActDayRwd>; //每日奖励
    actItem?: UpList<{ [key: string]: number }>; //道具模块
    actLuoFuXianYuG5S?: UpList<ActLuoFuXianYuG5S>; //罗浮仙域 - 获取成就5人
    actLuoFuXianYuG5?: UpList<ActLuoFuXianYuG5>; //罗浮仙域 - 获取成就5人
    actLuoFuXianYu?: UpList<ActLuoFuXianYu>; //罗浮仙域 - 个人信息
    sevLuoFuXianYu?: UpList<SevLuoFuXianYu>; //罗浮仙域 - 公共息
    actXiantu?: ActXiantu; //仙途
    actTaskMain?: ActTaskMain; //主线任务
    actDadiGuzi?: UpList<ActDadiGuzi>; //大帝古字
    actDaDiGuZiLinShi?: UpList<{ [lsid: string]: lishiGZInfo }>;
    actDaDiGuZiMfList?: UpList<{ [mfid: string]: mfInfo }>;
    actYiXiang?: UpList<ActYiXiang>; //异象
    actClub?: UpList<ActClub>; //世家
    actZhenfa?: UpList<ActZhenfa>; //法阵
    actZhenfaNew?: UpList<ActZhenfaNew>; //法阵(新)
    actZhenfaNewLs1?: UpList<{ [lsid: string]: ActZhenfaNewLs1 }>; //法阵(新)临时背包1
    actZhenfaNewLs2?: UpList<{ [xhid: string]: ActZhenfaNewLs2 }>; //法阵(新)临时背包2
    actZhenfaNewBag?: UpList<{ [xhid: string]: ActZhenfaNewBag }>; //法阵(新)背包
    actDouFaInfo?: UpList<ActDouFaInfo>; //斗法
    actDouFaLog?: UpList<{ [id: string]: ActDouFaLog }>; //斗法-日志
    sevDouFa?: UpList<SevDouFa>; //斗法保护列表
    actDiGongXunBao?: UpList<ActDiGongXunBao>; //地宫寻宝
    actZhangjie?: UpList<ActZhangjie>; //主界面章节
    actDiZi?: UpList<ActDiZi>; //弟子
    actDiZiList?: UpList<{ [dzid: string]: ActDiZi_Info }>;
    actDaoWen?: UpList<ActDaoWen>; //道纹
    actDaoWenList?: UpList<{ [iid: string]: DaoWen_Stone }>;
    actDaoyou?: UpList<ActDaoyou>; //道友
    actRed?: UpList<ActRed>; //红点
    //商店
    actShopItem?: ActShopItem; //商店 - 道具
    actShopCoin?: ActShopCoin; //商店 - 金币
    actShopDiaMond?: ActShopDiaMond; //商店 - 钻石
    actShopJinTiao?: ActShopJinTiao; //商店 - 金条
    actShopPata?: ActShopPata; //商店 - 爬塔
    actShopClub?: ActShopClub; //商店 - 世家
    actShopXiezhu?: ActShopXiezhu; //商店 - 组队协助
    //爬塔
    actPata?: UpList<ActPata>;
    //秘境
    actMijing?: UpList<ActMijing>;
    // 宗门
    actZongMen?: UpList<ActZongMen>;
    // 法则
    actFaze?: UpList<ActFaze>;

    // 仙域
    actXianYu?: UpList<ActXianYu>;

    fusers?: FUserInfo[]; //他人基础信息
    fuser?: FUserInfo; //他人基础信息
    fuserList?: UpList<{ [id: string]: FUserInfo }>; //他人基础信息

    sevZongMen?: SevZongMen; //宗门

    // act用
    kuaList?: string[]; //跨服列表
    // hd用
    hdKuaList?: { [hdcid: string]: string[] }; //跨服列表

    paoma?: UpList<{ [id: string]: Paoma }>; //跑马灯

    // 出师门徒
    actZongMenLs1?: UpList<{ [id: string]: mentu }>; // 单身列表
    actZongMenLs2?: UpList<{ [id: string]: mentu }>; // 已婚列表

    //境界
    actJingJie?: UpList<ActJingJie>;
    //兽灵
    actShouLing?: UpList<ActShouLing>;
    actShouLingList?: UpList<{ [gzid: string]: ActShouLing_ListOne }>;
    //主角皮肤
    actPifu?: UpList<ActPifu>;
    //新手引导
    actGuide?: UpList<ActGuide>;
    //彩蛋
    actCaiDan?: UpList<ActCaiDan>;
    //日常任务
    actDailyTask?: UpList<ActDailyTask>;

    //天碑林
    actLingMai?: UpList<ActLingMai>;
    actLingMaiLog?: UpList<{ [id: string]: ActLingMaiLog }>; //灵脉-日志
    sevDuiHuan?: UpList<SevDuiHuan>; //灵脉兑换道具
    //太初古矿
    actGuKuang?: UpList<ActGuKuang>;
    //功能开启
    actKaiQi?: UpList<{ [id: string]: number }>; //开启id,开启时间
    actEps?: UpList<ActEps>;
    boxDrops?: { [kind_id: string]: number }; //宝箱每日已掉落

    //药田
    actYaoTian?: UpList<ActYaoTian>; //我的药田信息
    factYaoTian?: ActYaoTian_fuser; //他人药田信息
    nearsActYaoTian?: UpList<{ [fuuid: string]: ActYaoTian_fuser }>; //附近药田列表
    enemyActYaoTian?: UpList<{ [fuuid: string]: ActYaoTian_fuser }>; //仇人药田列表
    actYaoTianLog?: UpList<{ [id: string]: ActYaoTianLog }>; //药田日志
    actYaoTianEps?: UpList<ActYaoTianEps>; //药田吃药增加属性

    //组队
    actZdHgjd?: UpList<ActZdHgjd>; //组队_荒古禁地
    actZdYdfz?: UpList<ActZdYdfz>; //组队_妖帝坟冢
    actZdQtxd?: UpList<ActZdQtxd>; //组队_青铜仙殿

    //订阅
    actDingYue?: UpList<ActDingYue>; //订阅
    actPvd?: UpList<ActPvd>; //每日挑战

    // 老玩家回归
    actUserBack?: UpList<ActUserBack>; //老用户回归
    // 奖励找回
    actRwdBack?: UpList<ActRwdBack>; //奖励找回

    hdJieQiData?: { [hdcid: string]: UpList<HdJieQiDataOut> }; //活动 -节气活动永久的数据
    //hd
    hdChongBang_cfg?: { [hdcid: string]: UpList<HdCfg<HdChongBangData>> }; //活动 -冲榜配置
    hdChongBang?: { [hdcid: string]: UpList<HdChongBangOut> }; //活动 -冲榜个人信息
    hdKaifu_cfg?: { [hdcid: string]: UpList<HdCfg<HdKaifuData>> }; //活动 - 开服庆典配置
    hdKaifu?: { [hdcid: string]: UpList<HdKaifugOut> }; //活动 - 开服庆典个人信息
    hdHuaLian_cfg?: { [hdcid: string]: UpList<HdCfg<HdHuaLianData>> }; //活动 -化莲配置
    hdHuaLian?: { [hdcid: string]: UpList<HdHuaLianOut> }; //活动 -	化莲
    hdJiYuan_cfg?: { [hdcid: string]: UpList<HdCfg<HdJiYuanData>> }; //活动 -新版机缘配置
    hdJiYuan?: { [hdcid: string]: UpList<HdJiYuanOut> }; //活动 -新版机缘
    hdLunHui_cfg?: { [hdcid: string]: UpList<HdCfg<HdLunHuiData>> }; //活动 -天道轮回配置
    hdLunHui?: { [hdcid: string]: UpList<HdLunHuiOut> }; //活动 -天道轮回
    hdYunShi_cfg?: { [hdcid: string]: UpList<HdCfg<HdYunShiData>> }; //活动-运势玩法配置
    hdYunShi?: { [hdcid: string]: UpList<HdYunShiOut> }; //活动-运势玩法
    hdNewHand_cfg?: { [hdcid: string]: UpList<HdCfg<HdNewHandData>> }; //活动-新手礼包配置
    hdNewHand?: { [hdcid: string]: UpList<HdNewHandOut> }; //活动-新手礼包
    hdNewHand2_cfg?: { [hdcid: string]: UpList<HdCfg<HdNewHand2Data>> }; //活动-新手礼包配置
    hdNewHand2?: { [hdcid: string]: UpList<HdNewHand2Out> }; //活动-新手礼包
    hdSpeGift_cfg?: { [hdcid: string]: UpList<HdCfg<HdSpeGiftData>> }; //活动 -特惠礼包
    hdSpeGift?: { [hdcid: string]: UpList<HdSpeGiftOut> }; //活动 -特惠礼包计费点
    hdSignGift_cfg?: { [hdcid: string]: UpList<HdCfg<HdSignGiftData>> }; //活动 -签到礼包
    hdSignGift?: { [hdcid: string]: UpList<HdSignGiftOut> }; //活动 -签到礼包
    hdChargeDays_cfg?: { [hdcid: string]: UpList<HdCfg<HdChargeDaysData>> }; //活动 -累天充值
    hdChargeDays?: { [hdcid: string]: UpList<HdChargeDaysOut> }; //活动 -累天充值
    hdChargeTotal_cfg?: { [hdcid: string]: UpList<HdCfg<HdChargeTotalData>> }; //活动 -累计充值
    hdChargeTotal?: { [hdcid: string]: UpList<HdChargeTotalOut> }; //活动 -累计充值
    hdFund_cfg?: { [hdcid: string]: UpList<HdCfg<HdFundData>> }; //活动 -基金
    hdFund?: { [hdcid: string]: UpList<HdFundOut> }; //活动 -基金
    hdDayTeJia_cfg?: { [hdcid: string]: UpList<HdCfg<HdDayTeJiaData>> }; //活动 -特惠
    hdDayTeJia?: { [hdcid: string]: UpList<HdDayTeJiaOut> }; //活动 -特惠
    hdDayTeHui_cfg?: { [hdcid: string]: UpList<HdCfg<HdDayTeHuiData>> }; //活动 -特价
    hdDayTeHui?: { [hdcid: string]: UpList<HdDayTeHuiOut> }; //活动 -特价
    hdPriCard_cfg?: { [hdcid: string]: UpList<HdCfg<HdPriCardData>> }; //活动 -特权卡
    hdPriCard?: { [hdcid: string]: UpList<HdPriCardOut> }; //活动 -特权卡
    hdTimeBen_cfg?: { [hdcid: string]: UpList<HdCfg<HdTimeBenData>> }; //活动-限时礼包配置
    hdTimeBen?: { [hdcid: string]: UpList<HdTimeBenOut> }; //活动-限时礼包
    hdDiZi_cfg?: { [hdcid: string]: UpList<HdCfg<HdDiZiData>> }; //活动-限时礼包配置
    hdDiZi?: { [hdcid: string]: UpList<HdDiZiOut> }; //活动-限时礼包
    hdDaoWen_cfg?: { [hdcid: string]: UpList<HdCfg<HdDaoWenData>> }; //活动-道纹活动配置
    hdDaoWen?: { [hdcid: string]: UpList<HdDaoWenOut> }; //活动-道纹活动
    hdShouLing_cfg?: { [hdcid: string]: UpList<HdCfg<HdShouLingData>> }; //活动-兽灵玩法配置
    hdShouLing?: { [hdcid: string]: UpList<HdShouLingOut> }; //活动-兽灵玩法
    hdShuFa_cfg?: { [hdcid: string]: UpList<HdCfg<HdShuFaData>> }; //活动 -术法配置
    hdShuFa?: { [hdcid: string]: UpList<HdShuFaOut> }; //活动 -	术法
    hdNewYearPray_cfg?: { [hdcid: string]: UpList<HdCfg<HdNewYearPrayData>> }; //活动 -新春祈福
    hdNewYearPray?: { [hdcid: string]: UpList<HdNewYearPrayOut> }; //活动 -	新春祈福
    hdJieQi_cfg?: { [hdcid: string]: UpList<HdCfg<HdJieQiData>> }; //活动 -节气
    hdJieQi?: { [hdcid: string]: UpList<HdJieQiOut> }; //活动 -	节气
    hdWanZuParty?: { [hdcid: string]: UpList<HdWanZuPartyOut> }; //活动 -万族盛会
    hdWanZuParty_cfg?: { [hdcid: string]: UpList<HdCfg<HdWanZuPartyData>> }; //活动 -万族盛会
    hdDouLuo_cfg?: { [hdcid: string]: UpList<HdCfg<HdDouLuoData>> }; //活动 -绝仙台
    hdDouLuo?: { [hdcid: string]: UpList<HdDouLuoOut> }; //活动 -绝仙台
    hdDouLuoLog_cfg?: { [hdcid: string]: UpList<HdCfg<HdDouLuoLogData>> };
    hdDouLuoLog?: { [hdcid: string]: UpList<{ [iid: string]: HdDouLuoLogOut }> };
    hdClubSameName_cfg?: { [hdcid: string]: UpList<HdCfg<HdClubSameNameData>> }; //活动 -世家同名
    hdClubSameName?: { [hdcid: string]: UpList<HdClubSameNameOut> }; //活动 -世家同名
    hdClubCz_cfg?: { [hdcid: string]: UpList<HdCfg<HdClubCzData>> }; //活动 -世家充值
    hdClubCz?: { [hdcid: string]: UpList<HdCfg<HdClubCzOut>> }; //活动 -世家充值
    hdFeiNiao_cfg?: { [hdcid: string]: UpList<HdCfg<HdFeiNiaoData>> }; //活动 -飞鸟
    hdFeiNiao?: { [hdcid: string]: UpList<HdFeiNiaoOut> }; //活动 -飞鸟
    hdShangHua_cfg?: { [hdcid: string]: UpList<HdCfg<HdShangHuaData>> }; //活动 -赏花觅宝
    hdShangHua?: { [hdcid: string]: UpList<HdShangHuaOut> }; //活动 -赏花觅宝
    hdZhangjiePush_cfg?: { [hdcid: string]: UpList<HdCfg<HdZhangjiePushData>> }; //活动 -赏花觅宝
    hdZhangjiePush?: { [hdcid: string]: UpList<HdZhangjiePushOut> }; //活动 -赏花觅宝
    hdClubDuoWei_cfg?: { [hdcid: string]: UpList<HdClubDuoWeiData> }; //活动 -仙盟夺位战
    hdClubDuoWei?: { [hdcid: string]: UpList<HdClubDuoWeiOut> }; //活动 -仙盟夺位战
    hdXianLuVying_cfg?: { [hdcid: string]: UpList<HdCfg<HdXianLuVyingData>> }; //活动 -仙路争锋
    hdXianLuVying?: { [hdcid: string]: UpList<HdXianLuVyingOut> }; //活动 -仙路争锋
    hdXianLuShop_cfg?: { [hdcid: string]: UpList<HdCfg<HdXianLuShopData>> }; //活动 -仙路争锋
    hdXianLuShop?: { [hdcid: string]: UpList<HdXianLuShopOut> }; //活动 -仙路争锋
    hdHuoBanGift_cfg?: { [hdcid: string]: UpList<HdCfg<HdHuoBanGiftData>> }; //活动 -伙伴礼包
    hdHuoBanGift?: { [hdcid: string]: UpList<HdHuoBanGiftOut> }; //活动 -伙伴礼包
    hdHuoBanUp_cfg?: { [hdcid: string]: UpList<HdCfg<HdHuoBanUpData>> }; //活动 -伙伴概率提升
    hdHuoBanUp?: { [hdcid: string]: UpList<HdHuoBanUpOut> }; //活动 -伙伴概率提升
    hdXuanTianDouFa?: { [hdcid: string]: UpList<HdXuanTianDouFaOut> }; //活动 玄天斗法
    hdXuanTianDouFa_cfg?: { [hdcid: string]: UpList<HdCfg<HdXuanTianDouFaData>> }; //活动 -玄天斗法配置
    hdBanBenFuLi?: { [hdcid: string]: UpList<HdBanBenFuLiOut> }; //活动 版本福利
    hdBanBenFuLi_cfg?: { [hdcid: string]: UpList<HdCfg<HdBanBenFuLiData>> }; //活动 -版本福利配置
    hdHeFu?: { [hdcid: string]: UpList<HdHeFuOut> }; //活动 合服活动
    hdHeFu_cfg?: { [hdcid: string]: UpList<HdCfg<HdHeFuData>> }; //活动 -合服活动配置
    hdJiuXiaoTianShu?: { [hdcid: string]: UpList<HdJiuXiaoTianShuOut> }; //活动 九霄天枢
    hdJiuXiaoTianShu_cfg?: { [hdcid: string]: UpList<HdCfg<HdJiuXiaoTianShuData>> }; //活动 -九霄天枢配置
    hdXianQiongZhiDian?: { [hdcid: string]: UpList<HdXianQiongZhiDianOut> }; //活动 仙穹之巅
    hdXianQiongZhiDian_cfg?: { [hdcid: string]: UpList<HdCfg<HdXianQiongZhiDianData>> }; //活动 -仙穹之巅配置
    hdXianQiongZhiDianLog?: { [hdcid: string]: UpList<{ [iid: string]: XianQiongZhiDianFightInfo }> }; //活动 仙穹之巅
    hdXianQiongZhiDianFuserList?: UpList<{ [id: string]: FUserInfo }>; //仙穹之巅他人基础信息
    hdXiongShou?: { [hdcid: string]: UpList<HdXiongShouOut> }; //活动 凶兽入侵
    hdXiongShou_cfg?: { [hdcid: string]: UpList<HdCfg<HdXiongShouData>> }; //活动 -凶兽入侵配置
    hdXiongShouLog?: { [hdcid: string]: UpList<{ [iid: string]: XiongShouLogInfo }> }; //活动 凶兽入侵日志

    hdOnLine_cfg?: { [hdcid: string]: UpList<HdCfg<HdOnLineData>> }; //活动 -在线福利
    hdOnLine?: { [hdcid: string]: UpList<HdOnLineOut> }; //活动 -在线福利
    hdShangXianFuLi_cfg?: { [hdcid: string]: UpList<HdCfg<HdShangXianFuLiData>> }; //活动 -上线福利
    hdClubPk_cfg?: { [hdcid: string]: UpList<HdCfg<HdClubPkData>> }; //活动 -仙盟混战
    hdClubPk?: { [hdcid: string]: UpList<HdClubPkOut> }; //活动 -仙盟混战
    hdActPre_cfg?: { [hdcid: string]: UpList<HdCfg<HdActPreData>> }; //活动 -活动预告
    hdActPre?: { [hdcid: string]: UpList<HdActPreOut> }; //活动 -活动预告
    hdXiuWeiShenZao_cfg?: { [hdcid: string]: UpList<HdCfg<HdXiuWeiShenZaoData>> }; //活动 -修为深造
    hdXiuWeiShenZao?: { [hdcid: string]: UpList<HdXiuWeiShenZaoOut> }; //活动 -修为深造
    hdTianDeng_cfg?: { [hdcid: string]: UpList<HdCfg<HdTianDengData>> }; //活动 -天灯祈愿
    hdTianDeng?: { [hdcid: string]: UpList<HdTianDengOut> }; //活动 -天灯祈愿

    //rds
    rdsDouFa?: UpList<{ [rid: string]: RdsFUserInfo }>; //排行榜 - 斗法
    rdsDouFaMy?: rdsMyInfo; //排行榜 - 斗法
    rdsHdChongBang?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜 - 冲榜
    rdsHdChongBangMy?: { [hdcid: string]: rdsMyInfo }; //排行榜 - 冲榜
    rdsPata?: UpList<{ [rid: string]: RdsFUserInfo }>; //排行榜 - 爬塔
    rdsPataMy?: rdsMyInfo; //排行榜 - 爬塔
    rdsClubBoss?: UpList<{ [rid: string]: RdsFUserInfo }>; //排行榜 - ClubBoss
    rdsClubBossMy?: rdsMyInfo; //排行榜 - ClubBoss
    rdsClubList?: UpList<{ [rid: string]: RdsClubInfo }>; //排行榜 - Club
    rdsClubListMy?: RdsClubInfo; //排行榜 - Club
    rdsZongMen?: UpList<{ [rid: string]: RdsFUserInfo }>; //排行榜 - 宗门门徒
    rdsZongMenMy?: rdsMyInfo; //排行榜 - 宗门门徒
    rdsDouLuo?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜 - 绝仙台
    rdsDouLuoMy?: { [hdcid: string]: rdsMyInfo }; //排行榜 我的信息
    rdsHdDaoWen?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜 - 道纹活动
    rdsHdDaoWenMy?: { [hdcid: string]: rdsMyInfo }; //我的排名 - 道纹活动
    rdsHdDiZi?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜 - 道纹活动
    rdsHdDiZiMy?: { [hdcid: string]: rdsMyInfo }; //我的排名 - 道纹活动
    rdsLingMai?: UpList<{ [rid: string]: RdsFUserInfo }>; //排行榜-灵脉
    rdsLingMaiMy?: rdsMyInfo; //排行榜 - 灵脉 我的排名
    rdsPvd?: UpList<{ [rid: string]: RdsFUserInfo }>; //排行榜-每日挑战
    rdsPvdMy?: rdsMyInfo; //排行榜 - 每日挑战 我的排名
    rdsHdShuFa?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜-术法活动
    rdsHdShuFaMy?: UpList<{ [hdcid: string]: rdsMyInfo }>; //排行榜 - 术法活动 我的排名
    rdsHdXianLuVying?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜-术法活动
    rdsHdXianLuVyingMy?: UpList<{ [hdcid: string]: rdsMyInfo }>; //排行榜 - 术法活动 我的排名
    rdsHdJieQi?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜-节气活动
    rdsHdJieQiMy?: UpList<{ [hdcid: string]: rdsMyInfo }>; //排行榜 - 节气活动 我的排名
    rdsClubQuestList?: UpList<{ [rid: string]: RdsClubInfo }>; //排行榜 - 世家悬赏
    rdsClubQuestListMy?: RdsClubInfo; //排行榜 - 世家悬赏
    rdsZdQtxd?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜 - 青铜仙殿
    rdsZdQtxdMy?: { [hdcid: string]: rdsMyInfo }; //我的排名 - 青铜仙殿
    rdsYdfzHit?: UpList<{ [rid: string]: { rid: number; hit: number; name: string; zdId: number } }>; //排行榜 - 妖帝坟冢伤害排名
    rdsYdfzHitMy?: { rid: number; hit: number }; //我的排名 - 妖帝坟冢伤害排名
    rdsHdWanZuParty?: { [hdcid: string]: UpList<{ [rid: string]: RdsFUserInfo }> }; //排行榜 - 万族盛会
    rdsHdWanZuPartyMy?: { [hdcid: string]: rdsMyInfo }; //我的排名 - 万族盛会
    rdsHdWanZuPartyClub?: { [hdcid: string]: UpList<{ [rid: string]: RdsClubInfo }> }; //排行榜 - 万族盛会
    rdsHdWanZuPartyClubMy?: { [hdcid: string]: RdsClubInfo }; //我的排名 - 万族盛会


    //sev
    club?: UpList<ClubInfo>;
    clubYiJia?: UpList<ClubYiJia>; //世家 - 云游商人
    actAdokSev?: UpList<actAdokSev>; //世家红点
    fclubs?: Fclub[];

    actClubMiShu?: UpList<ActClubMiShu>; //世家秘术
    actClubShengB?: UpList<ActClubShengB>; //世家圣兵
    actClubQuest?: UpList<ActClubQuest>; //世家圣兵

    sevClubQuestBoss?: UpList<{ [uuid: string]: ClubQuestBoss }>; //世家悬赏boss
    sevClubQuest?: UpList<{ [uuid: string]: ClubQuestTask }>; //世家悬赏boss
    sevClubQuestLog?: UpList<SevClubQuestLog>; //世家悬赏boss

    chat?: Chat; //聊天模块
    zhuli?: UpList<Zhuli>; //助力

    zudui?: UpList<{ [iid: string]: Zudui }>; //组队
    zuduiEvent?: ZuduiEvent[]; //组队事件
    sevHuangGuJinDi?: UpList<SevHuangGuJinDi>; //荒古禁地
    sevYaoDiFenZhong?: UpList<SevYaoDiFenZhong>; //妖帝坟冢
    sevYaoDiFenZhongBoss?: UpList<{ [iid: string]: SevYaoDiFenZhongBoss }>; //妖帝坟冢
    sevQingTongXianDian?: UpList<SevQingTongXianDian>; //青铜仙殿
    sevXuanTianDouFaLogsOut?: UpList<SevXuanTianDouFaLogsOut>; //玄天斗法日志
    sevXuanTianDouFaOtherGroupOut?: UpList<SevXuanTianDouFaOtherGroupOut>; //玄天斗法其他组信息
    sevHeFuDaoYouZhuLiRecordsOut?: UpList<SevHeFuDaoYouZhuLiRecordsOut>; //合服活动助力记录输出
    sevShenZangJieJie?: UpList<SevHeFuShenZangJieJieOut>; //合服活动-神藏结界记录  
    sevClubPkMy?: UpList<SevClubPkMy>  //仙盟混战 我仙盟信息
    sevClubPkLog?: UpList<SevClubPkLog>  //战报-公告
    sevTianDeng?: UpList<SevTianDengOut>  //天灯祈愿

    //充值
    order10Id?: string; //人民币充值订单ID
    order10cs?: string; //计费点
    order10Back?: any; //返回给SDK方（后端用）
    order11Id?: string; //广告订单ID
    order11cs?: string; //广告订单Key

    //查看他人所有基础信息
    fuserAll?: FUserAll;
    //查看其他世家信息
    platBack?: PlatBack; //平台返回

    fightBack?: OverBack; //战斗日志
    fightBackEnd?: OverBackEnd<any>; //战斗日志
    fightBackMx?: fightBackMx; //战斗日志明细
    fightBofang?: ActFightStart; //战斗重播
    idCardInfo?: IDCardInfo; // 实名认证
    actFaBao?: UpList<ActFaBao>; //法宝

    // 仙域
    sevXianYu?: UpList<string[]>;
    sevXianYuLog?: UpList<{
        fuser: FUserInfo;
        // 入住时间
        time: number;
    }[]>;
    sevXianYuRwd?: UpList<SevXianYuRwd>;


    // 已经结好的门徒列表
    marriedList?: { [id: string]: mentu }[];
    randomName?: string; //随机名称

    //公会退出 解散 前置检测
    clickWins?: ClickWin[]

    //淘宝相关信息
    actTaoBao?: UpList<ActTaoBao>;
}

export enum SevBackType {
    fail = 0, //业务逻辑失败
    success = 1, //业务逻辑成功 (只有这个成功 才会写入缓存数据)
    wu = 4, //无效（重复）请求
}

//排行业务分类
export enum RdsUser {
    rdsHdChongBang = "rdsHdChongBang", //冲榜
    rdsHdXianQiongZhiDianTop = "rdsHdXianQiongZhiDianTop", //仙穹之巅 个人排行 用于展示
    rdsHdXianQiongZhiDian = "rdsHdXianQiongZhiDian", //仙穹之巅 个人排行 用于发奖励
    rdsHdXiongShou = "rdsHdXiongShou", //凶兽个人榜
    rdsDouLuo = "rdsDouLuo", //绝仙台日榜
    rdsLuoFuXianYu = "rdsLuoFuXianYu", //罗浮仙域
    dongtian = "dongtian", //洞天邻居榜 //洞天等级
    rdsHdDiZi = "rdsHdDiZi", //弟子活动排行
    rdsHdShouLing = "rdsHdShouLing", //兽灵活动排行
    rdsHdDaoWen = "rdsHdDaoWen", //道纹活动排行
    rdsDouFa = "rdsDouFa", //斗法
    Pata = "rdsPata", //试炼周排行
    rdsClubList = "rdsClubList", //世家排行
    rdsClubQuestList = "rdsClubQuestList", //世家悬赏排行
    rdsClubQuestListLaskWeek = "rdsClubQuestListLaskWeek", //世家悬赏boss排行-上周
    rdsClubBoss = "rdsClubBoss", //clubBoss排行
    rdsHdNewYearPray = "rdsHdNewYearPray", //新春祈福活动排行
    rdsDiGongXunBao = "rdsDiGongXunBao", //地宫寻宝排行
    rdsLingMai = "rdsLingMai", //灵脉排行榜
    rdsYaoTian = "rdsYaoTian", //药田邻居榜
    rdsZongMen = "rdsZongMen", //宗门-门徒排行榜
    rdsPvd = "rdsPvd", //每日挑战
    rdsHdShuFa = "rdsHdShuFa", //术法活动
    rdsHdXianLuVying = "rdsHdXianLuVying", //仙路争锋活动
    rdsZdQtxd = "rdsZdQtxd", //组队-青铜仙殿
    rdsYdfzHit = "rdsYdfzHit", //组队-妖帝坟冢伤害排行
    rdsHdXuanTianDouFa = "rdsHdXuanTianDouFa", //玄天斗法
    rdsHdJieQi = "rdsHdJieQi", //节气活动
    rdsHdWanZuParty = "rdsHdWanZuParty", //万族盛会
    rdsHdWanZuPartyClub = "rdsHdWanZuPartyClub", //万族盛会-club排行
    rdsHdClubPkUser = "rdsHdClubPkUser", // 仙盟混战（个人）
}
//排行业务分类 club
export enum RdsClub {
    rdsClubXiongShou = "rdsClubXiongShou", //凶兽入侵
    rdsClubQunXiong = "rdsClubQunXiong", // 群雄逐鹿
    rdsHdClubPk = "rdsHdClubPk", // 仙盟混战(工会)
}
export interface Notices {
    type: number; //公告类型
    title: string; //这里是公告标题
    content: string; //这里是公告内容
}

export interface DiyChengHao {
    name: string; //称号名称
    chid: string; //称号表ID
}
//提示模块
export interface SC_Win {
    msg?: string[]; //文字提示
    items?: KindItem[]; //道具弹窗提示
    msgOut?: string; //文字提示
    msgClubOut?: string; //文字提示
    yiXiangExp?: number; //异象升级加的经验点
    shoulingXh?: string; //兽灵驯化成功弹窗
    dongtianQiPao?: string; //洞天拉车气泡
    dongtian?: KindItem[]; //拉车奖励弹窗
    dongtianAdd?: KindItem[]; //拉车翻倍奖励提示
    hdDaoWen?: string; //道纹活动抽奖结果提示
    fabaoItems?: KindItem[]; //法宝获得提示 [[总类，道具ID，数量，转换0/1，转换后总类，道具ID，数量]]
    daoyouFavor?: number; //道友好感度增加
    daoyouItem?: KindItem[]; //道友奖励获得
    tupo?: KindItem[]; //突破任务奖励一键领取获得
    hdDiZiRound?: string[]; //弟子活动抽奖的道具id
    zhenfaNew?: KindItem[]; //阵法设置方案 获取道具弹窗
    hdShangHua?: {
        type: string; //1 dajiang  2putong
        dc: string;
        item: KindItem;
    }[]; //抽中的奖励档次列表
    mentuGetMmarriedSuccess?: string; //门徒结好成功
    mentuGetSuccess?: string; //门徒选拔成功
    daowen?: number[][]; //道纹道具获得弹窗
    zhaomu?: number[][]; //弟子招募弹窗
    shufa?: KindItem; //术法抽取额外给的道具
    zfZhaomu?: KindItem[]; //阵法招募
    shouLingChouqu?: {
        pinzhi: string,
        times: number,
        slids: string[]
    }; //兽灵抽取

    // 节气活动通关
    jieQiPass?: {
        dajiang: number[][],
        putong: number[][]
    };
    // 一键抽取的结果
    jieQiChouPlus?: {
        // 本次一件抽取的格子id
        ids: string[]
        // 如果出了大奖,大奖的格子id。没有为空
        dajiangId: string
        // 如果出了大奖。没有为空
        dajiang: number[][],
        // 所有除了大奖的奖励放在这里
        putong: number[][]
        // 本次抽取消耗的总道具
        subItem: number[]
    };
    //合服活动抽取奖励下标
    hefuChouQu?: number[]
    //合服活动抽取奖励
    hefuChouQuItems?: KindItem[],
    // 祈福奖励
    qifuRwd?: number[][],
    //弟子皮肤
    dzSkin?: string,
    // 购买了新手礼包
    newHand2?: string
    // 法则
    faze?: string,
}

export interface Other {
    new0: number; //今日0点（服务器时间）
    week0: number; //每周一 0点（服务器时间）
    kfdays: number; //开服天数
}

//区服列表
export interface QufuInfo {
    sid: string; //区服ID
    name: string; //名字
    sName: string; //所属大区名称
    openAt: number; //开服时间
    status: string; //状态 1新服 2拥挤 3爆满 4维护
    heid: string; //合服ID
    suofu: number; //锁服
}
export interface OrderList {
    rmb: number;
    money: number;
    desc: string;
    iid: string;
    daibi: number;
}


export interface WeChatDyInfo {
    id: string; //订阅ID
    type: string;
    tmplId: string;
}

//账号基础信息
export interface PlayInfo {
    uid: string; //uid
    sid: string; //最后一次登陆区服
    list: { [id: string]: PlayInfoUser }; //每个区最多一个角色
    token: string; //账号登陆验证码
}

export interface PlayInfoUser {
    uuid: string; //角色ID
    name: string;
    level: number; //等级
    lastlogin: number; //最后一次登录时间
}

//查看他人角色基础信息
export interface FUserInfo {
    uid: string; //账号ID
    uuid: string; //角色ID
    sid: string; //所属分区
    name: string;
    head: string; //头像
    wxhead: string; //微信头像
    sex: number; //0女1男
    level: number; //等级
    jingjieId: string; //境界ID
    lastlogin: number; //最后一次登录时间
    power: number;
    chenghao: string[]; //称号
    yxid: string; //异象
    hxid?: string; //化形id , 前端这个字段要判空
    shouling?: string;
    skin?: string; //皮肤
    clubName?: string; //世家名称
    shufa?: [string, number][]; //术法
}

export interface FUserPk3 extends FUserInfo {
    add_per: number //场次积分加成
    add_jf: number  //加积分
}


//查询角色详细信息的时候用到 其他用 FUserInfo
export interface FUserAll extends FUserInfo {
    sevBack?: SevBack;
}

export interface RdsFUserInfo extends FUserInfo {
    rid: number; //排名
    score: number; //分数
    sevBack?: SevBack; //前三名才下发
    mentuId?: string; //门徒ID
    mentu?: mentu; //门徒信息
    // 活动-万族盛会
    school?: {
        id: string;
        score: number;
    }[]
}

export interface rdsMyInfo {
    rid: number; //排名
    score: number; //分数
    mentuId?: string; //门徒ID
}

//角色基础信息
export interface UserInfo {
    uid: string; //账号ID
    uuid: string; //角色ID
    sid: string; //所属分区
    name: string;
    head: string; //头像
    wxhead: string; //微信头像
    sex: number; //0女1男
    level: number; //等级
    jingjieId: string; //境界ID
    regtime: number; //注册时间
    loginTime: number; //登录时间
    lastlogin: number; //最后一次登录时间
    lineTime: number; //在线时长（s）
    token: string; //验证是否已经登陆
    iscz: number; //只存储累计充值rmb
    power: number; //战力
    setNameNum: number; //改名次数
}

/**
 * 平台返回
 */
export interface PlatBack {
    openid: string; //账号唯一标识
    token: string; //后端验证key
}
//邮件列表
export interface MailInfo {
    id: string; //
    title: string; //标题
    content: string; //内容
    items: KindItem[]; //道具列表
    fts: number; //发送时间
    rts: number; //读取时间
    ets: number; //过期时间
}

export interface HdCfg<HdData> {
    info: HdCfgInfo; //活动信息头部
    data: HdData; //活动信息配置
    red: number; //红点 0 ：没有红点 1：有红点
}

export interface HdCfgInfo {
    id: string; //活动重置id
    title: string; //标题
    icon: string; //图标
    sAt: number; //开始
    eAt: number; //结束
    dAt: number; //消失时间
    show: number; //延迟多少
}

export interface HdChongBangData {
    hdRankKey: string; //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    hdDayGift: number[]; //每日礼包
    hdRank: {
        pm: [number, number]; //排名区间
        items: number[][]; //奖励
    }[];
}

export interface HdChongBangOut {
    gift: number; //礼包领取时间
}
export interface ActZhangjie {
    zjid: string; //章节ID
    maxitem: {
        //已获得掉落道具
        [kind: string]: {
            [itemid: string]: number;
        };
    };

    bossxb: number; //BOSS下标
    monsJd: string[]; //怪物节点
    zjrwd: number; //破风（章节）奖励 是否已经领取 0未领取 1已领取
    guai: number; //当前BOSS前置已击杀小怪数量
    kind11: number; //今日看广告次数
    kind11_max: number; //今日看广告次数上限值

    gjtime: number; //挂机最后结算时间
    gjMax: number; //挂机最大时长 （小时）
    gjRwd_dj: {
        [kind: string]: {
            //种类
            [id: string]: number; //道具ID 对应剩余未结算时间
        };
    };
}

// 地宫寻宝
export interface ActDiGongXunBao {
    map: DiGong_MapItem[][]; //地图数据 36个
    maxLevel: number; //玩家只能挑战的最高关卡
    level: number; //当前的关卡 不大于maxLevel
    playerHp: number; //记录主角剩余血量万分比
    zhenRong: { [fid: string]: number }; //记录弟子血量万分比
    hfTimeLast: number; //上次恢复血量时间
    outTime: number; //每日重算
    strongTimes: number; //强力丸的次数
    rwdNum: number; //关卡内奖励的数量
    strongNum: number; //关卡内强力丸的数量
    hpNum: number; //关卡内恢复丸的数量
    monNum: number; //关卡内小怪的数量
    freeNum: number; //广告领取次数
    taskProcess: { [gid: string]: 0 | 1 }; //0未领取 1已领取 默认为空
}

// 地宫寻宝 结点类型枚举
export enum DiGong_ItemType {
    boss = 1, //boss
    mon = 2, //普通小怪
    item = 3, //道具奖励
    empty = 4, //...啥也没有
    pass = 5, //通关门
    player = 6, //玩家
    strong = 7, //强力丸
    hp = 8, //回血丸
}

// 地宫寻宝 结点详细信息
export interface DiGong_MapItem {
    type: number; //结点类型
    hp: { [monId: string]: number }; //当前血量
    view: number; //当前视野 0不可见 1 可见
    id: string;
    // 当type为以下情况时id的枚举
    // boss = 1, bossID
    // mon = 2, 普通怪物ID
    // item = 3, 全局表digong_items（奖励ID）
    // empty = 4, -
    // pass = 5, -
    // player = 6, -
    // strong = 7, - 奖励读全局表digong_strong.item
    // hp = 8, - 奖励读全局表digong_hp.item
}

//地宫 战斗信息
export interface ActDiGongFight { }

//仙穹之巅 配置
export interface HdXianQiongZhiDianData {
    costItem: number[]   //每次挑战消耗1枚天骄贴
    freeItem: number   //每天0点获得天骄贴数量
    freeGap: number   //每xx时间获得1个个天骄贴
    itemPrice: number[]   //天骄贴价格
    maxBuyNum: number   //每日最多可最多购买20次天骄贴
    maxFreeNum: number   //最多可以拥有多少个的天骄贴
    maxAttempts: number   //n次内不会遇到同对手
    noLoseScoreState: number[]   //达到某境界后失败不扣分
    noDownState: number[]   //不降境的境界
    winItems: number[][]   //战斗胜利的奖励
    kuaNum: number   //10个区服跨一组
    matchTime: number[]   //匹配等待时间范围：毫秒
    robotServer: string   //机器人区服多语言key
    robotName: string   //机器人名称多语言key
    robotChenghao: number[]   //机器人称号列表
    fristRoundFake: number[]   //首次做假，第1场战力低于自己的范围（百分比）
    secondRoundFake: number[]   //首次做假，第2场战力低于自己的范围（百分比）
    thirdRoundFake: number[]   //首次做假，第3场战力高于自己的范围（百分比）
    followingRoundFake: number[]   //首次做假，后续场次战力低于自己的范围（百分比）
    fristPromoteFake: number[]   //首次做假，第1场升段战力低于自己的范围（百分比）
    secondPromoteFake: number[]   //首次做假，第2场升段战力低于自己的范围（百分比）
    thirdPromoteFake: number[]   //首次做假，第3场升段战力低于自己的范围（百分比）
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    kuaType: number   //周循环
    week: number[]   //生效周，比赛时间
    showWeek: number[]   //展示周，活动入口展示时间
    itemCall: number[]   //道具回收
    hdRankKey: string   //个人排行奖励
    stateInfo: {
        state: number  //境界
        title: string  //境界名称
        times: number  //升境的那个3次挑战次数，升级则升境
        breakScore: number  //该境界有几颗星
        items: number[][]  //段位奖励
    }[]
    match: {
        type: string  //匹配类型
        win: number  //连胜/连败场次
        gailv: string  //战力高于自己概率
        zhanlihigher: number[]  //战力高于自己范围：百分比
        zhanlilower: number[]  //战力低于自己范围：百分比
    }[]
    hdRank: {
        round: number  //轮次
        pm: [number, number]  //排名区间
        items: number[][]  //奖励
    }[]
    task: {
        [dc: string]: {
            dc: string  //档次dc
            kind: string  //活动种类
            need: number  //需要完成进度
            items: number[][]  //抽中道具
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //[]中，第一位是次数，第二位是活动中买其他礼包的累积充值，第三位是游戏内的累积充值
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次dc
            title: string  //礼包类型
            need: number[]  //购买所需道具类型及数量
            rwd: number[][]  //包含道具
            limit: number  //总限制购
            dayLimit: number  //每日限购
        }
    }
}



//仙穹之巅 后端输出信息
export interface HdXianQiongZhiDianOut {
    score: number; //总积分
    lastTime: number; //上次获得登神帖时间
    buyCount: number; //今日已买的次数
    up: 0 | 1; //0:自由比试 1:升镜比试
    upTimes: number; //升镜挑战次数
    fightFUuid: string[]; //挑战过的对手， 长度记录在活动配置
    gift: { [id: string]: number }; //礼包购买
    giftDay: { [id: string]: number }; //礼包购买

    taskhook: {
        [kind: string]: number;
    };
    task: { [dc: string]: number }; //已经领取任务档次列表
    kuaList: string[]; //参与的区服
    enemy: string; //对手
    freeTimes: number; //挑战次数
}

//仙穹之巅-战斗记录后端输出信息
export interface XianQiongZhiDianFightInfo {
    fUser?: any; //被挑战者
    fuuid: string;
    fState: number; //被挑战者的段位
    fScore: number; //被挑战者的段位积分

    win: number; //挑战者的输赢状态 0:输 1赢

    mUser?: FUserInfo; //挑战者
    uuid: string;
    mState: number; //挑战者的段位
    mScore: number; //挑战者的段位积分
    time: number; //时间
}

// 道友
export interface ActDaoyou {
    time: number; //隔天刷新字段
    daoyouMap: { [key: string]: DaoyouInfo }; //玩家拥有的道友
    items: { [did: string]: number[] }; //记录已领取的道友好感度等级奖励
    hook: { [key: string]: number }; //钩子数据
}
export interface ActRed {
    [key: string]: number;
}

// 道友等级信息
export interface DaoyouInfo {
    favorLv: number; // 好感度等级
    did: string; // 道友 id
    skill: number[]; // 技能id
    favor: number; // 当前好感度
    maxLevel: number; //现在挑战成功的关卡
    rwdCount: number; //礼物领取到哪一级
}

/**
 * 道友切磋数据
 */
export interface ActDaoYouFight { }

/**
 * 斗法战斗被打日志
 */
export interface ActDouFaLog extends FUserInfo {
    win: number; //1胜0负
    score: number; //获得积分
    fuchou: number; //1是0否复仇
    cAt: number; //被打时间
    xhid: string; //战斗序号
}

/**
 * 斗法信息
 */
export interface ActDouFaInfo {
    lastDayRid: number; //上一次每日排名 -1表示未上榜
    lastWeekRid: number; //上一次每周排名 -1表示未上榜
    dayAt: number; //下一次生成日奖励时间
    weekAt: number; //下一次生成赛季奖励时间
    dItems: KindItem[]; //每日奖励
    wItems: KindItem[]; //赛季奖励
    get5: DoufaGet5[]; //抽取5个对手
    refreAt: number; //下一次可刷新时间
    winCount: number; //胜利刷新次数
    pkNum: number; //已战斗次数 其他模块要用
}

/**
 * 斗法战斗
 */
export interface ActDouFaFight { }

export interface DoufaGet5 {
    score: number; //分数
    bhAt: number; //保护截止时间
    fuuid: string; //指向展示详细信息对应的玩家
    fuser?: FUserInfo;
}

//异象信息
export interface ActYiXiang {
    hh: string; //幻化的翅膀ID
    hhList: string[]; //可幻化列表
    id: number; //翅膀等级分表序号ID
    exp: number; //当前翅膀进度条
    hxData: {
        [hh_id: string]: {
            level: number
        }
    }
    hxid: string; //化形id
}

// club
export interface ActShopClub extends ActShopBase { }
export interface ActClub {
    //我的世家ID ""空字符串代表没有世家
    clubId: string;
    //活跃值
    active7D: Active7D;
    // 每日活跃度奖励领取情况
    activeRwd: { [dc: string]: number };
    //加入当前世家时间
    joinTime: number;
    //上一次退出世家的时间
    quitTime: number;
    //退出世家的次数
    quitNum: number;
    // 退出当天0点时间--用于判断是否能打boss
    quitNum0: number;
    //每日重算字段
    outTime: number;
    //申请表 已经在申请中的世家ID
    apply: {
        [clubId: string]: number;
    };
    zhuli: {
        // 今天助力次数
        num: number;
        // 助力的几种类别
        type: { [type: string]: number };
    };
    boss: {
        // 打boss的次数
        fightNum: number;
        // 获得的宝箱数
        rwdBox: number;
        maxHurt: number;
        dayHurt: number;
        zhenNum: number;
        hurtRwd: { [dc: string]: number };
        killRwd: { [bossId: string]: number };
    };
    // 议价
    yiJia: {
        subCost: number;
        // 购买后记录本次议价的结束时间，用于判断是否购买过
        buyTime: number;
    };

    // 每个任务的进度
    taskHook: { [kind: string]: number };
    // 任务列表领取情况
    task: { [id: string]: number };
}

export interface ActClubMiShu {
    // 筋骨
    jinGu: {
        [type: string]: number; //等级
    };
    jllist: {
        //经络列表
        [jlId: string]: InfoJl;
    };
    curJlQuality: number; // 当前经络阶级
    curJlId: string; // 当前的经络id
}
interface InfoJl {
    level: number; //经络等级
}

export interface ActClubShengB {
    // 全局等级
    lv: number;
    // 当前经验
    exp: number;
    // 方案名
    planName: { [id: string]: string };
    // 词条全局解锁状态
    pos: { [id: string]: number };
    // 当前应用的方案
    curPlan: string;
    // 具体方案 方案id 词条位置id 词条id isLock:是否锁定当前位置上的词条
    plan: { [planId: string]: { [posId: string]: { isLock: number; id: string; range: number } } };
}

// 世家悬赏
export interface ActClubQuest {
    // 临时数据
    temp: {
        taskId: string;
        taskEvent: TaskEvent[];
    };

    // 任务次数
    nTask: number;
    // 挑战别人胜利之后获得奖励次数
    nGetRwd: number;
    // 打boss次数
    nBoss: number;

    //挑战日志
    log: {
        // 挑战者uuid
        fuuid: string;
        fuser: FUserInfo;
        taskId: string;
        //损失的道具
        cost: number[][];
        time: number;
    }[];

    // 悬赏积分
    score: number;

    // 每周膜拜奖励领取情况
    worshipRwd: number;

    adNum: number;

    nRefreshChallenge: number;

    // 挑战列表 uuid
    challengeList: {
        [fuuid: string]: {
            // 类型：仇人
            type: number;
            // 他的任务详情
            task: ClubQuestTask;

        };
    };

    red: number,
}

export interface SevClubQuest {
    // 世家悬赏任务列表
    ku: {
        [uuid: string]: ClubQuestTask;
    };
}

export interface SevClubQuestLog {
    // 世家历史日志列表-已经完成的任务
    log: ClubQuestTask[];
}

export interface ClubQuestTask {
    // 当前悬赏任务id
    uuid: string;
    user?: FUserInfo;
    id: string;
    clubId: string;
    // 精力值
    energy: number;
    // 绝对结束时间
    endTime: number;
    // 不在护送时间会暂停：顺延的时间
    delayTime: number;
    // 被击败次数
    nDefeat: number;
    //攻击过这条任务的人 是否护送中
    fightList: {
        [fuuid: string]: {
            fuser?: FUserInfo;
            // 是否也在护送中
            isTasking?: number;
            // 一共打了几次
            nFight: number;
            //是否赢过这个人
            isWin: number;
        };
    };
}

export type QiyuEvent = {
    type: "1"; // 奇遇
    qiyuId: string;
    item: number[][];
};

export type ChallengeEvent = {
    type: "2"; // 挑战输了
    fuuid: string;
    fuser?: FUserInfo;
    item: number[][];
};

export type TaskEvent = QiyuEvent | ChallengeEvent;

// 章节推关送奖
export interface HdZhangjiePushData {
    list: {
        [dc: string]: {
            dc: string; //档次
            cons: number; //需要的章节数-进度
            items: KindItem[]; //奖励
        };
    };
}

export interface HdZhangjiePushOut {
    // 已领取的章节推关奖励
    rwd: { [dc: string]: number };
    cons: number; //当前章节进度
}

// 世家同名活动
export interface HdClubSameNameOut {
    sameName: { [dc: string]: number };
    memberList: string[];
}
export interface HdClubSameNameData {
    list: {
        [dc: string]: {
            dc: string; //档次
            rwd: KindItem[]; //奖励
        };
    };
}
// 世家同门充值
export interface HdClubCzOut {
    rwdCz: { [dc: string]: number };
}
export interface HdClubCzData {
    list: {
        [dc: string]: {
            dc: string; //档次
            rwd: KindItem[]; //奖励
        };
    };
}

export interface ClubCz { }

export interface SevClubPkMy {
    cjHook: {  //成就进度
        [kind: string]: number
    }
    //仙盟日志  我工会被打的日志
    log: {
        [id: string]: {
            user: FUserInfo  //出手方
            clubId: string // 属于哪个工会
            killNum: number  //击杀多少个
            jifen: number  //扣除多少积分
            time: number  //触发时间
        }
    }
    showList: {
        names: string[]//名字列表
        max: number  //最大人数
    }
}

export interface SevClubPkLog {
    //仙盟日志  我工会被打的日志
    log: {
        [id: string]: {
            user: FUserInfo  //出手方
            clubId: string // 打人的工会ID
            clubName: string // 被打的工会的工会名字
            killNum: number  //击杀多少个
            time: number  //触发时间
        }
    }
}


export interface ClubYiJia {
    // 本次云游商人的id
    id: string;
    // 本次云游商人结束时间
    endTime: number;
    // 本次云游商人玩家总议价的金额
    sub: number;
    // 本次云游商人最多能议价的金额
    maxSub: number;
    // 本次云游商人议价日志
    log: {
        fuuid: string;
        subCost: number;
        time: number;
    }[];
}

//申请表成员信息
export interface ClubApplyMember {
    user: FUserInfo; //玩家信息
    active7D: number; //7日活跃值
}

export interface ActClubFight {
    start: ActFightStart; //战斗开始阵容准备信息
    end: {
        win: number; //0失败 1胜利 2平手
        items: KindItem[]; //获得奖励
        hurt: number; //照成的总伤害
    };
}

//七日活跃算法
export interface Active7D {
    all: number; //当前7日活跃值
    days: {
        [dayId: string]: number;
    };
    // rstTime: number; //上次重算日期
}

export interface ClubFx {
    list: {
        [fuuid: string]: number[]; //角色ID:[福字,总阅历,总境界点,世家贡献]
    };
    cons: number; //今日福字总数量
}

/**
 * 罗浮仙域 - 公共信息
 */
export interface SevLuoFuXianYu {
    cj: {
        [id: string]: string[]; //首先达到层数的5个人
    };
}

/**
 * 罗浮仙域 - 个人信息
 */
export interface ActLuoFuXianYu {
    sevRwd: string[]; //领取的全服奖励档次
    actRwd: string[]; //领取的个人奖励档次

    nowId: number; //今日已通过关卡ID
}
export interface ActLuoFuXianYuG5S {
    list: ActLuoFuXianYuG5[];
}
export interface ActLuoFuXianYuG5 {
    id: string; //当前展示档次
    list: {
        rid: number;
        score: number;
        fuser: FUserInfo;
    }[];
}

/**
 * 荒古禁地
 */
export interface SevHuangGuJinDi {
    cj: {
        [xlsId: number]: {
            score: number; // 通关时长
            fuser: FUserInfo; // 通关时的信息
        }; //首通玩家信息
    };
}

export interface SevYaoDiFenZhong {
    cj: {
        [xlsId: number]: {
            score: number; // 通关时长
            fuser: FUserInfo; // 通关时的信息
        };
    };
}

export interface SevQingTongXianDian {
    cj: {
        [xlsId: number]: {
            score: number; // 通关时长
            fuser: FUserInfo; // 通关时的信息
        }; //首通玩家信息
    };
}

export interface SevYaoDiFenZhongBoss {
    maxHp: number; //最大血量
    hp: number; //剩余血量
    mems: {
        [iid: string]: SevYaoDiFenZhongBossList;
    };
    guwu: {
        [fuuid: string]: number;     // 鼓舞加成
    }
    maxEtime: number; //被打的最后时间点
}

//单人就是 角色Id  组队就是队伍ID
export interface SevYaoDiFenZhongBossList {
    allHit: number; //打BOSS的总伤害 （多次）
    fhtime: number; //下一次复活时间（s）
    stime: number; //本次战斗开始时间（s）
    etime: number; //本次战斗结束时间（s）
    hit: number; //本次战斗的伤害（单次）
    fUser?: FUserInfo;
    win: number; //本次战斗是否胜利（单次） 1胜利己方不死 0失败乙方死亡
}

export interface ActDayRwd {
    rwd: number;
}

//凶兽入侵 配置
export interface HdXiongShouData {
    tzItem: number[]   //每次挑战消耗1枚御兽符
    tzFreeNum: number   //每天0点获得2个御兽符
    tzFreeGap: number   //每8小时(28800秒)获得1个御兽符
    tzMaxItem: number   //御兽符最大拥有上限
    tzMaxBuyNum: number   //御兽符最大购买数量
    tzItemPrice: number[]   //御兽符的价格
    tzScore: number   //在挑战中每造成10000点伤害可获得1点积分
    zjItem: number[]   //阻击消耗的道具：狙击券
    zjItemPrice: number[]   //狙击券价格
    zjFreeNum: number   //每天0点获得3个狙击券
    zjFreeGap: number   //每8小时(28800秒)获得1个狙击券
    zjMaxItem: number   //狙击券最大拥有上限
    zjMaxBuyNum: number   //每日最多可最多购买6次狙击券
    zjFreeRefreshCount: number   //狙击，每日免费刷新次数
    zjPayRefreshPrice: number[]   //狙击，付费刷新的价格
    zjPayRefreshCount: number   //狙击，每日付费刷新次数
    zjRefreshRule: number[]   //狙击刷新对手的规则：[仇人的数量,相近积分对手的数量,随机对手的数量]
    zjEnemyScore: number[]   //相近积分对手：积分相差范围（百分比），乘的是玩家自己当前的积分
    zjWinScore: number   //狙击，单次挑战获得最高积分比例（万分比）
    zjBaodiScore: number   //被狙击时的保底积分值
    zjCloseTime: number   //活动结束前，提前关闭狙击功能的时间（秒）
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    kuaNum: number   //10个区服跨一组
    kuaType: number   //周循环
    week: number[]   //生效周，比赛时间
    showWeek: number[]   //展示周，活动入口展示时间
    itemCall: number[]   //道具回收
    hdRankKey: string   //个人排行奖励
    logLimit: number   //最多显示XX条日志
    rankMembers: number   //排行榜最多显示XX名玩家
    socreItem: number   //积分道具
    monsterData: {
        [id: string]: {
            id: string  //副本id
            name: string  //怪物名称
            zuid: string  //编队id
            fightrwd: number[][]  //挑战奖励
            killrwd: number[][]  //击杀奖励
            scale: number  //UI缩放比例(boss)
        }
    }
    hdRank: {
        round: number  //轮次
        pm: [number, number]  //排名区间
        items: number[][]  //奖励
    }[]
    task: {
        [dc: string]: {
            dc: string  //档次dc
            kind: string  //活动种类
            need: number  //需要完成进度
            items: number[][]  //抽中道具
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次
            title: string  //标题
            need: number[]  //价格
            items: number[][]  //奖励
            limit: number  //限购次数
            dayLimit: number  //每日限购次数
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //[]中，第一位是次数，第二位是活动中买其他礼包的累积充值，第三位是游戏内的累积充值
        }
    }
}




//凶兽入侵 后端输出信息
export interface HdXiongShouOut {
    zjLastTime: number; //上次获得显影符时间
    zjBuyCount: number; //今日已买显影符的次
    maxScore: number; //单次挑战中最高积分
    tzBuyCount: number; //今日已买斩凶密卷的次数
    tzLastTime: number; //上次获得斩凶密卷时间
    gift: { [id: string]: number }; //礼包购买
    giftDay: { [id: string]: number }; //礼包购买
    taskhook: {
        [kind: string]: number;
    };
    task: { [dc: string]: number }; //已经领取任务档次列表
    monster: string; //bossID
    monsterDamage: number; //对boss造成的伤害
    monsterMaxHp: number; //boss最大血量
    zjList: {
        user: FUserInfo,
        state: number, //0随机人 1相近人 2仇人
        score: number,//可掠夺的分数
        rank: number,
    }[]
    zjFreeRefreshCount: number, //阻击列表今日免费刷新次数
    zjPayRefreshCount: number,//阻击列表今日付费刷新次数
    zjNeedRefresh: number, //下次进入阻击列表是否需要刷新 0不需要 1需要

    bugNum: number, //礼包购买次数
    bugCons: number,//礼包购买金额
    kuaList: string[]; //参与的区服
    tzfreeTimes: number, //挑战免费次数
    zjfreeTimes: number, //阻击免费次数
    logRed: number, //日志红点
}

//凶兽入侵-战斗记录后端输出信息
export interface XiongShouLogInfo {
    fUser?: FUserInfo; //被阻击者
    fuuid: string;
    score: number; //被抢夺的积分
    fightBackScore?: number; //反击的积分
    time: number; //时间
    red: number; //红点
    fightBack: number; //是否已反击 0否1是
}


export interface HdWanZuPartyData {
    kuaType: number // 1普通跨服
    kuaNum: number   //跨服数量
    hdRankKey: string   //个人排行版key
    hdRankKey2: string  //club排行版key
    itemCall: number[]   //道具回收
    itemCallRate: number //万族灵玉回收倍率
    buyNeed: number[]   //购买挑战次数所需的道具
    buyItem: number[]   //挑战通用道具
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    gift: {
        [dc: string]: {
            dc: string  //档次
            title: string  //礼包名称
            need: number[]  //需求
            rwd: number[][]  //礼包内容
            dayLimit: number  //每日限制
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //条件  累积充值
        }
    }
    exchange: {
        [dc: string]: {
            dc: string  //档次
            need: number[]  //需要的道具
            items: number[]  //可兑换的道具
            max: number  //最大兑换次数
            unLockNeed: number  //解锁需要的活动道具消耗
        }
    }
    hdRank: {
        pm: [number, number]  //排名区间
        items: number[][]  //奖励
    }[]
    hdRankClub: {
        pm: [number, number]  //排名区间
        // 宗主奖励-如果是空读items
        LeaderItems: number[][]
        items: number[][]  //全员奖励
    }[]
    school: {
        [id: string]: {
            id: string  //门派ID
            title: string  //门派名称
            maxBuyNum: number  //每天额外购买addChallengeNum次挑战次数的次数
            freeNum: number //门派开启时免费的挑战次数
            open: number[]  //门派周几开始开放和开放持续几天
            class: string   //关卡分类
            feature: number[][]  //伙伴流派影响-流派id-伤害百分比
        }
    }
    class1: {
        [id: string]: {
            id: string  //bossid
            zuid: string  //boss编队id
            rwd: number[][]  //奖励
        }
    }
    class2: {
        [id: string]: {
            id: string  //bossid
            zuid: string  //boss编队id
            rwd: number[][]  //奖励
        }
    }
    class3: {
        [id: string]: {
            id: string  //bossid
            zuid: string  //boss编队id
            rwd: number[][]  //奖励
        }
    }
    class4: {
        [id: string]: {
            id: string  //bossid
            zuid: string  //boss编队id
            rwd: number[][]  //奖励
        }
    }
}

export interface HdWanZuParty_class {
    [id: string]: {
        zuid: string  //boss编队id
        rwd: number[][]  //奖励
    }
}

export interface HdWanZuPartyOut {
    // 时间线 - 各个门派的开启和关闭时间 id = “999”是展示期
    timeLine: { [id: string]: { sAt: number, eAt: number } }
    //门派信息-challengeNum:挑战次数; buyNum:每天用灵石购买挑战次数的次数; score:积分; maxCourse:记录达到的最大关卡;
    school: { [id: string]: { challengeNum: number; buyNum: number; score: number; maxLv: number } };
    // 已经购买/兑换的次数
    giftDay: { [id: string]: number };
    exchange: { [id: string]: number };
    // 消耗的盛会币
    subCoinNum: number;
    // 我的排名 null表示未上榜
    rankMy: number | null;
    // 上一名的积分(自己如果是第一名，这个积分就是第二名的积分,如果自己未上榜，这个积分就是上榜积分)

    //  - 对于已上榜玩家：
    // - 第一名：返回第二名的分数
    // - 其他名次：返回前一名的分数
    // - 对于未上榜玩家：
    // - 如果排行榜有人：返回最后一名的分数
    // - 如果排行榜没人：返回 null
    fScore: number | null;

    bugNum: number; //礼包购买次数
    bugCons: number; //礼包购买金额

}

export interface ActFightStart {
    from: string; //战斗类型
    seed: number; //随机种子
    teams: {
        [iid: string]: FightTeam;
    };
    // user?: FUserInfo; //自己的角色信息
    // fuser?: FUserInfo; //他人的角色信息
    // power: number;
    // fPower: number; //对方的战力
}
export interface FightTeam {
    fid: string; //唯一身份ID
    zhanwei: number; //站位 0无1前2后
    level: number; //主角等级，仙侣等级
}

/**
 * 战斗日志
 */
export interface fightLogList {
    win: number; //0失败 1胜利 2平手
    log: {
        //战斗日志列表
        //回合ID：单回合内战斗日志
        [huihe: string]: fightLogOne[];
    };
}

//单回合内战斗日志
export interface fightLogOne {
    aType: ActionType; //战斗动作类型
    atker: fightLogOneData; //出手方
    target: fightLogOneData[]; //目标
}
export interface fightLogOneData {
    fid: string; //出手方Id
    iid: string; //阵容下标
    hp: number; //剩余血量
    nuqi: number; //当前怒气值
    buff: [string, number][]; //上BUFF [ [BuffID,回合数]]
    effect: [string, number][]; //触发效果 [ [属性key,数值]]
    status: number; //备用字段 1会复活  2要被反击了
}



//战斗开始返回
export interface OverBack {
    start: ActFightStart;
    log: {
        //战斗日志列表
        //帧数：单回合内战斗日志
        [zhen: string]: fightLogOne[];
    };
    hurt: number; //本次战斗总伤害
    win: number; //0失败 1胜利
    hp: number; //对方剩余血量
    tongji: Tongji;
    xhid: string;
    zd_arr?: { xlsId: string; nextBoci?: boolean; boci?: number };
    zhen?: number;
}

export interface Tongji {
    [fiid: string]: {
        shuchu: number; //输出
        zhiliao: number; //治疗
        chengshang: number; //承伤
    };
}

export interface OverBackEnd<T> {
    end: T; //战斗结束弹窗信息
    xhid: string;
}

//妖帝坟冢结算下发
export interface zdydfz {
    from: string; //战斗类型
    rid: number; //排名
    items: KindItem[]; //队伍ID
    zd_id: string; //组队ID ""表示自己
    tongji: Tongji; //角色：伤害
}

export interface fightBackMx {
    xhid: string;
    uuid: string;
    from: string;
    teams: { [iid: string]: FightTeam };
    user?: FUserInfo;
    fuser?: FUserInfo;
    win: number;
    hurt: number;
    hp: number;
    tongji: {
        [fiid: string]: {
            shuchu: number; //输出
            zhiliao: number; //治疗
            chengshang: number; //承伤
        };
    };
}

//章节BOSS弹窗
export interface OverBackEnd_ZhangJie {
    items: KindItem[];
    tongji: Tongji;
}

export interface LogOneData {
    fid: string; //出手方Id
    iid: string; //阵容下标
    hp: number; //剩余血量
    mp: number; //剩余怒气
    buff: [string, number][]; //buff列表
    effect: [string, number][]; //触发效果 [ [属性key,数值]]
    tongji: number; // 累计伤害
    zonji?: number; // 队伍累计伤害
}
/**
 * 战斗动作类型
 */
export enum ActionType {
    round = "0", //回合开始 玩家出手前
    buff = "1", //buff
    atk = "2", //普通攻击
    skill = "3", //技能攻击
    over = "999", //回合结束
}

export interface ActShopBase {
    buy: {
        [dc: string]: number; //档次对应购买次数
    };
}

export interface ActShopItem extends ActShopBase { }

export interface ActShopCoin extends ActShopBase { }

export interface ActShopDiaMond extends ActShopBase { }

export interface ActShopPata extends ActShopBase { }
export interface ActShopXiezhu extends ActShopBase { }

export interface ActShopJinTiao extends ActShopBase {
    // 打折
    startDiscountTimestamp: number;
    overDiscountTimestamp: number;
    discount: number;
}

//特惠礼包
export interface HdSpeGiftData {
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    banner: string   //banner图标
    list: {
        [dc: string]: {
            dc: string  //档次
            title: string  //礼包类型
            need: number[]  //购买所需道具类型及数量
            items: number[][]  //包含道具
            limit: number  //每日限制
            bg: string  //背景色
            show: number  //累计充值达到多少显示
            showAll: number  //购买后展示剩余礼包
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //条件  累积充值
        }
    }
}

export interface HdSpeGiftData_dc {
    need: KindItem;
    items: KindItem[];
    title: string; //标题
    limit: number; //每日限购
    bg: string; // 背景色 lv lan zi cheng hong
    show: number; //累计充值达到多少显示
    rate: number; //倍率购买 0不生效 例如配置10可翻10倍购买
}
export interface HdSpeGiftOut {
    list: {
        [dc: string]: number; //档次 : 购买次数
    };
    outTime: number; //每日过期刷新时间
    chargeNum: number; //每日充值金额

    bugNum: number; //礼包购买次数
    bugCons: number; //礼包购买金额
}

//签到
export interface HdSignGiftData {
    //配置
    list: {
        [day: string]: {
            rwd: KindItem[];
        };
    };
    dajiang: {
        [day: string]: {
            rwd: KindItem;
        };
    };
}
export interface HdSignGiftOut {
    //输出
    rwds: {
        [day: string]: number; //已领取表
    };
    days: number; //累计登录天数
}

//每日特惠
export interface HdDayTeHuiData {
    dayRwd: number[][]; //每日免费奖励
    allNeed: number[]; //allNeed
    allRwd: number[][]; //打包购买 给的奖励
    allDays: number; //allDays
    title: string; //连购标题
    dayList: {
        [dc: string]: {
            dc: string; //档次
            title: string;
            need: number[];
            rwd: number[][]; //初始轮奖励
        };
    };
}

export interface HdDayTeHuiOut {
    dayRwd: number; //每日白嫖
    //今天已领取(购买)档次
    dayList: {
        [id: number]: number;
    };
    allOutTime: number; //全买过期时间
}

//每日特价
export interface HdDayTeJiaData {
    need: number[]; //一键购买价格
    title: string; //礼包名称
    ids: string[]; //一键购买的礼包档次
    list: {
        [dc: string]: {
            dc: string; //档次
            type: number; //类型
            title: string; //礼包名称
            need: number[]; //价格
            items: number[][]; //物品
            limit: number; //每日限购
        };
    };
}
export interface HdDayTeJiaOut {
    list: {
        [id: string]: number;
    };
}

// 称号
export interface ActChenghao {
    // 已经解锁的称号列表
    list: {
        [id: string]: {
            // 红点
            red: number;
            // 到期时间
            at: number;
            //是否发送即将过期提醒邮件
            isSend: number;
            //称号名称
            name: string;
        };
    };
    //最后一次晋升获得的称号ID
    getId: string;
    //当前穿戴的
    chuan: string;
}

//爬塔
export interface ActPata {
    histMax: number; //历史过的最大关卡 0 开始-用于判断奖励
    dayMax: number; //当日过的最大关卡 0 开始-用于判断奖励
    nowId: number; //当前过的关卡 0 开始-当前已经过的关卡
    etime: number; //重置时间
    cengRwd: { [id: string]: number }; //奖励
    // 是否已经扫荡;
    iSsweep: number;
    //待选择加成
    list: string[];
    //记录选择加成的层数
    selectCeng: string[];
    //当前加成 islock = 1 锁住
    pos: { [id: string]: { buffId: string; isLock: number } };
    // 是否自动选择加成
    autoSelect: number;
    // 选择加成的预设偏好 优先级-
    buffYushe: string[];
    //每日重置字段
    dayAt: number;
}

//秘境
export interface ActMijing {
    time: number; //用于每日重置
    // level:当前秘境等级，ad:记录当前秘境广告 每天上限
    mijing: {
        [id: string]: {
            level: number;
            monPower: number; //怪物战力下发
            ad: number;
            dayLimit: number;
            nSaoDang: number; // 免费扫荡次数 每日重置
        };
    };
}

// 宗门
export interface ActZongMen {
    // ----------------- 宗门信息(家) -----------------
    // 宗门等级
    level: number;
    // 宗门经验
    exp: number;
    // 培养位置，键为位置ID
    trainPos: {
        [id: string]: {
            energy: number; // 培养位置的能量值
            isLocked: number; // 是否锁定
            mentuId: string; // 当前培养的门徒ID，表示该位置上正在培养的门徒
            recoverTime: number; // 记录每次恢复灵气后的时间
        };
    };
    // ----------------- 选拔门徒(出生)-----------------

    // 选择列表
    selectList: mentu[];

    // ----------------- 门徒培养----------------

    // ----------------- 门徒三个阶段列表----------------
    // 特权卡
    nBaodi: number;

    // 门徒未成年列表
    mentu: {
        [id: string]: mentu;
    };

    // 任命位置，键为位置ID
    appointPos: {
        [id: string]: {
            isLocked: number; // 是否锁定
            mentuId: string; // 当前任命的门徒ID
        };
    };

    adNum: number; //广告次数

    // 是否开启自动培养
    isAutoTrain: number;

    isRefuseAll: number; //是否拒绝所有申请

    // 结好门槛，要求对方门徒最低等级
    marryLevel: number;

    // 存储玩家当前最高战力的门徒id
    maxPowerMentu: [string, number] | string;

    apply: { [fuuid: string]: { [mentuId: string]: { mentuInfo?: mentu; stime: number } } }; //申请表

    // 每个发布频道免费刷新次数
    refreshCount: { [channel: string]: number };

    // ----------------- 统计 ----------------
    // 出师总数量
    graduateCount: number;
    // 结好总数量
    marryCount: number;
    // 累计获得的奖励数量
    rewardCount: number;
    // 所有门徒基础属性之和
    allBasicAttr: { [key: string]: number };
    // 所有任命门徒的特殊属性之和
    allSpeAttr: { [key: string]: number };
}



// 门徒
export interface mentu {
    // 基础信息
    name: string;
    pifu: string;
    gender: number; //0女 1男

    userName?: string; // 玩家名字
    clubName?: string; // 世家名字
    sid?: string; // 区服id

    // 被选择后增加的属性
    pinzhi?: string; // 品质
    level?: number; // 门徒等级
    speAttr?: string[]; // 特殊属性id列表
    maxTrain?: number; // 培养上限

    // 培养后增加的属性
    basicAttr?: { [key: string]: number }; // 普通属性
    trainCons?: number; // 培养进度

    // 出师后获得的出师属性
    isGraduated?: number; // 是否出师
    graduateAttrId?: string; // 出师属性id
    graduateAttr?: { [key: string]: number }; // 普通属性

    isLocked?: number; // 是否锁定为不可结好

    // 结好发布频道
    channel?: string; // 结好频道
    // 发布频道结束时间
    postEndTime?: number; // 发布频道结束时间

    // 申请记录
    applyList?: { [fuuid: string]: number }; // 申请列表 fuuid: 申请时间

    // 结好信息
    married?: { [fuuid: string]: { mentuId: string; mentuInfo?: mentu; time: number } };
}

export interface mentuPostMarryInfo {
    iid: string; //
    uuid: string; //请求结好玩家的uuid
    mentuId: string; //请求结好玩家的门徒id
    mentuInfo: mentu; //请求结好玩家的门徒信息
    postLv: number; // 要求对方门徒的最低等级
    postTime: number; // 发起时间
}

// 仙域
export interface ActXianYu {
    // 展示进入宫殿的队列-获得仙域称号
    // 按照对应的品质高低，品质低的在前面
    //   宫殿id
    list: string[];

    // 宫殿的入住有人还是没人
    palace: {
        [id: string]: 0 | 1;
    };

    // 仙气
    nXianqi: number;

    // 仙树奖励 
    treeRwd: {
        [id: number]: number
    };

    like: {
        [id: string]: number
    };

    // 可赐福称号id
    cifu: {
        [id: string]: {
            chId: string;
            // 来源
            chItem: number[]
            // 赐福状态: 0-未赐福, 1-已赐福未开奖, 2-已赐福已开奖
            status: number;
            // 开奖时间（仅在已赐福未开奖状态下有效）
            drawTime: number;
            // 逾期时间-过了之后不能发送赐福
            endTime: number
        };
    };

    cifuLog: {
        chId: string;
        chItem: KindItem;
        time: number;
    }[]

    // 玩家祈福次数。每日重置
    nQifu: number;

    qifuBuff: string;

    // 仙名录红点
    logRed: {
        [id: string]: number
    }

    // buff的次数
    nbuff: number;

    // 记录领过的玩家的uuid
    arrGetCifu: string[];

    // 玩家获得的仙玉
    nXianyu: number;

    // 天骄阁
    roleShop: { [id: string]: number };
    huobanShop: { [id: string]: number };

    subXianguo: number;

    // 祈福展示前端用
    qifuShow: string;

    xianqiFund: {
        [id: string]: {
            // 状态：0未购买,1购买了
            status: 0 | 1;
            // 可以领取的时间
            time: number
        }
    }

}

export interface SevXianYu {
    palace: {
        // 仙域ID ：仙域信息 
        // uuid 称号id
        [id: string]: [string, string][]
    }
}

export interface SevXianYuRwd {
    list: {
        [fuuid: string]: {
            arrChId: string[];
            fuser: FUserInfo;
            // 过期时间
            endTime: number;
        }
    }
}

// 仙名录
export interface SevXianYuLog {
    palace: {
        // 仙域ID ：仙域信息  uuid 和 称号id
        [id: string]: {
            fuser: FUserInfo;
            // 入住时间
            time: number;
        }[]
    }
}

//累计天数充值礼包
export interface HdChargeDaysData {
    dayRwd: KindItem[]; //每日白嫖
    //活动配置
    dayNeed: number; //每日需要充值多少钱(6元)
    //一轮内 档次奖励
    list: {
        [id: string]: {
            need: number; //需求天数
            rwd: KindItem[]; //初始轮奖励
            rwd1: KindItem[]; //循环轮奖励
        };
    };
}

export interface HdChargeDaysOut {
    dayRwd: number; //每日白嫖奖励领取了没
    //已领取 档次
    rwd: {
        [id: string]: number;
    };
    score: number; //累计天数
    todayTotol: number; //今日累计充值 (每日重置)
    todayAdd: number; // 今天天数加入没有
    lun: number; //当前第几轮 默认0 每轮+1 不输出 暂时没用
}

//累计充值礼包
export interface HdChargeTotalData {
    dayRwd: KindItem[]; //每日白嫖
    hdHours: number; //持续时间 小时
    banner: string   //banner图标
    //任务奖励
    list: {
        [id: string]: {
            need: number; //需求充值
            rwd: KindItem[]; //奖励
            limit: number   //累计充值多少解锁
        };
    };
}
export interface HdChargeTotalOut {
    dayRwd: number; //每日白嫖奖励领取了没
    //已领取 档次
    rwd: {
        [id: string]: number;
    };
    score: number; //累计充值
    endTime: number; //结束时间  endTime < now 未开启
    //每日重置
    outTime: number; //每日重算字段
}

//基金 成长基金 角色基金
export interface HdFundData {
    title: string; //礼包名称
    need: number[]; //need
    type: "actJingJie" | "actZhenfa" | "actPata" | "actDadiGuzi" | "actZhangjie" | "actYaoTian" | "actMiJing" | "actZongMen"; //基金类型 境界 阵法 试炼 术法 章节 药田
    exItem: number[][]; //购买之后立即获得的奖励
    exgetItem: number[][]; //购买之后手动领取获得的奖励
    chenghaoId: number   //购买之后立即获得的称号
    list: {
        [dc: string]: {
            dc: string; //档次
            free: number[][]; //奖励
            grwd: number[][]; //奖励
        };
    };
    jifen?: number[][]; //需要积分
}

export interface HdFundOut {
    free: {
        [dc: string]: number; //档次 : 领取时间
    };
    pay: {
        [dc: string]: number; //档次 : 领取时间
    };
    payTime: number;
    getItemT: number;
    taskCons: { [kind: string]: number }; //任务完成情况
}

export interface HdKaifuData {
    jflist: {
        [dc: string]: {
            dc: string; //档次
            need: number; //需要多少分
            items: number[][]; //奖励
        };
    };
    duihuan: {
        [dc: string]: {
            dc: string; //档次
            need: number; //需要多少
            item: number[]; //兑换道具
            limit: number; //限购
            lock: number; //分达到多少开启档次兑换
        };
    };
    task: {
        [dc: string]: {
            dc: string; //档次
            kind: string; //任务类型
            items: number[][]; //奖励
            need: number; //任务条件
            jumpId: number; //跳转id
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次
            tiaojian: number[]; //前面是次数，后面是累积充值
        };
    };
    gifts: {
        [dc: string]: {
            dc: string; //档次
            title: string; //标题
            need: number[]; //价格
            items: number[][]; //奖励
            limit: number; //限购次数
            dayLimit: number; //每日限购次数
        };
    };
}

export interface HdKaifugOut {
    cons: number; //玩家当前积分
    allCons: number; //玩家总积分
    jflist: { [dc: string]: number }; //已经领取的积分档次列表
    duihuan: { [dc: string]: number }; //已经兑换档次列表
    taskhook: {
        [kind: string]: number;
    };
    task: { [dc: string]: number }; //已经领取任务档次列表
    gift: { [dc: string]: number }; //已经充值礼包档次列表

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}
// 世家动态日志分类
export type ClubLogAct = "join" | "kick" | "quit" | "info" | "role";
// 世家职位
export type ClubRole = "leader" | "elder" | "jingying" | "member";

export interface actAdokSev {
    clubRed: number; //工会红点
    zd_iid: string; //组队ID
    zm_time: number; //集结组队全服招募CD
    xz_count: number; // 今日协助次数
    checkNewZdRed: number; // 是否检查新队伍红点
    newZdRed: number; // 有新的组队队伍红点 1有 0没有
}

export interface ClubInfo {
    //世家基础数据
    clubId: string; //公会ID
    uuid: string; //会长UUID
    sid: string; //世家所属服务器ID
    name: string; //世家名字
    level: number; //世家等级
    exp: number; //世家经验
    jifen: number; //世家积分
    flag: string; //世家旗帜
    notice: string; //世家公告
    weChat: string; //世家微信
    declaration: string; //世家宣言
    power: number;
    // 旗帜到期时间
    flagList: { [id: string]: number };
    // 世家日志
    log: {
        user: FUserInfo;
        fuser: FUserInfo;
        // 职位变更
        act: string;
        time: number;
    }[];

    applyLevel: number; //申请加入等级要求
    applyAuto: number; //允许自动加入
    canselect: number; //允许被搜索
    createTime: number; //创建时间 /(世家是否存在:0 不存在)
    outTime: number; //每日重算字段

    //成员列表
    member: {
        [uuid: string]: {
            fuser: FUserInfo;
            role: ClubRole;
            active: number; //活跃值
            contrib: number; //贡献值
            contribAll: number; //贡献值
        };
    };

    // 总活跃值
    activeAll: number;

    //成员申请
    apply: {
        [fuuid: string]: {
            time: number; //申请时间
            fuser: FUserInfo;
        };
    };

    //当前bossId
    boss_id: string;
    //boss剩余血量
    boss_hp: number;
    // 辟邪阵等级
    boss_zhenLv: number;
    // 辟邪阵结束时间
    boss_zhenTime: number;
    // 辟邪阵布阵日志
    boss_zhenLog: {
        uuid: string;
        time: number;
    }[];
    boss_log: {
        type: number; // 1 伤害 2 击杀
        uuid: string;
        bossId: string;
        hurt: number;
        boxNum: number;
        time: number;
    }[];

    // 宝箱数量
    boss_boxNum: number;

    // 议价玩法
    yiJia: {
        // 今日是否出现云游商人
        isShow: number;
        log: {
            uuid: string;
            subCost: number;
            time: number;
        }[];
        // 总共议价金额
        subCost: number;
    };
}

export interface Fclub {
    clubId: string; //世家ID
    //世家基础数据
    uuid: string; //会长UUID
    sid: string; //世家所属服务器ID
    name: string; //世家名字
    notice: string; //世家公告
    level: number; //世家等级
    weChat: string; //世家微信
    power: number; //世家战力
    flag: string; //世家旗帜
    jifen: number; //世家积分
    declaration: string; //世家宣言
    applyLevel: number; //申请加入等级要求
    applyAuto: number; //允许自动加入
    canSelect: number; //允许被搜索

    createTime: number; //创建时间 /(世家是否存在:0 不存在)
    rstMstTime: number;

    // 0 点时间戳 //下次需要重算的时间 //前端倒计时刷新时间
    outTime: number; //每日重算字段

    member: {
        [uuid: string]: {
            fuser: FUserInfo;
            role: ClubRole;
            active: number; //活跃值
            contrib: number; //贡献值
            contribAll: number; //贡献值
        };
    };
}

//世家BOSS伤害排行
export interface ClubBoss {
    user: FUserInfo; //玩家信息
    score: number; //伤害值
}

export interface ActXiantu {
    list: {
        [id: string]: number;
    };
}

//主线任务
export interface ActTaskMain {
    id: number; //当前未完成的任务ID
    cons: number; //当前完成进度
}

//万象
export interface ActDadiGuzi {
    level: number; //血脉境界等级
    exp: number; //血脉境界经验
    mpList: {
        //命格列表
        [xhid: string]: {
            [buwei: string]: {
                //部位
                lsid: number; //临时id
                id: string; //古字序号
                eps: { [key: string]: number }; //属性
                level: number; //等级
                pinzhi: number;
            };
        };
    };
    mpName: {
        //预设套装名字
        [xhid: string]: string;
    };
    mpXhid: string; //出战序号
    lsid: number; // 临时id
    cwCount: number; // 参悟次数
    lqtime: number; // 参悟领取时间
    linshi: {
        [lsid: number]: lishiGZInfo;
    };
    ywItems: KindItem[]; // 分解获得的道具列表
    isYw: number; //装备或自动遗忘0|1会
    dayAt: number; //每日刷新
    cons: number; //自动模式剩余次数
    buycons: number; //每日已购买次数
    isOpen: number; //是否开启自动模式 0|1开启
    openAt: number; //最后一次自动模式开启时间
    kwd: number; //开悟点
    fjExp: number; //法决经验
    moshi: {
        //自动模式设置
        pinzhi: number; // 大于等于命格品质
        upPower: number; //0|1 战力提升时停止
        hq: number[]; // 0同时 1或者
        keys: [number, string, string]; //[是否选择，属性key1，属性key2]  空字符串表示任意
        lm: [number, string]; //[是否选择，灵脉id] 0表示任意
        speed: number; //是否加速0不加速1加速
    };

    //秘法部分
    baodi: number; //保底次数
    cwids: [string, number][]; //[秘法id，秘法碎片0表示完整秘法][]最后一次参悟秘法id列表给前端展示
    mfList: {
        [id: string]: {
            // 秘法id
            level: number; //等级
            step: number; //阶级
            chip: number; //碎片
            mwLock: string[]; //铭文解锁
        };
    };
    mfZhan: {
        //秘法出战列表
        [type: string]: string; //秘法类型：秘法id
    };
    mwlist: {
        //铭文列表
        [id: string]: number;
    };
    tjlist: {
        //图鉴列表等级
        [id: string]: number; //图鉴id对应等级
    };
    free: number; //免费次数每日重置
    cwNum: number; //每天参悟首次免费
    fjcons: number; //分解值
}

export interface lishiGZInfo {
    lsid: number; //临时id
    buwei: string; //部位
    id: string; //古字序号
    eps: { [key: string]: number }; //属性
    level: number; //等级
    pinzhi: number; //品质 1-9
    isNew: number; //是不是新的
    isbeibao: number; // 进入背包 0不是 1是
    islock: number; // 是否锁定 0未锁定 1锁定
}

export interface mfInfo {
    level: number; //等级
    step: number; //阶级
    chip: number; //碎片
    mwLock: string[]; //铭文解锁
}

export interface HdInfo<HdData, HdOut> extends HdCfg<HdData> {
    outf: HdOut; //活动个人信息部分输出
}

//化莲
export interface HdHuaLianData {
    need: number[]; //抽一次奖消耗
    prob: number[][]; //抽取的概率[类型,概率]
    itemCall: number[]; //通用字段-道具召回 填道具ID
    chou: {
        [dc1: string]: {
            [dc2: string]: {
                dc1: string; //档次1
                dc2: string; //档次2
                items: number[][]; //抽中道具
                prob: number; //抽中概率
                limit: number; //最大抽中次数0无限
                buzhong: number; //前几次不中
                baodi: number; //保底必中
            };
        };
    };
    task: {
        [dc: string]: {
            dc: string; //档次dc
            kind: string; //活动种类
            need: number; //需要完成进度
            items: number[][]; //抽中道具
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次1，[]中，前面是次数，后面是累积充值
            tiaojian: number[]; //条件
        };
    };
    gift: {
        [dc: string]: {
            dc: string; //档次dc
            title: string; //礼包类型
            need: number[]; //购买所需道具类型及数量
            items: number[][]; //包含道具
            limit: number; //每日限制
        };
    };
    jifen: {
        [dc: string]: {
            dc: string; //档次
            need: number; //所需积分
            items: number[][]; //奖励道具
        };
    };
}

export interface HdHuaLianOut {
    score: number; //抽取积分 用于领取进度奖励
    baodi: {
        //抽取次数
        [dc: string]: number;
    };
    chou1: {
        //普通抽中次数
        [dc: string]: number;
    };
    chou2: {
        //大奖抽中次数
        [dc: string]: number;
    };
    jifen: string[]; //积分档次

    gift: {
        //限时礼包   每日0点重置
        [dc: string]: number;
    };
    task: {
        //任务领取列表  每日0点重置
        [dc: string]: number;
    };
    taskKind: {
        //任务进度  每日0点重置
        [kind: string]: number;
    };

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

//机缘
export interface HdJiYuanData {
    ylun: number; //活动开启时间0点，每30天一轮
    lun: number; //活动开启时间0点，每7天一轮
    ylockGift: {
        [dc: string]: {
            dc: string; //档次id
            title: string; //礼包名称
            need: number[]; //消耗需求
            items2: number[][]; //立即获得
        };
    };
    yxyuan: {
        [dc: string]: {
            dc: string; //档次
            pt: number[][]; //普通品质
            xy: number[][]; //稀有品质
            exp: number; //抽中道具
        };
    };
    lockGift: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包名称
            need: number[]; //消耗需求
            items2: number[][]; //立即获得
        };
    };
    xyuan: {
        [dc: string]: {
            dc: string; //档次
            pt: number[][]; //普通品质
            xy: number[][]; //稀有品质
            exp: number; //抽中道具
        };
    };
    task: {
        [dc: string]: {
            dc: string; //档次
            kind: string; //任务种类
            need: number; //所需积分
            items: number[][]; //奖励道具
            jumpId: number; //跳转
        };
    };
    freeGift: {
        title: string; //礼包名称
        items: number[][]; //立即获得
        show: string; //超值展示
    };
    gift: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包名称
            tiaojian: number[]; //条件：充值在0-60元 可抽取
            need: number[]; //消耗需求
            items: number[][]; //立即获得
            show: string; //超值展示
        };
    };
    giftOver: {
        need: number; //需要购买个数
        items: number[][]; //奖励内容
    };
}

//机缘
export interface HdJiYuanOut {
    lunEat: number; //本轮结束时间
    lockGift: string; //解锁礼包 购买档次
    exp: number; //仙缘积分
    pt: string[]; //已经领取普通奖励档次列表
    xy: string[]; //已经领取稀有奖励档次列表

    ylunEat: number; //本轮结束时间
    ylockGift: string; //解锁礼包 购买档次
    yexp: number; //仙缘积分
    ypt: string[]; //已经领取普通奖励档次列表
    yxy: string[]; //已经领取稀有奖励档次列表

    taskHook: {
        //任务种类 task表
        [kind: string]: number;
    };
    taskdc: string[]; //已经领取档次
    gift: { [dc: string]: number }; //购买礼包（每日重置）
    freeGift: number; //每日免费礼包是否已经领取（每日重置）
    giftOver: number; //购买礼包进度，领取后扣除进度，继续累计进度，下次还可领取
}

//天道轮回
export interface HdLunHuiData {
    dayRwd: number[][]; //每日免费奖励
    needItem: number[]; //消耗什么道具来做任务累计
    list: {
        [dc: string]: {
            dc: string; //档次
            lun: number; //第X轮
            lunBase: number; //本轮基数(上一轮最后一档)
            need: number; //需求消耗
            rwd: number[][]; //奖励
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次
            tiaojian: number[]; //[]中，前面是次数，后面是累积充值
        };
    };
    gift: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包类型
            need: number[]; //购买所需道具类型及数量
            rwd: number[][]; //包含道具
            limit: number; //每日限制
        };
    };
}

export interface HdLunHuiOut {
    //后端输出hdid: string; //活动重置ID
    //已领取 档次
    rwd: {
        [id: string]: number;
    };
    score: number; //积分
    dayRwd: number; //每日白嫖奖励领取了没
    //礼包购买
    gift: {
        [id: string]: number;
    };
    //黑市礼包购买
    hs: {
        [id: string]: number;
    };
    //每日重置
    outTime: number; //每日重算字段

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

//运势玩法
export interface HdYunShiData {
    rwd: {
        [dc: string]: {
            dc: string; //奖品类型
            title: string; //物品名称
            prob0: number; //抽取权重
            kind10: number; //是否触发充值双倍
            limit: number; //几次才会抽中
            item: number[]; //奖励
        };
    };
    dajiang: {
        [dc: string]: {
            dc: string; //档次
            name: string; //名字
            limit: number; //几次才会抽中
            item: number[]; //奖励
        };
    };
    pay: {
        [dc: string]: {
            dc: string; //档次
            prob: number; //抽大奖的概率1W
            need: number[]; //抽取消耗
        };
    };
}

export interface HdYunShiOut {
    dayAt: number; //用于每日重置
    free: number; //拥有次数(免费次数)
    chou: number; //已经抽取次数
    djid: string; //大奖ID
    over: number; //是否抽中大奖 0未抽中 1抽中
    djnum: number; //抽中大奖次数
    nowId: string; //当前抽中的ID
    nowRwd: number; //当前奖励是否已领取 0未领取 1已领取
    ids: {
        //今日已经抽取的id列表
        [id: string]: number;
    };
}

//其他 世家排行信息
export interface RdsClubInfo {
    info: ClubInfo;
    rid: number; //排名
    score: string; //分数
}

//其他 世家排行信息
export interface RdsMentuInfo {
    info: mentu;
    rid: number; //排名
    score: string; //分数
    // 归属玩家
    user: FUserInfo;
}

// 新手礼包2
export interface HdNewHand2Data {
    buyShow: number; //全部购买显示折扣
    show: number; //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    buyAll: number[]; //合集礼包第一档全部购买的价格
    buyAllDc: string[]; //合集礼包第一档全部购买的礼包档次
    buytitle: string; //礼包标题
    popup6: string; // 一个弹6元的品质
    popup30: number; //一个弹30元的等级
    type: {
        [id: string]: {
            id: string; //类型id
            lv: number; //弹出优先级
            duration: number; //有效期0永久
            cd: number; //冷却间隔0无
        };
    };
    list: {
        [id: string]: {
            id: string; //档次id
            title: string; //礼包名称
            dc: string[]; //档次合集（数组的位数代表后续档次）
            type: number; //礼包类型
        };
    };
    dcKu: {
        [id: string]: {
            id: string; //档次
            title: string; //礼包名称
            need: number[]; //单个买的价格
            rwd: string[]; //每天的奖励（数组的位数代表天数）
            icon: string; //顶图图标
            pctImg: string; //价值百分比图
        };
    };
    rwdKu: {
        [id: string]: {
            id: string; //档次
            items: number[][]; //奖励
        };
    };
}



export interface HdNewHand2Out {
    // 当前生效的档次id
    list: {
        [dc: string]: {
            //已领取奖励天数
            day: number;
            //累计登陆了几天
            loginDay: number;
        };
    };

    // 当前合集礼包的dc
    colPackage: string[];

    // 弹出情况
    popup: {
        // 礼包类型id
        [id: string]: {
            // 最后一次弹出时间
            time: number;
        };
    };
}

//每日签到 新手礼包三天
export interface HdNewHandData {
    buyAll: number[]; //新手礼包全部购买的价格
    buyAllDc: string[]; //新手礼包全部购买的档次
    buyShow: number; //全部购买显示折扣
    buytitle: string; //礼包标题
    show: number; //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    list: {
        [dc: string]: {
            dc: string; //档次id
            imgTips: string; //文字提示,比如开启自动开鼎 配置空字符串代表不显示
            title: string; //礼包名称
            need: number[]; //需要完成进度
            days: string[]; //档次（数组的位数代表天数）
            showid: string; //预览id
            tier: number; //礼包层级
            next: string; //下一层礼包
            last: string; //上一层礼包
        };
    };
    days: {
        [dc: string]: {
            dc: string; //档次
            need: number; //需要消耗物品
            items: number[][]; //配置装备的话，第四个参数填写图片ID 如果图片有下划线，配第五个参数
        };
    };
}

export interface HdNewHandOut {
    dc: {
        [dc: string]: {
            day: number; //已领取奖励天数
            loginDay: number; //累计登陆了几天
        };
    }; //当前已购买的的档位:奖励领到第几天
    isWin: number; //是否弹窗
}

//限时福利()
export enum TimeBenType {
    daDiGuZi_guZi = "daDiGuZi_guZi", // 大帝古字-抽取古字道具不足
    daDiGuZi_shuFaChouQu = "daDiGuZi_shuFaChouQu", // 大帝古字-抽取术法道具不足
    daDiGuZi_shuFaShengJi = "daDiGuZi_shuFaShengJi", // 大帝古字-升级术法道具不足
    zhenWen = "zhenWen", // 阵法-抽取阵纹道具不足
    daoWen_jieFeng = "daoWen_jieFeng", // 道纹-解封道纹道具不足
    daoYou_zengLi = "daoYou_zengLi", // 道友-赠礼道具不足
    diZi_zhaoMu = "diZi_zhaoMu", // 弟子-招募道具不足
    shouLing_shengJi = "shouLing_shengJi", // 兽灵-升级道具不足
    shouLing_xunHua = "shouLing_xunHua", // 兽灵-驯化道具不足
    yiXiang_shengJi = "yiXiang_shengJi", // 异象-升级道具不足
    zhanFa_waiXing = "zhanFa_waiXing", // 阵法-外形道具不足
    diZi_ZhongJizhaoMu = "diZi_ZhongJizhaoMu", //弟子-招募橙色品质弟子专属
    diZi_GaoJizhaoMu = "diZi_GaoJizhaoMu", //弟子-招募红色品质弟子专属
    yaoTian_zhongZhi = "yaoTian_zhongZhi", // 药田种植道具不足
    yaoTian_shiFei = "yaoTian_shiFei", // 药田施肥道具不足
    taiChu_JianZuiQiao = "taiChu_JianZuiQiao", // 太初古矿道具不足
    zhenFa_zhaoMu = "zhenFa_zhaoMu", // 阵法招募道具不足
    zongMen_energy = "zongMen_energy", // 宗门-灵力不足
    fumo = "fumo", // 附魔-附魔道具不足
}

//伙伴限时礼包
export enum HuoBanGiftType {
    mid_level = "mid_level", //弟子-招募橙色品质弟子专属
    high_level = "high_level", //弟子-招募红色品质弟子专属
    newHand = "newHand", // 购买新手礼包
}

export interface HdHuoBanGiftData {
    // 礼包类型列表
    list: {
        [type: string]: {
            type: string; //礼包类型
            isDown: number; //是否降档
            showLimit: number; //触发次数限制
            cd: number; //消失时间
            nextcd: number; //同类型 消失后 触发CD
            dcList: string[]; //礼包列表
        };
    };

    // 具体礼包列表
    dcList: {
        [dc: string]: {
            dc: string; //礼包档次
            title: string; //礼包名称
            need: KindItem; //消耗
            rwd: KindItem[]; //奖励
            chip: number; //伙伴碎片数量
            prec: number;  //前端折扣展示
        };
    };
}

export interface HdHuoBanGiftOut {
    resetTime: number; //每日重算字段

    // 礼包列表
    list: {
        [type: string]: {
            dc: string; //当前礼包档次
            endTime: number; //过期时间
            nShow: number; //今日弹出次数
            buyTime: number; //最后一次购买时间
        };
    };

    huoBan: {
        [type in HuoBanGiftType]: string; // 伙伴品质，伙伴id
    };
}

export interface HdTimeBenData {
    listNew: {
        [TimeBenType: string]: {
            TimeBenType: string; //礼包类型
            type: number; //升降级礼包
            show: number; //触发次数限制
            cd: number; //消失时间
            nextcd: number; //同类型 消失后 触发CD
            dclist: string[]; //档次列表
        };
    };
    dclist: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包名称
            need: number[]; //需要消耗物品
            rwd: number[][]; //奖励
            hbsl: number; //伙伴碎片数量
            prec: number; //折扣
        };
    };
}

export interface HdTimeBenOut {
    nowType: TimeBenType | null; //当前生效礼包
    otime: number; //当前生效礼包 过期时间

    //每日刷新时间
    outTime: number; //每日重算字段
    //改后字段
    newList: {
        [type: string]: {
            dc: string; //当前礼包档次
            otime: number; //生效过期时间
            show: number; //今天弹出次数 0 开始
            buyTime: number; //最后一次购买时间
        };
    };
    dizi: {
        [pinzhi: string]: string; // 弟子品质，弟子id
    };
}

//弟子活动（兽灵起源）
export interface HdDiZiData {
    need: number[]; //抽一次奖消耗
    itemCall: number[]; //通用字段-活动结束后删除道具 填道具ID
    hdRankKey: string; //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    item_z: number[]; //积分道具
    item_g: number[]; //解锁格子道具
    item_num: number[]; //招募一个弟子给的道具
    task1: {
        [dc1: string]: {
            dc1: string; //档次1
            sort: number; //排序
            kind: number; //任务类型
            need: number; //需求
            rwd: number[][]; //奖励
        };
    };
    task2: {
        [dc1: string]: {
            dc1: string; //档次1
            sort: number; //排序
            kind: number; //任务类型
            need: number; //需求
            rwd: number[][]; //奖励
        };
    };
    tree: {
        list: string[]; //档次id
        quick_nd1: number[][]; //速战需求
        scoreTimeMax: number; //积分时间累计上限
        zzProb: number; //起源之证掉落概率系数
    };
    list: {
        [pzid: string]: {
            pzid: number; //流派ID
            title: string; //星球名称
            open_nd: number[]; //解锁消耗
            make: string[]; //产出
        };
    };
    make: {
        [dc: string]: {
            dc: string; //档次
            item: number[]; //产出详情积分[空，异系，同系]
            levelItem: number[][]; //等级产出积分[等级，等级，产出]
            starItem: number[][]; //星级级产出积分[星级，星级，产出]
            zItem: number[]; //产出起源之征[空，异系，同系],个数乘以一万
            levelZItem: number[][]; //等级产出起源之征[等级，等级，产出]产出个数乘以一万
            starZItem: number[][]; //星级产出起源之征[星级，星级，产出]产出个数乘以一万
        };
    };
    round: {
        rwd: string[]; //奖励列表
        z1bdMax: number; //组1保底
        z1bdMin: number; //组1暗杠
        z1bd2tid: string; //组1的2次保底道具（填入奖励内容的索引）
        z2bdMax: number; //组2保底
        z2bdMin: number; //组2暗杠
        z2bd2tid: string; //组2的2次保底道具
    };
    rwd: {
        [dc: string]: {
            dc: string; //档次
            prob: number; //本组概率 万分比
            overTo: string; //本组抽完 概率给这组
            title: string; //组名
            sort: number; //组排序
            item: string[]; //奖励内容
        };
    };
    item: {
        [dc: string]: {
            dc: string; //档次
            prob: number; //概率
            item: number[]; //内容
            limit: number; //限制次数
            sort: number; //转盘显示位置
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次
            tiaojian: number[]; //[]中，前面是次数，后面是累积充值
        };
    };
    gift: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包名称
            need: number[]; //需求
            rwd: number[][]; //礼包内容
            limit: number; //限制
            dayLimit: number; //每日限制
        };
    };
    hdRank: {
        pm: number[]; //排名范围
        items: number[][]; //奖励内容
    }[];
}

export interface HdDiZiOut {
    //后端输出
    // hdid: string; //活动重置ID
    //额外道具表
    // item1: number; //[1,914,10] [起源仙尘] +活跃任务  -树速战 -树开格子
    // item2: number; //[1,915,10] [起源之证] +探索任务 +树掉落  -轮盘抽奖
    score: number; //[1,916,10] 排行积分 +树掉落

    rwds1: {
        //活跃任务
        [id: string]: number; // 已领取档次
    };
    rwds2: {
        //探索任务
        [id: string]: number; // 已领取档次
    };
    hook: {
        //完成进度 (公用)
        [kind: string]: number;
    };

    //树
    tree: {
        //格子行
        list: {
            [pzid: string]: {
                //品质下标
                open: number; //开了几个格子
                dzList: {
                    [gzid: number]: string; //格子ID => 法阵ID
                };
            };
        };
        s_num: number; //当前累计[积分]
        s_time: number; //[积分] 结算时间点
        z_num: number; //当前起源之征累计（实际个数除以10000）
    };

    //转盘
    round: {
        totol: {
            //总奖励统计
            [id: string]: number;
        };
        z1Bd: number; //组1保底累计
        z2Bd: number; //组2保底累计
    };
    //礼包购买
    gift: {
        [id: string]: number;
    };
    //礼包购买 日限购
    giftDay: {
        [id: string]: number;
    };
    //每日重置
    outTime: number; //每日重算字段
    //排行奖励领取控制
    //排行榜红点?

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

// 弟子概率提升up
export interface HdHuoBanUpData {
    continueTime: number   //每一期持续时间（单位：天）
    chipProb: number[][]   //通用碎片概率。如果常规池子没有活动碎片的情况下
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    list: {
        [id: string]: {
            id: string  //唯一索引
            up: number[]  //当期up
            chipUp: number  //当期碎片up
            prob: number  //提升概率（万分比）
        }
    }
    drawRwd: {
        [id: string]: {
            id: string  //唯一索引
            upId: string  //当期up
            need: number  //招募数需求
            rwd: number[]  //奖励
        }
    }
}


export interface HdHuoBanUpOut {
    curPhase: string; // 当前的期数
    drawTimes: number; // 当前的招募次数
    rwd: { [id: string]: number }; // 当前的领取情况
    phases: {
        id: string; // 期数
        startAt: number; // 开始时间（整天时间戳）
        endAt: number; // 结束时间（整天时间戳）
    }[]; // 当前期及未来七期的时间范围
}

export interface ActZhenfa {
    fangan: string; //方案列表
    chuan: {
        [buwei: string]: {
            pfid: string; //皮肤ID(阵服ID)
            level: number; //法阵等级
            eps: { [key: string]: number }; //法阵属性
            fmLv: number; //附魔等级
            fmBd: number; //附魔绑定1绑定 0没有绑定
            fmEps: [string, number][]; //[属性key，属性值]附魔属性
            fmZhBd: number[]; //附魔转换绑定下标id第一位为0
            fmZhls: [string, number][]; //附魔转换临时属性
            pinzhi: string; //品质
        };
    };
    lsList: {
        //临时列表
        [xhid: string]: {
            xhid: string;
            pfid: string; //法阵ID
            level: number; //法阵等级
            eps: { [key: string]: number }; //法阵属性
            isNew: number; //1新0旧
            pinzhi: string; //品质
        };
    };

    count: number; //已经抽取次数选择哪个下标id
    czpf: {
        //抽中皮肤次数
        [pfid: string]: number;
    };
    time: number; //每日刷新
    fmCount: number; //附魔次数

    level: number; //等级
    exp: number; //经验
    upType: number; //0:未进阶  1：进阶中
    endAt: number; //完成进阶截止时间
    zhuli: number; //是否可助力1可助力
    kind11At: number; //下次可看广告时间
}

export interface ActZhenfaNew {
    fangan: string; //方案列表
    chuan: {
        [buwei: string]: {
            pfid: string; //皮肤ID(阵服ID)
            level: number; //法阵等级
            eps: { [key: string]: number }; //法阵属性
            fmLv: number; //附魔等级
            fmBd: number; //附魔绑定1绑定 0没有绑定
            fmEps: [string, number][]; //[属性key，属性值]附魔属性
            fmZhBd: number[]; //附魔转换绑定下标id第一位为0
            fmZhls: [string, number][]; //附魔转换临时属性
            pinzhi: string; //品质

            // 洗炼
            xilianEps: { [pos: string]: { isLock: number; id: string } }; //洗炼属性 {位置id，属性词条id}
            xilianEpsTemp: { [pos: string]: string }; //洗炼刷新属性临时存放 {位置id，属性词条id}
        };
    };
    count: number; //已经抽取次数选择哪个下标id
    czpf: {
        //抽中皮肤次数
        [pfid: string]: number;
    };
    time: number; //每日刷新
    fmCount: number; //附魔次数

    level: number; //等级
    exp: number; //经验
    upType: number; //0:未进阶  1：进阶中
    endAt: number; //完成进阶截止时间
    zhuli: number; //是否可助力1可助力
    kind11At: number; //下次可看广告时间

    // 阵法
    zmScore: number; //招募积分
    zmCount: number; // 今日招募次数
    zfChuan: string; // 穿戴的阵法
    zfList: {
        // 阵法列表
        [zfid: string]: {
            level: number; // 等级
            step: number; //阶级
        };
    };
    zfBaodi: number; // 保底次数
    zfZuojia: number; // 作假
    kind11Count: number; //今日广告招募次数
}

export interface ActZhenfaNewLs1 {
    count: number;
    pfid: string; //最高品质对应的法阵ID
    pinzhi: string; //最高品质
    isbg: number; //是否进背包 1是 0否(卖)
    items: KindItem[]; //掉落道具
}

export interface ActZhenfaNewLs2 {
    xhid: string;
    pfid: string; //法阵ID
    level: number; //法阵等级
    eps: { [key: string]: number }; //法阵属性
    pinzhi: string; //品质
    isNew: number; //1新0旧  2优先处理
}

export interface ActZhenfaNewBag {
    xhid: string;
    pfid: string; //法阵ID
    level: number; //法阵等级
    eps: { [key: string]: number }; //法阵属性
    pinzhi: string; //品质
}

export interface ActZhenfaList {
    list: string[];
}

export interface ActShouLing {
    // list: {
    //     [gzId: string]: {
    //         slid: string; //兽灵ID
    //         level: number; //兽灵等级
    //         star: number; //星级
    //         step: number; //觉醒阶级
    //         sk: {
    //             skillId: string;
    //             lv: number;
    //         };
    //         skPg: string; //兽灵普通攻击技能id
    //         skBd: {
    //             //被动技能
    //             [caoId: string]: {
    //                 skillId: string;
    //                 lv: number; //等级
    //                 lock: number; //1锁定0未锁
    //             };
    //         };
    //     };
    // };
    // gzId: string; //格子的序号
    jiban: {
        //羁绊列表
        [jbid: string]: {
            level: number;
        };
    };
    shouling: { [slid: string]: number }; //兽灵星级
    useGzId: {
        //出战id：格子id 0主站 1 助战1 2 助战2
        [czid: string]: string;
    };
    cqIds: {
        slid: string;
        jihuo: number;
    }[]; //当前抽取到的兽灵Id列表 是否已购买 0未激活 1 已激活
    mubiao: string; //玩家可以红品兽灵中选择1只作为目标兽灵。
    mbNum: { [pinzhi: string]: number }; //刷新出N次目标兽灵。
    kind11: number; //今日看广告次数
    pttqBaodi: number; //特权保底抽取次数
    xilian: string; //记录洗炼的兽灵gzid
    xilianSk: {
        //洗炼技能库 暂时存储
        [caoId: string]: {
            skillId: string;
            lv: number; //等级
            lock: number; //1锁定0未锁
        };
    };
    slPower: number;  //兽灵战力
    chouquSettings: { //抽取配置
        savepz: 0 | 1, //是否勾选保留
        pinzhi: string,//需要保留的品质
        savesl: 0 | 1,//是否勾选保留
        slids: string[],//需要保留的灵兽IDs
    }
}
export interface ActShouLing_ListOne {
    slid: string; //兽灵ID
    level: number; //兽灵等级
    star: number; //星级
    step: number; //觉醒阶级
    sk: {
        skillId: string; //技能ID
        lv: number; //技能等级
        step: number; //觉醒阶级
    };
    skPg: string; //兽灵普通攻击技能id
    skBd: {
        //被动技能
        [caoId: string]: {
            skillId: string;
            lv: number; //等级
            lock: number; //1锁定0未锁
        };
    };
    skin: string; //穿戴的的皮肤
    skins: {
        [id: string]: { //皮肤ID
            level: number,//等级
            type?: number, //0:通用道具激活 1:指定道具激活
            cost1: number,//通用道具消耗
            cost2: number//指定道具消耗
        },
    };
}

// 法则
export interface ActFaze {
    // 存储格
    slots: {
        [key: string]: {
            faze: faze | null;
            locked: 1 | 0;  // 0 未锁定 1 已锁定
            type: slotType // 主、辅1、辅2、普通格子   
        }
    };

    freeHulu_lastTime: number  // 免费葫芦最后一次恢复的时间戳
}

interface faze {
    id: string;
    level: number;
    // 星级
    starLv: number;
    // 凝元等级
    ningyuanLv: number;
    // 是否锁定
    locked: 0 | 1;

    exp: number; // 经验
}

type slotType = "main" | "assist1" | "assist2" | "normal";

//兽灵活动(破除心魔)
export interface HdShouLingData {
    dayTaskNum: number   //每天刷几个任务
    stime: number   //多少秒后获得1个挑战印记
    pmNeed: number[]   //破魔 需要的 镇灵符数量
    reNeed: number[]   //刷新 需要的道具
    dayFree: number   //每天免费刷新次数
    hdRankKey: string   //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    chushi: number   //活动初始给三个道具
    scoreItem: number[]   //兽灵活动加积分道具
    itemCall: number[]   //通用字段-活动结束后删除道具 填道具ID
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    reNeed2: number[]   //刷新 需要的货币
    pmNeed2: number[]   //破魔 需要的 镇灵符数量(不上阵兽灵）
    dazhe: number   //活动期间，驯化兽灵的折扣（万分比）
    task: {
        [dc: string]: {
            dc: string  //档次1
            kind: string  //任务类型
            need: number  //需要次数
            rwd: number[][]  //奖励
        }
    }
    shouling: {
        [dc: string]: {
            dc: string  //档次dc
            title: string  //活动种类
            prob: number  //刷出概率
            tnum: number  //阵法人数
            rwd: number[][]  //破魔奖励
            score: number[]  //积分上下限
        }
    }
    sMath: {
        [pz: string]: {
            pz: number  //档次1，[]中，前面是次数，后面是累积充值
            xishu: number[]  //系数
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次id
            title: string  //礼包类型
            need: number[]  //购买所需道具类型及数量
            rwd: number[][]  //包含道具
            limit: number  //限制
            dayLimit: number  //每日限制
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //条件  累积充值
        }
    }
    hdRank: {
        pm: number[]  //排名范围
        items: number[][]  //奖励内容
    }[]
    zyRwd: {
        [dc: string]: {
            dc: number  //档次id
            need: number  //镇压次数  
            rwd: number[]  //奖励
        }
    }
}


//兽灵配置
export interface HdShouLingData_shoulingCfg {
    title: string; //兽灵名字
    prob: number; //刷出概率
    tnum: number; //阵法人数
    rwd: KindItem[]; //破魔奖励
    score: [number, number]; //积分上下限
}

export interface HdShouLingOut {
    item: number; //镇灵符 数量 //灵石
    itemTime: number; //镇灵符 上次刷新时间
    score: number; //积分
    payscore: number; //累充积分
    task: {
        //任务
        [id: string]: number; // 领取时间
    };
    hook: {
        //完成进度 (公用)
        [kind: string]: number;
    };
    //已经用过的兽灵列表 //今日
    dieFz: {
        [gzid: string]: number;
    };
    dayFree: number; //今天已用的免费刷新次数
    //当前兽灵
    shouling: {
        [id: number]: {
            //序号 1开始
            slid: string; //心魔ID
            die: number; //被杀时间
        };
    };
    //礼包购买
    gift: {
        [id: string]: number;
    };
    //礼包购买 日限购
    giftDay: {
        [id: string]: number;
    };
    //充值积分奖励领取记录
    payRwd: {
        [id: string]: number;
    };
    //每日重置
    outTime: number; //每日重算字段

    bugNum: number; //购买次数
    bugCons: number; //购买金额
    zyCount: number; // 镇压次数
    zyRwd: {
        [id: string]: number // 镇压领取状态
    }
}

//道纹活动
export interface HdDaoWenData {
    dwcqScore: number   //抽取道纹获得积分
    hdRankKey: string   //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    chouScore: number[]   //抽奖获取的积分范围
    chouNeed: number[]   //抽奖消耗道具
    scoreItem: number[]   //道纹积分道具
    itemCall: number[]   //通用字段-活动结束后删除道具 填道具ID
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    bigRwdMax: number   //X次必出大奖
    bigRwdMin: number   //x次后可能出现大奖
    bigRwdJL: number[]   //x次后[大奖的几率,普通的几率]
    chouItemMax: number[][]   //大奖列表
    chouItemMin: number[][]   //普通列表
    bigRwdBd: number[]   //大奖出货限制[前x次没出下一次,必出大奖下标索引]
    task2: {
        [dc1: string]: {
            [dc2: string]: {
                dc1: string  //档次1
                dc2: string  //档次2
                sort: number  //排序
                kind: string  //任务类型
                need: number  //需求
                rwd: number[][]  //奖励
            }
        }
    }
    scoreRwd: {
        [dc: string]: {
            dc: number  //档次id
            need: number  //积分需求  
            rwd: number[]  //奖励
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //条件  累积充值
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次
            title: string  //礼包名称
            need: number[]  //需求
            rwd: number[][]  //礼包内容
            limit: number  //限制
            dayLimit: number  //每日限制
        }
    }
    hdRank: {
        pm: number[]  //排名范围
        items: number[][]  //奖励内容
    }[]
}


export interface HdDaoWenOut {
    score: number; //积分
    task: {
        //任务 kind领取了多少次
        [kind: string]: number; //这个任务领了多少次
    };
    hook: {
        //完成进度 (公用)
        [kind: string]: number;
    };
    //积分奖励领取记录
    scRwd: {
        [id: string]: number;
    };
    //礼包购买
    gift: {
        [id: string]: number;
    };
    //礼包购买 日限购
    giftDay: {
        [id: string]: number;
    };
    //每日重置
    outTime: number; //每日重算字段
    taskid: string; //前端读取哪天任务

    bugNum: number; //购买次数
    bugCons: number; //购买金额
    bdCount: number; // 保底次数
}

//术法活动
export interface HdShuFaData {
    scoreItem: number[]; //术法积分道具（单次抽取术法获得的道具）
    jifen: {
        [dc: string]: {
            dc: string; //档次
            need: number; //所需积分
            items: number[][]; //奖励道具
        };
    };
    task: {
        [dc: string]: {
            dc: string; //档次dc
            kind: string; //活动种类
            need: number; //需要完成进度
            items: number[][]; //抽中道具
        };
    };
    gift: {
        [dc: string]: {
            dc: string; //档次dc
            title: string; //礼包类型
            need: number[]; //购买所需道具类型及数量
            rwd: number[][]; //包含道具
            limit: number; //总限制购
            dayLimit: number; //每日限购
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次1，[]中，前面是次数，后面是累积充值
            tiaojian: number[]; //条件
        };
    };
    hdRank: {
        pm: [number, number]; //排名区间
        items: number[][]; //奖励
    }[];
}

export interface HdShuFaOut {
    score: number; //抽取积分 用于领取进度奖励
    jifen: string[]; //积分档次
    gift: {
        //限时礼包   每日0点重置
        [dc: string]: number;
    };
    giftDay: {
        //礼包每日限购
        [dc: string]: number;
    };
    task: {
        //任务领取列表  每日0点重置
        [dc: string]: number;
    };
    taskKind: {
        //任务进度  每日0点重置
        [kind: string]: number;
    };
    bugNum: number; //术法礼包购买次数
    bugCons: number; //术法礼包购买金额
}

export interface HdNewYearPrayData {
    lotProb: number; //训练出现福签的概率 基数10000
    draw: number[]; //抽奖道具-红封
    unRepeat: number; //前多少抽不限制重复逻辑,允许玩家随机获得
    hdRankKey: string; //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    lots: {
        [dc: string]: {
            dc: string; //档次
            item: number[]; //内容
            prob: number; //概率
            dayLimit: number; //每日限制
        };
    };
    lotRwds: {
        [dc: string]: {
            dc: string; //档次
            items: number[][]; //内容
            score: number; //概率
        };
    };
    messageMustNum: {
        [dc: string]: {
            dc: string; //档次
            baodi: string; //概率
        };
    };
    messageRwds: {
        [dc: string]: {
            dc: string; //档次
            newNum: number; //出新词条的保底
            repeat: number; //达到保底前,必定获得重复的次数
            score: number; //概率
            weight: number; //配置初始化权重
            items: number[][]; //内容
        };
    };
    messages: {
        [dc1: string]: {
            [dc2: string]: {
                dc1: string; //档次1
                dc2: string; //档次2
                title: string[]; //概率
            };
        };
    };
    collect: {
        [dc: string]: {
            dc: string; //档次
            col: number; //概率
            item: number[]; //内容
        };
    };
    tasks: {
        [dc1: string]: {
            dc1: string; //档次1
            kind: string; //任务类型
            list: string[]; //任务详情
        };
    };
    list: {
        [dc: string]: {
            dc: string; //档次1
            need: number; //需求
            items: number[][]; //奖励
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次
            tiaojian: number[]; //条件  累积充值
        };
    };
    gifts: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包名称
            need: number[]; //需求
            items: number[][]; //礼包内容
            limit: number; //限制
        };
    };
    hdRank: {
        pm: number[]; //排名范围
        items: number[][]; //奖励内容
    }[];
}

export interface HdNewYearPrayOut {
    collectState: { [id: string]: number };
    gift: { [id: string]: number }; //礼包购买
    giftDay: { [id: string]: number }; //礼包购买
    score: number;
    // 收集数
    collectNum: number;
    // 祝福语收集详细情况
    allCollect: { [id: string]: { [id: string]: number } };
    tasks: { [id: string]: string[] }; // 任务进度 档次： 已经领取的子档次列表
    taskHook: { [kind: string]: number }; //完成进度

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

export interface SevNewYearPrayMessage {
    // 祝福语奖池
    pool: { [id: string]: number };
}

export interface HdJieQiData {
    hdName: string   //活动名称
    hdRankKey: string   //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    itemCall: number[]
    need: number[]   //每次消耗
    onetouchUnlock: number
    dayTaskNum: number //每天刷的任务数量
    ext: number[]   //扩展字段：[大于等于活动x轮次货币兑换打折,打y折]
    ext_yixiang: string[]   //yixiang(异象)扩展字段：[受影响的yixiangId1,受影响的yixiangId2]
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    ceng: {
        [id: string]: {
            id: string  //层数
            pos: number[] //石头的位置（一行一行）
            hasSelect: number  //是否有自选大奖
            items: number[][]  //大奖的固定奖励
            ptList: number[][]  //普通奖励权重列表
            up: number  //触发升品的概率
            upStep: number[][];  // 升品阶段概率和倍率系数 [等级,概率(万分比),倍率]
            gailv: number[]; //普通奖励概率，前端显示用
            fbaodi: number  //反向保底。必不出
        }
    }
    achv: {
        [dc: string]: {
            dc: string  //档次dc
            need: number  //需要完成进度
            items: number[][]  //道具
        }
    }
    dajiang: {
        [id: string]: {
            id: string  //序号
            count: number  //大奖次数要求
            item: number[]  //大奖
            limit: number //限制次数
            xd: number //是否是限定奖励
        }
    }
    task: {
        [id: string]: {
            id: string  //档次dc
            kind: string  //活动种类
            need: number  //需要完成进度
            items: number[][]  //完成奖励
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次dc
            title: string  //礼包类型
            need: number[]  //购买所需道具类型及数量
            rwd: number[][]  //包含道具
            limit: number  //每日限制
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //条件  累积充值
        }
    }
    hdRank: {
        pm: number[]  //排名范围
        items: number[][]  //奖励内容
    }[]
}



export interface HdJieQiOut {
    task: {
        //任务领取列表  每日0点重置
        [id: string]: number;
    };
    taskKind: {
        //任务进度  每日0点重置
        [kind: string]: number;
    };
    gift: {
        //限时礼包   每日0点重置
        [dc: string]: number;
    };

    achv: {
        //成就  
        [id: string]: number;
    };

    // 选择的大奖
    prizeByCeng: {
        [cengId: string]: string;
    }; // key: 层id, value: 大奖id

    // 记录获得大奖的次数
    dajiang: {
        [id: string]: number;
    }


    chouAll: number; //抽奖总次数
    curCeng: string; //当前层
    trueCeng: string; //真实层
    // 当前层的初始奖励
    curRwd: KindItem;
    // 当前层的奖励等级

    // 当前奖励的品质
    //达到7就可以通关下一层
    curRwdPz: number;
    // 当前奖励的倍率
    curRwdLv: number;
    // 记录升级情况
    curRwdUp: number[]
    //当前开的格子id
    curId: string;
    isPass: number; // 当前层是否通关
    grid: {
        [id: string]: number;
    }; //当前层的格子情况  1: 开启状态 0或者null: 关闭状态

    // 当前是否触发升级 
    isUp: number;

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

export interface HdJieQiDataOut {
    // 记录参与的轮次
    nRound: {
        [hdcid: string]: number;
    }

}

//青龙贺岁
export interface HdQingLongData {
    zoneNum: number; //每X个服务器为一个赛区
    djWeight: number[]; //大奖配置概率
    costItem1: number[]; //消耗的道具
    luck: number; //幸运值上限
    costItem2: number[]; //消耗的道具
    tzWeight: number[]; //套装配置概率
    dailyTaskNum: number; //每天重置的任务
    dj: {
        [dc: string]: {
            dc: number; //档次dc
            unlock: number; //需要完成进度
            rwd: number[]; //抽中道具
            prob: number; //概率
            limit: number //限制
        };
    };
    rwdPool1: {
        rwd: number[]; //奖励配置
        prob: number; //权重
    }[];
    rwdPool2: {
        rwd: number[]; //奖励配置
        prob: number; //权重
        times: number; //前N次抽奖不出大奖
        id: number; //奖励的唯一标识
    }[];
    loginRwd: {
        [dc: string]: {
            dc: string; //档次dc
            rwd: number[][]; //抽中道具
        };
    };
    task: {
        [dc1: string]: {
            dc1: string; //档次1
            kind: string; //任务类型
            dc: string[]; //任务详情
        };
    };
    dc: {
        [dc: string]: {
            dc: string; //档次1
            need: number; //需求
            rwd: number[][]; //奖励
        };
    };
    ycgift: {
        [dc: string]: {
            dc: string; //档次1，[]中，前面是次数，后面是累积充值
            tiaojian: number[]; //条件
        };
    };
    gift: {
        [dc: string]: {
            dc: string; //档次dc
            title: string; //礼包类型
            need: number[]; //购买所需道具类型及数量
            items: number[][]; //包含道具
            limit: number; //每日限制
        };
    };
}



export interface ClickWin {
    type: number // 1退出 2解散
    kid: string  //模块kid
    hdcid: string  //模块分组ID
}


export interface ActTaoBao {
    xwid: number  //淘宝关键行为ID
}

//青龙贺岁 - 奖励信息
export interface HdQingLongRwdInfo {
    prob?: number; //权重
    unlock?: number; //解锁的次数
    rwd?: number[]; //
    dc?: number; //奖励的唯一标识
}

//青龙贺岁 - 后端输出信息
export interface HdQingLongOut {
    hdid: string; //活动ID
    times: number; //一元复始大奖的获取次数
    times2: number; //青龙贺岁总抽取次数
    djId: string; //大奖ID
    luck: number; //幸运值
    gift: { [id: string]: number }; //礼包购买
    giftDay: { [id: string]: number }; //礼包购买
    outTime: number; //活动结算时间
    loginRwds: { [day: string]: number }; //签到领取表
    days: number; //累计登录天数
    task: { [id: string]: string[] }; // 任务进度 档次： 已经领取的子档次列表
    hook: { [kind: string]: number }; //完成进度
    finish: number; //活动结束标识
    //每日重置任务 如：10选5个任务类型 每个任务类型选择一条任务
    dailyTask: {
        [dc: string]: { kind: string; dc: { [id: string]: { need: number; rwd: KindItem[] } } };
    };

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

//青龙贺岁 - 限量奖励后端输出信息
export interface HdQingLongRwdOut {
    hdid: string; //活动重置ID
    logs: LogInfo[];
    rwdPool: {
        //奖励ID ：剩余次数
        [itemId: number]: number;
    };
}
//青龙贺岁 - 跨服信息
export interface SevQingLongHeSui {
    hdid: string; //活动重置ID
    list: {
        //本合服ID => 跨服ID
        [sid: string]: string;
    };
}
export interface LogInfo {
    itemId: number;
    user?: FUserInfo;
    uuid: string;
    time: number;
}

//赏花觅宝
export interface HdShangHuaData {
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    taobao: {
        dajiang: string[]  //大奖  
        putong: string[]  //普通奖励
        need: number[]  //每次消耗道具
        get1: number[]  //月宫积分范围
        get2: number[]  //满月值范围
        maxMy: number  //最大满月值 
        showdj: number  //前端展示基础大奖概率
        djProb: number[][]  //抽大奖概率
    }
    dajiang: {
        [dajiang: string]: {
            dajiang: string  //档次dc
            item: number[]  //奖励
            limit: number  //限制
            count: number  //大奖次数要求
            xd: number  //是否是限定奖励
        }
    }
    putong: {
        [putong: string]: {
            putong: string  //档次dc
            item: number[]  //奖励
            prob: number  //权重
        }
    }
    baoge: {
        [dc: string]: {
            dc: string  //档次dc
            need: number[]  //兑换消耗
            items: number[][]  //兑换奖励
            limit: number  //兑换次数
            get1: number  //解锁所需积分
        }
    }
    task: {
        [dc: string]: {
            dc: string  //档次dc
            kind: string  //任务类型
            need: number  //任务需求
            items: number[][]  //任务奖励
        }
    }
    leiji: {
        [dc: string]: {
            dc: string  //档次dc
            need: number  //任务需求
            items: number[][]  //任务奖励
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次1，[]中，前面是次数，后面是累积充值
            tiaojian: number[]  //条件
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次
            title: string  //礼包名称
            need: number[]  //需求
            rwd: number[][]  //礼包内容
            dayLimit: number  //每日限制
        }
    }
}





export interface HdShangHuaOut {
    dajiang: {
        //抽中大奖的次数
        [dc: string]: number;
    };
    djid: string; //选择的大奖ID
    get1: number; //月宫积分
    get2: number; //满月值
    baoge: {
        //月宫宝阁 兑换次数
        [dc: string]: number;
    };
    task: {
        //任务领取列表  每日0点重置
        [dc: string]: number;
    };
    taskKind: {
        //任务进度  每日0点重置
        [kind: string]: number;
    };
    gift: {
        //限时礼包   每日0点重置
        [dc: string]: number;
    };
    sign: string[]; //签到  存放档次ID
    chouAll: number; //抽取次数
    leiji: {
        //领取的档次列表
        [dc: string]: number;
    };
    hday: number; //活动开启第几天

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

export interface Paoma {
    pmid: string; //跑马灯id
    cs: any[]; //跑马灯参数
}

export enum ChannelType {
    hefu = "hefu", //合服
    all = "all", //所有服
    club = "club", //世家
    kua = "kua", //跨服
    zongMen = "zongMen", //宗门跨服
    zudui = "zudui", // 组队
    zhaomu = "zhaomu", // 组队招募
    hdClubPk = "hdClubPk", // 仙盟混战
}

export interface ChatInfo {
    id: number; //聊天编号ID
    type: ChatType; //聊天类型
    fuuid: string; //玩家ID
    fuser?: FUserInfo; //玩家信息
    zudui?: ZuduiChat; //玩家信息
    msg: string; //消息体
    time: number; //时间
}

export enum ChatType {
    moren = "1", //默认基础聊天
    moon = "moon", //购买月卡
    adver = "adver", //购买免广告卡
    fever = "fever", //购买终身卡
    zhuli = "zhuli", //助力
    zudui = "zudui", //组队
    time = "time", //时间
    clubQuestBoss = "clubQuestBoss", //世家悬赏boss
}

//聊天模块
export interface Chat {
    club: UpList<{ [xbid: string]: ChatInfo }>; //世家聊天信息
    zongMen: UpList<{ [xbid: string]: ChatInfo }>; //宗门聊天信息
    kua: UpList<{ [xbid: string]: ChatInfo }>; //跨服聊天信息
    hefu: UpList<{ [xbid: string]: ChatInfo }>; //合服聊天信息
    zudui: UpList<{ [xbid: string]: ChatInfo }>; //组队聊天信息
    zhaomu: UpList<{ [xbid: string]: ChatInfo }>; //招募聊天信息
}

//宗门频道
export interface SevZongMen {
    club: UpList<{ [iid: string]: mentuPostMarryInfo }>; //世家聊天信息
    kua: UpList<{ [iid: string]: mentuPostMarryInfo }>; //跨服聊天信息
    hefu: UpList<{ [iid: string]: mentuPostMarryInfo }>; //合服聊天信息
}

// 助力的类型
export enum ZhuliType {
    zhenFa = "zhenFa", //阵法
    lingMai = "lingMai", //灵脉
    yaotian = "yaotian", //药田
}

export interface Zhuli {
    list: {
        [iid: string]: {
            type: ZhuliType; //zhenfa：阵法
            fuuid: string; //被助力的角色
            stime: number; //发起时间
            etime: number; //最晚结束时间（可能会提前结束，这个时间不准）
            members: string[]; //助力成员列表
            cs: string[]; //助力参数
        };
    };
    iid: number;
}

export interface clubQuestLog {
    [uuid: string]: {
        // 挑战者uuid
        fuuid: string;
        taskId: string;
        //损失的道具
        cost: number[][];
        time: number;
    }[];
}

export interface SevClubQuestBoss {
    list: {
        [uuid: string]: ClubQuestBoss;
    };
}

export interface ClubQuestBoss {
    uuid: string; //触发的角色
    user: FUserInfo;
    bossId: string; //bossId
    bossHp: number; //boss血量
    bossMaxHp: number; //boss血量
    stime: number; //发起时间
    etime: number; //结束时间
    isShare: number; //是否分享
    members: { [fuuid: string]: { fuser: FUserInfo; damage: number } }; //助力成员列表 uuid 造成的伤害
}

//组队
export interface ZuduiChat {
    hdcid: number; // 1.荒古禁地  2.妖帝坟冢  3.青铜仙殿
    xlsid: number; // 关卡ID
    state: number; //状态 1组队中 2准备中 3战斗中 4队友结算中
    uuid: string; //队长
    mems: {
        //成员列表
        [fuuid: string]: ZuduiMem;
    };
}
//组队
export interface Zudui {
    hdcid: number; // 1.荒古禁地  2.妖帝坟冢  3.青铜仙殿
    xlsid: number; // 关卡ID
    type: number; //1组队 2集结
    uuid: string; //队长

    state: number; //状态 1组队中 2准备中 3战斗中 4队友结算中
    time: number; //状态的最后一次操作时间

    mems: {
        //成员列表
        [fuuid: string]: ZuduiMem;
    };
    applyAuto: number; //自动加入0不自动， 1自动
    apply: {
        [fuuid: string]: ZuduiApply;
    };
    jijie_time: number; // 集结结束时间 初始0
    zb_time: number  // 全员准备进入战斗后 倒计时时长后进入战斗
}

export interface ZuduiEvent {
    type: number; //触发类型 2.队长准备 3.取消准备
}

export interface ZuduiMem {
    state: number; //角色ID：状态 1组队中 2已准备  3战斗中
    identity: number; //1真玩家 3机器人
    joinTime: number; //加入时间
    applyAuto: number; //自动确认进入副本 0不自动， 1自动
    fuser: FUserAll; //角色信息
}

export interface ZuduiApply {
    state: number; //角色ID：状态 1已申请  2已处理
    fuser?: FUserInfo; //角色信息
}

//特权卡
export enum PriCardType {
    fever = "fever", //终生卡
    moon = "moon", //月卡
    adver = "adver", //免广告卡
    moonDT = "moonDT", //洞天月卡
    TianMing = "TianMing", //天命卡
    ZhiZun = "ZhiZun", //至尊卡
    xianyu = "xianyu", //仙域特权
}
export interface HdPriCardData {
    //配置
    days: number; //持续天数 0 永久
    rwd: KindItem[]; //购买奖励
    dayRwd: KindItem[]; //每日奖励
    title: string; //礼包名称
    need: KindItem; //充值/购买需求

    // ------------------------月卡-------------------------------
    exDoufa?: number; //每日额外挑战券-只有月卡用到
    isUpZhenfa?: number; //是否开启阵法加速-只有月卡用到
    exMijing?: KindItem[]; //每日额外秘境-月卡终身卡
    zhaoHuan?: number; //装备召唤倍数+1
    autoOnlineTime?: number; //自动挂机时间加2小时

    // ------------------------终生卡-------------------------------
    online2hour?: number; //在线2小时额外领取次数
    dadiguziAuto?: number; //大帝古字自动开启-终身卡
    itemAdd?: number; // 终身卡福地拉车道具加成
    dadiguziUp?: number; //大帝古字加速开启0关闭，1开启
    chenghao?: number; //称号id
    yaotianAdd?: number; //增加药田产量-终身卡
    mustHuoBan?: number; //招募xx次后必出极品及以上伙伴
    mustZongMen?: number; //宗门每xx次后必出极品及弟子
    mustShouling?: number; //刷新X次必出配置的兽灵

    // ------------------------天命卡-------------------------------
    mjRwdAdd?: number   //所有秘境奖励增加50%
    zdRwdAdd?: number   //所有组队玩法奖励增加50%（不包括协助奖励）
    xiezhuRwdAdd?: number   //组队协助币奖励增加500%
    hgjdCountAdd?: number   //荒古禁地每日挑战次数增加
    ydfzCountAdd?: number   //妖帝坟冢每日挑战次数增加
    qtxdRwdType?: number   //青铜仙殿表的挑战奖励新增了一列奖励类型配置（类型1是原来的普通奖励，类型2对应的天命卡解锁的专属奖励）

    // ------------------------至尊卡-------------------------------
    mustZhenFa?: number   //阵法专研xx次后必出仙品阵法
    mustShufa?: number   //术法专研xx次后必出仙品阵法
    xiezhuShopCost?: number   //协助商店兑换消耗减少百分比
    mustZhenFaBDId?: number   //阵法保底库ID
    mustShuFaBDId?: string   //术法保底品质

    // ------------------------仙域特权-------------------------------
    xianshuRwd?: number  //仙树奖励增加比例（万分比）
    fund?: {
        [dc: string]: {
            need: KindItem,
            time: number,   //返利时间(秒)
            xianqiRwd: number,   //获得仙气
        }
    }

    // ------------------------other-------------------------------
    // powerLimit?: number; // 增加道童体力上限-只有洞天月卡用到
    lacheSpeed?: number; //洞天拉车速度提升万分比-只有洞天月卡用到
    shuache?: number; //每日首次刷车必出等级-只有洞天月卡用到
    yaotianTime?: number; //药田月卡，药田种植时间缩短成原来的百分比
    powerLimit?: number; // 药田特权卡增加体力
    dongtian_PriCard?: number //药田特权卡-药山自动管家时长
    yaotian_PriCard?: number //药田特权卡药田管家时长（秒）
}

export interface HdPriCardOut {
    btime: number; //购买过期时间 0 未购买 >0 过期时间 <0 永久 //折算天数 (btime-now)/86400
    rtime: number; //上次领取时间
    shiyong: number; //是否是试用 0否 1是
}

export interface ActDingYue {
    [id: string]: {
        open: number; //1开启0关闭
        dy: number; //1已订阅0没有订阅
    };
}

export interface ActZdHgjd {
    xlsId: string; //技术存储ID
    tzNum: number; //挑战次数
    maxNum: number; //最大挑战次数
    star: {
        [xlsId: number]: number; // 通关星级
    };
    kind11: number; // 每日已观看广告次数
    firstRwd: {
        [xlsId: string]: number; // 首通奖励领取
    };
    firstRed: number; //奖励红点
    red: number; //模块红点

    task: { [id: string]: number }; //任务领取 没下发默认0 配置表id：对应  0不能领取  1可领取  2已领取
    jiesuo: { [xlsId: number]: number }; //解锁的xlsId
}

export interface ActZdYdfz {
    tzNum: number; //已挑战次数
    maxNum: number; //最大挑战次数
    kind11: number; // 每日已观看广告次数
    firstRwd: {
        [xlsId: string]: number; // 首通奖励领取
    };
    firstRed: number; //首通奖励红点
    red: number; //模块红点
}

export interface ActZdQtxd {
    xlsId: string; //技术存储ID
    tzNum: number; //已挑战次数
    hit: {
        [id: number]: number; // 队伍总伤害
    };
    hitRwd: {
        [id: number]: number; // 伤害奖励领取状态
    };
    kind11: number; // 每日已观看广告次数
    firstRwd: {
        [id: string]: number; // 首通奖励领取
    };
    firstRed: number; //首通奖励红点
    red: number; //模块红点
}

//排行业务分类 user
export enum DongTianLogType {
    newCar = "newCar", //资源刷新：我方洞天刷出新资源
    rob_s_a = "rob_s_a", //掠夺_成功_矿主 //洞天被掠夺成功：我方资源被他方掠夺成功，点击【前往洞天】进入他人洞天
    rob_s_b = "rob_s_b", //掠夺_成功_劫匪 //掠夺成功：我方掠夺他方资源成功
    // rob_f_a = "rob_f_a", //掠夺_失败_矿主 //守护成功
    rob_f_b = "rob_f_b", //掠夺_失败_劫匪 //掠夺失败：掠夺他方资源失败，点击【前往洞天】进入他人洞天

    fight_a = "fight_a", //驱赶成功：驱赶他方掠夺资源成功
    fight_b = "fight_b", //被驱赶成功：被驱赶掠夺 ，玩家名称六字驱赶了你对【99级神秘资源】的掠夺，点击【前往洞天】进入他人洞天
}

//洞天日志信息
export interface ActDongTianLog {
    id: number; //日志编号
    type: DongTianLogType; //类型 1默认
    uuid: string; //uuid
    user?: FUserInfo; //玩家信息
    carId: string; //矿车编号
    time: number; //时间
}

export interface ActDongTian_show {
    kmax: number; //苦力总数
    busy: number; //干活苦力数
}
//洞天 列表信息 (附近和仇人)
export interface ActDongTian_fuser {
    fuser: FUserInfo;
    dongtian: { [pos: string]: ActDongTian_CarInfo };
}

/**
 * 一辆车信息
 */
export interface ActDongTian_CarInfo {
    id: string; //矿车ID
    pos: string; //几号矿车
    spos: number; //初始位置
    dpos: number; //启动时间点位置偏移
    stime: number; //开始时间(启动判定)
    etime: number; //结束时间 (矿车消失判定)
    plunder: number; //是否可被掠夺 0可以 1不可以
    my: {
        fuuid: string;
        fuser?: FUserInfo; //拉车人的信息
        knum: string[]; //苦工数量
        pow: number; //开工状态
        fevCard: boolean; //是否有特权卡
    };
    he: {
        fuuid: string;
        fuser?: FUserInfo; //拉车人的信息
        knum: string[]; //苦工数量
        pow: number; //开工状态
        fevCard: boolean; //是否有特权卡
    };
    pklog: {
        time: number; //打架时间
        win: number; //胜负
        fuuid1: string; //进攻者
        fuuid2: string; //防守者
        fuser1?: FUserInfo; //进攻者
        fuser2?: FUserInfo; //防守者
    }[];
}
/**
 * 车的运算信息
 */
export interface ActDongTian_Carshow {
    edtime: number; //离结束 还有多长时间 0已完成 (未开始 -1)
    win: 0 | 1; //胜利方是谁 0守方 1攻方 (未开始默认0)
    nowpos: number; //当前位置偏移
}

export interface ActDongTian {
    //自家矿车
    adokCars: number; //刷车心跳(下一次生成矿车时间点)
    cars: {
        [pos: string]: ActDongTian_CarInfo;
    };
    dtList: {
        [dtid: string]: number; //0空闲 1已派选
    };
    unlock: string[]; //待解锁道童id列表
    laquNum: number; //拉取矿车次数

    //哥布林拉车信息
    rob: {
        [fuuid: string]: {
            //角色ID
            [pos: string]: ActDongTian_CarInfo;
        };
    };

    //附近
    rntime: number; //上次附近刷新时间
    nears: string[];

    //敌对表
    enemy: {
        //备注：这个有没有用？
        [fuuid: string]: number; //敌人 , 掠夺时间
    };

    //每日刷新字段
    outTime: number; //每日重算字段

    //苦工状态值
    power: number;
    powerMax: number;
    snum: number; //今天拉过几次了
    rstcars: number; //今天手动刷新矿车次数
    kind11: number; //广告刷新矿车次数
    kind11_tili: number; //广告增加体力次数
    kindAt: number; //下次广告刷新矿车时间
    xlStep: number; //当前训练阶级
    xlLv: {
        //当前训练等级
        [type: string]: number;
    };
    sb: number; //是否上榜

    //自动拉车设置
    auto: {
        [key: string]: number; //kaiqi 0 关闭 1开启，first：typ，second：type，thirdly：type,fourthly:type, level:0 时间优先 1 等级优先
    };
    autoAt: number; //下一次自动检测时间
    hook: {
        [key: string]: number;
    };
    //礼包购买
    gift: {
        [key: string]: number;
    }; //礼包购买次数
    pricardNum: number; //拥有特权卡今日是否刷新车
    shiyong: number; //是否试用过自动拉车 0 否 1是
    powerAdd: { [key: string]: number }; //key：daoyou 道友加成值，priCard 特权卡加成值
    zidong: {
        startTime: number; //自动开始时间
        closeTime: number; //自动关闭时间
        lastTime: number; //上次结算时间
        count: number; //自动种植次数
        items: KindItem[]; //累计获得的道具
    };
    caiyao: number; //采药登记
    islock: number; //是否解锁 0 未解锁 1已解锁
    autoOverTime: number; //自动拉车倒计时
}

export interface DongtianSevInfo {
    level: number; //NPC等级
    cars: {
        [pos: string]: ActDongTian_CarInfo;
    };
    adokCars: number; //刷车心跳(下一次生成矿车时间点)
    ver: number; //刷新空闲矿车
}

export interface ActDongTianPos {
    pos: string; //车ID
    fuser: FUserInfo;
    knum: number; //苦工数量
    etime: number; //结束时间
}

export interface ActDaoWen {
    dc: string; //当前生效的预设档位
    dcs: {
        //每一个档位所装备的道纹
        [dc: string]: {
            slot: { [slot: string]: string };
            name: string;
        };
    };
    dcList: {
        [dc: string]: number; //0未解锁 1已解锁，预算档位是否解锁
    };
    unlockLevel: number; //解封魂玉的等级
    daowenExp: number; //道纹解封经验
    score: number; //解封魂玉的积分 用于指定解封
}
//宝石信息
export interface DaoWen_Stone {
    iid: string; //星魂唯一ID
    id: string; //道纹id
    status: number; // 0未使用 1已使用
    slot: string; //星宿槽位
    exp: number; // 经验
    level: number; // 等级
    pinzhi: string; //品质
    tzid: string; //套装ID
    baseEps: {
        sxid: string;
        level: number; //词条等级
    }; //道纹主属性
    fuEps: {
        [sxid: string]: {
            pinzhi: number; //当前基础属性等级
            level: number; //词条等级
        };
    }; //道纹副属性
}

export interface ActJingJie {
    level: number; //当前角色等级
    xiuwei: {
        //修为等级
        [type: string]: number;
    };
    exp: number;
    upNum: number; //升级次数
    hook: { [kind: string]: number }; //钩子数据
    task: { [kind: string]: number };
}

export interface ActTaskAchievement {
    type: string; //任务类型
    id: string; //当前未完成的任务ID
    cons: number; //当前完成进度
}

export interface ActYouLi {
    tili: number; //游历体力数量
    cdTime: number;
}

//弟子系统输出信息
export interface ActDiZi {
    shangZhen: { [gezi: string]: string }; //上阵弟子
    // dzList: { [dzid: string]: ActDiZi_Info }; //已拥有的弟子
    tujian: { [tjid: string]: number }; //已激活的图鉴:等级
    freeTimes: number; //今日广告观看几次
    kind11Times: number; //累计广告观看几次
    times: number; //今日已招募几次
    zmInfo: {
        level: number; //招募库等级
        exp: number; //招募库经验
    };
    jiban: string[]; //弟子羁绊
    // 特权卡招募计数 招募几次 开通特权卡才累计\
    nZhaoMu: number;
}
//单个弟子数据结构
export interface ActDiZi_Info {
    id: string; //弟子id
    state: number; //状态 0默认 1已上阵
    level: number; //等级
    star: number; //弟子星级
    jingjie: number; //弟子境界等级
    tupoNum: number; //突破失败次数
    skin: string; //穿戴的的皮肤
    skins: {
        [id: string]: {
            level: number,//等级
            cost1: number,//通用道具消耗
            cost2: number//指定道具消耗
        },
    };
}

export interface HdDouLuoData {
    battleItem: number[]; //每次挑战需消耗的道具
    battleItemMax: number; //每次挑战道具上限
    itemCd: number; //斗罗旗恢复CD
    battleBg: string; //战斗使用的背景
    buyNeed: number[]; //售价,次数
    buyMax: number; //每日购买上限
    refNeed: number[]; //刷新需求
    sdRwd: number[][]; //扫荡奖励
    winRwd: number[][]; //胜利奖励
    kd: number[][]; //跨度配置
    hdRankKeyDay: string; //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    kuaType: number; //跨服类型 0:无跨服，1:普通跨服，2:根据周跨服
    kuaNum: number; //跨服区服个数 kuaType = 1|2生效
    week: number[]; //生效周 kuaType = 2生效
    weekNum: number; //生效N周
    showWeek: number[]; //展示周 kuaType = 2生效
    chengjiu: {
        [dc: string]: {
            dc: string; //达到第几名才获得奖励
            rwd: number[][]; //奖励
        };
    };
    hdRank: {
        pm: number[]; //排名范围
        items: number[][]; //奖励内容
    }[];
    hdRankWeek: {
        pm: number[]; //排名范围
        items: number[][]; //奖励内容
    }[];
}

export interface HdDouLuoOut {
    ksid: string; //跨服ID
    itemBuy: number; //斗罗旗 今天购买次数
    //刷新cd 上次手动刷新时间
    rtime: number;
    //挑战表
    tzList: DouLuoFuser[];
    //每日重置
    outTimeDay: number; //每日重算字段
    itemNext: number; //斗罗旗 下次恢复时间 (前端展示用)
    //20231009 版本新增
    score: number; //斗罗积分 每周重置
    minRid: number; //斗罗最前排名
    shop: {
        //商店 每周重置
        [dc: string]: number; //购买档次 ： 购买次数
    };
    chengjiu: {
        //完成成就  不重置
        [dc: string]: number; //购买档次 ： 领取时间
    };
    freeItem: number; //免费道具数量
}

export interface DouLuoFuser extends RdsFUserInfo {
    type?: 0 | 1 | 2; //0只能看,1可以挑战,2可以扫荡
}

export interface ActDouLuoFight { }

//绝仙台 战斗日志 后端数据
export interface HdDouLuoLogOut {
    type: 0 | 1; //0挑战 1 被人打
    win: number; //胜负
    time: number; //时间
    users: {
        fuuid: string;
        fuser?: FUserInfo;
        rid: number; //排名
    }[];
    xhid: string;
}
//绝仙台 战斗日志 配置
export interface HdDouLuoLogData { }

export interface HdZiXuanData {
    zxlblist: {
        [dc: string]: {
            dc: string; //档次
            title: string; //礼包名称
            need: number[]; //充值金额
            items: number[][]; //固定奖励
            items1: number[][]; //可选奖励
            fanli: number; //返利百分比
        };
    };
}

export interface HdZiXuanOut {
    zxlblist: { [dc: string]: number }; //已经购买的档次列表
    buylist: { [dc: string]: number[][] }; //已经购买的档次列表所选道具
}

// 实名认证
export interface IDCardInfo {
    id: string; // 账号唯一id
    name: string; // 姓名
    IDCard: string; // 身份证
    age: number; // 年龄：每次登录/获取时更新
    birthTime: string; // 出生日期 "YYYY-MM-DD"
    monthRcg: number; // 月充值
    monthRcgTime: number; // 月充值记录时间
    dayRcg: number; // 日充值
    dayRcgTime: number; // 日充值记录时间
    todayOnline: number; // 日在线
    onlineTime: number; // 日在线记录时间
}
// 法宝
export interface ActFaBao {
    extractCount: number; //法宝抽取次数
    nowCount: number; //法宝当前抽取次数 x次后必出卓越（出卓越后重置为0）
    fabaoList: { [fbId: string]: FaBaoInfo };
    jibanList: {
        //羁绊列表
        [jbid: string]: number; // 羁绊最低星级
    };
}
export interface FaBaoInfo {
    fbId: string; //法宝id
    level: number; //法宝等级
    star: number; //法宝星级
}
export interface ActPifu {
    skin: string; //当前设置的皮肤
    list: {
        //解锁的皮肤列表
        [pfid: string]: {
            getT: number; //获得时间
            level: number; //等级
        };
    };
}

export interface ActGuide {
    list: {
        //步骤存储
        [id: string]: number;
    };
    last: string;
}

export interface ActCaiDan {
    list: {
        [id: string]: number;
    };
}
export interface ActEps {
    [kid: string]: {
        //哪个模块
        [key: string]: number; //属性信息
    };
}

export interface ActDailyTask {
    hook: { [kind: string]: number }; //任务进度
    task: { [kind: string]: number }; //任务奖励领取情况
    jifen: { [kind: string]: number }; //积分奖励领取情况
    score: number; //记录每天的任务积分
}

//奖励找回
export interface ActRwdBack { }
// 老玩家回归
export interface ActUserBack { }

export interface HdFeiNiaoData {
    dnum: number; //每天可以开几个
    rwd: number[][]; //奖励
    cd: number; //冷却时间
}

export interface HdFeiNiaoOut {
    rwdnum: number; //今天已经开过几个了
    rtime: number; //下次可以领取时间
    outTime: number; //每日刷新时间
}

export interface ActLingMai {
    myList: LingMaiList;
    guanbei: number[]; //[观碑角色ID,入座时间，碑的产出，碑的过期时间]
    list: {
        [uuid: string]: LingMaiList;
    }; //用于下发碑林列表信息
    shop: {
        //商店 每周重置
        [dc: string]: number; //购买档次 ： 购买次数
    };
    ruzuoCd: number; //该时间内不能再次入座或挑战
    // linshi:{
    //     [key:string]:{
    //         uuid:string //被谁驱赶
    //         time:number, //在那里待了多长时间（分钟）
    //         count:number,//获得的道具数量
    //     }
    // } //1：观碑防守失败结算,2:被驱赶结算 number:获得的道具数量
    zhuli: number; //是否可助力1可助力
    zhuliNum: number; //有多少人给我助力
    kind11: number; //今日看广告次数
    one: LingMaiList; //用来下发某个房间的完整数据（user）
    jiesuan: {
        // key: "1":自己的，“2”:观碑正常结算， “3”:被驱赶结算 ,"4"：防守失败结算
        [key: string]: {
            items: KindItem[];
            time: number; //呆了多长时间（分钟）,
            name?: string; //驱赶人名称
            sid?: string; //驱赶人区服
        };
    };
    discount: {
        [dc: string]: number; //哪个档次打折：打几折 计算货币是四舍五入
    };
    zkKind11: number; //折扣看广告数
}

export interface LingMaiList {
    list: {
        [id: string]: {
            uuid: string; //入座角色ID
            time: number; //入座时间
            user?: FUserInfo;
        };
    };
    chenghao: string[];
    overTime: number; //碑的结束时间
    score: number; //单位时间产出道具数量
    logs: {
        [key: string]: {
            fuuid: string; //入座的人
            fuser?: FUserInfo;
            qugan: string; //取代了谁才入座
            quganUser?: FUserInfo;
            time: number; //入座时间
        };
    };
}

export interface ActLingMaiLog extends FUserInfo {
    win: number; //1胜0负
    type: number; //0我驱逐别人1我挑战别人2别人挑战我3别人驱逐我 4收入 5消耗
    cAt: number; //被打时间
    xhid: string; //战斗序号
    count: number; //道具数量
    duihuan: number; //兑换的道具数量
}

export interface ActGuKuang {
    cjLine: number; // 已经向下采集了多少行
    map: {
        //地图
        [page: number]: number; // 第几层：随机数种子
    };
    wjMap: {
        // 地图对应挖掘的格子
        [page: number]: { [posXy: number]: number }; // {"1":{y*6+x:0}}
    };
    kind11: {
        [item_id: number]: number;
    }; // 今天看广告次数
    itemRecord: {
        // 记录特殊道具轰炸点
        [itemType: number]: {
            [page: number]: number[]; //posXy
        };
    };
}

export interface HdChouJiangData {
    need: number[]; //抽一次奖消耗
    kind11: number; //广告抽奖次数
    count: number; //百宝箱内道具数量达到多少才可以购买
    buyNeed: number[]; //购买百宝箱的消耗
    title: string; //购买礼包名称
    chou: {
        dajiang: number[]; //大奖
        showdj: number; //前端展示基础大奖概率
        djProb: number[]; //抽大奖概率【第几次开始概率增加,上限次数，增加概率】
        xianzhi: number; //大奖前x次不中
        baodi: number; //大奖x次必中
        prob: number; //大奖基础概率
    };
    chouPt: {
        [dajiang: string]: {
            dajiang: string; //档次dc
            item: number[]; //奖励
            prob: number; //概率
        };
    };
    task: {
        [day: string]: {
            day: string; //天数
            taskList: string[]; //任务列表
        };
    };
    taskList: {
        [dc: string]: {
            dc: string; //档次dc
            kind: string; //活动种类
            need: number; //需要完成进度
            item: number[]; //奖励抽奖道具
        };
    };
}

export interface HdChouJiangOut {
    time: number; //用于每日重置
    baodi: number; //抽取次数;
    jifen: string[]; //积分档次
    buy: number; //是否购买百宝箱 0未购买 1已购买
    task: {
        //任务领取列表
        [dc: string]: number;
    };
    taskKind: {
        //任务进度
        [kind: string]: number;
    };
    kind11: number; //今日观看广告次数
    baoxiang: number; //百宝箱里存放的抽奖道具数量
}

export interface SevDuiHuan {
    list: {
        [dc: string]: {
            count: number; //剩余数量
            price: number; //这一期的价格
        };
    };
    time: number; //下次刷新时间
}

export interface ActKaiQi {
    list: { [id: string]: number }; //id和对应的开启时间
}

export interface SevDouFa {
    list: {
        [fuuid: string]: number; //保护人 申请截止时间
    };
}

export interface DuoWeiInfo {
    club: string;
    allPower: number;
    level: number;
    time: number;
    fClub: string;
    qinzhan: {
        // 请战列表
        [uuid: string]: ActFightStart;
    };
    shangzhen: {
        // 上阵列表
        [pos: number]: string;
    };
    record: {
        win: number; // 胜利局数
        lose: number; // 失败局数
        score: number; // 总积分
        winLog: {
            [pos: number]: number;
        };
        loseLog: {
            [pos: number]: number;
        };
    };
}
export interface ActYaoTian {
    yaotian: {
        //药田
        level: number;
        exp: number;
        gezi: {
            [key: string]: {
                startTime: number; //开始种植时间
                overTime: number;
                chanchu: KindItem; //产出道具
                addExp: number; //收获获得经验
                toucai: FUserInfo | string; // uuid谁在偷
                toucaiOverTime: number; //偷菜结束时间
                istou: number; //是否被偷过了 1被偷过了 0没有
                zhuli: number; //这次种菜是否还能请求助力
            };
        };
        shoucai: number; //收菜次数
        zidong: {
            startTime: number; //自动开始时间
            lastTime: number; //上次结算自动的时间
            closeTime: number; //关闭自动时间
            count: number; //自动种植次数
            items: KindItem[]; //累计获得的道具
            addExp: number; //获得的经验
            costItem: KindItem[]; //消耗的道具
        };
    };
    yaolu: {
        //药炉
        level: number;
        exp: number;
        danfang: number[]; //已解锁的丹方
    };
    dingdan: {
        level: number;
        exp: number;
        dingdanList: {
            [xh: string]: {
                id: string;
                get: number; //是否领取 0否1是
            };
        };
    };
    hook: {
        [key: string]: number; //药田格子解锁任务钩子
    };
    dingdanHook: {
        [key: string]: number; //订单任务钩子
    };
    toucai: {
        [key: string]: {
            //uuid偷的谁的
            gezi: string; //偷的哪个格子
            overTime: number; //结束时间
            item: KindItem; //偷到的菜
        };
    };
    useAuto: number; //今日是否体验过自动种植
    unchallenged: {
        //不能阻击玩家信息列表
        [key: string]: {
            //谁家
            uuid: string; //挑战的谁
            gezi: string; //哪个菜格子
            overTime: number; // 该玩家偷菜结束时间
        };
    };
    yaofang: {
        [key: string]: {
            //丹药id
            shiyong: number; //当前耐药食用数量
            count: number; // 总共使用数量
            naiyao: number; //当前耐药百分比
        };
    };
    auto: {
        [key: string]: number; //自动种植设置 key:kaiqi是否开启自动种植，shifei是否开启自动施肥，first：种子id，second：种子id，thirdly：种子id, 是否开启自动偷菜,autoSteal:是否开启自动偷菜
    };
    autoAt: number; //自动种植时间（用于检测自动种植）
    rntime: number; //上次附近刷新时间
    nears: string[];

    //敌对表
    enemy: {
        [fuuid: string]: number; //敌人 , 掠夺时间
    };
    //礼包购买
    gift: {
        [id: string]: number;
    }; //礼包购买次数
    chongzhi: number; //每日重置次数
    jiesuan: {
        // key: 1偷菜成功 2 被人驱赶 3制药
        [key: string]: {
            items: KindItem[];
            name?: string; //驱赶人名称 | 偷菜
        };
    };
    kind11: number; //看广告领取肥料次数
    autoOverTime: number; //自动种植体验时间
    unlock: {
        [key: string]: number; //1道具解锁 2 任务解锁 number解锁数量
    };
    sxFree: number; //今日使用免费刷新的次数
    freeItem: {
        [key: string]: number; //免费道具id：数量
    };
}

//药田日志信息
export interface ActYaoTianLog {
    id: number; //日志编号
    type: string; //类型 0收菜 1偷别人 2被别人偷
    uuid: string; //uuid
    user?: FUserInfo | any; //玩家信息
    item: KindItem; //道具
    time: number; //时间
}

//药田 列表信息 (附近和仇人)
export interface ActYaoTian_fuser {
    fuser: FUserInfo | any;
    yaotian: {
        [gezi: string]: {
            startTime?: number; //开始种植时间
            overTime: number;
            chanchu: KindItem; //产出道具
            addExp: number; //收获获得经验
            toucai: FUserInfo | string; // uuid谁在偷
            toucaiOverTime: number; //偷菜结束时间
            istou: number; //是否被偷过了 1被偷过了 0没有
        };
    };
}

export interface YaoTianSevInfo {
    level: number; //NPC等级
    gezi: {
        [gezi: string]: {
            overTime: number;
            chanchu: KindItem; //产出道具
            addExp: number; //收获获得经验
            toucai: string; // uuid谁在偷
            toucaiOverTime: number; //偷菜结束时间
            istou: number; //是否被偷过了 1被偷过了 0没有
        };
    };
}

export interface ActYaoTianEps {
    [key: string]: number; //属性信息
}

export interface HdClubDuoWeiData {
    qiDayActive: number; //七日活跃大于等于10000才可以参与
    weekNum: number; //持续几周
    kuaNum: number; //x个区服跨一组
    kuaType: number; //周循环
    week: number[]; //周一至周五开始活动
    showWeek: number[]; //周一至周五展示活动
    info: {
        [id: string]: {
            id: number; //头衔
            name: string; //名称
            posList: number[]; //仙位配置
        };
    };
    pos: {
        [id: string]: {
            id: number; //id
            name: string; //位置
            score: number; //积分
        };
    };
    uplevel: {
        [id: string]: {
            id: number; //id
            xmCount: number; //分组仙盟数量
            level: number; //仙盟等级
            upCount: number; //晋级数量
            cenCount: number; //包级数量
            downCount: number; //降级数量
        };
    };
    rwd: {
        [id: string]: {
            id: number; //id
            type: number; //奖励类型
            level: number; //头衔
            itmes: number[][]; //奖励
        };
    };
    time: {
        [id: string]: {
            id: number; //阶段
            beginTime: number[]; //开始时间[星期x,x点,x分]
            endTime: number[]; //endTime[星期x,x点,x分]
        };
    };
}
export interface HdClubDuoWeiOut {
    club: string;
    allPower: number;
    level: number;
    time: number;
    fClub: string;
    qinzhan: {
        // 请战列表
        [uuid: string]: ActFightStart;
    };
    shangzhen: {
        // 上阵列表
        [pos: number]: string;
    };
    record: {
        win: number; // 胜利局数
        lose: number; // 失败局数
        score: number; // 总积分
        winLog: {
            [pos: number]: number;
        };
        loseLog: {
            [pos: number]: number;
        };
    };
    state: number; // 阶段
    fightLog: string[]; // 战斗数据
}

// 仙路争锋
export interface HdXianLuShopData {
    exchangeShop: {
        [dc: string]: {
            dc: string;
            need: KindItem;
            items: KindItem;
            // 跨服才出现（1跨服出现，0一直在）
            show: number;
        };
    };
}

export interface HdXianLuShopOut {
    exchange: { [key: string]: number };
}

export interface HdXianLuVyingData {
    scoreItem: number[]   //积分道具
    fundNeed: number[]   //购买基金
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    itemCall: number[]   //召回道具
    fundTitle: string   //基金名称
    hdRankKey: string   //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    kuaNum: number   //10个区服跨一组
    kuaType: number
    task: {
        [id: string]: {
            id: string  //档次
            kind: string  //任务类型
            need: number  //需要完成的数量
            rwd: number[][]  //任务完成奖励
            isDay: number  //是否每日（1为每日0为活动期间）
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[] //前面是次数，后面是累计充值
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次
            title: string  //标题
            need: number[]  //价格
            rwd: number[][]  //奖励
            limit: number  //限购次数
            dayLimit: number  //每日限购次数
        }
    }
    fund: {
        [dc: string]: {
            dc: string  //档次
            need: number  //积分数
            free: number[][]  //奖励
            grwd: number[][]  //奖励
        }
    }
    speTask: {
        [kind: string]: {
            kind: string  //任务类型
            need: number  //需要完成的数量
            rwd: number[]  //获得积分
        }
    }
    exchange: {
        [dc: string]: {
            dc: string  //档次
            need: number[]  //需要的道具
            items: number[]  //可兑换的道具
            limit: number  //限制兑换次数
            lockneed: number  //解锁需要的积分数
        }
    }
    hdRank: {
        pm: [number, number]  //排名区间
        items: number[][]  //奖励
    }[]
    round: {
        tasks: number[]  //任务列表,任务表的ID
        pre: number  //开启的前置条件
        gprize: number[][]  //大奖
    }[]
}


export interface HdXianLuVyingOut {
    // 基金
    payTime: number; //购买时间
    score: number; //积分
    free: {
        //免费领取
        [dc: string]: number; //档次 : 领取时间
    };
    pay: {
        //付费领取
        [dc: string]: number; //档次 : 领取时间
    };

    // 特殊活动-获得积分
    consSpe: number;

    // 当前任务轮次的索引
    taskIndex: number;

    //任务 活动期间
    taskCons: { [kind: string]: number };
    taskRwd: { [id: string]: number };
    taskBigRwd: { [id: string]: number };


    //任务 每日
    taskConsDay: { [kind: string]: number };
    taskRwdDay: { [id: string]: number };

    // 礼包
    //礼包领取
    gift: { [id: string]: number }; //礼包id : 领取、购买时间
    giftDay: { [id: string]: number }; //礼包id : 领取、购买时间

    exchange: { [id: string]: number }; //兑换次数

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

export interface ActPvd {
    maxTili: number; //最大体力
    tili: number; //当前体力

    maxHit: number; //今日打的总伤害
    allHit: number; //今日打的累计伤害
    boss: {
        id: string;
        bossId: string;
        skill: number;
    };
    lastDayRid: number; //排名
    dItems: KindItem[];
}

//上线福利
export interface HdShangXianFuLiData {
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    time: number   //X秒未领取则自动领取
    rwd: number[][]   //奖励
    chenghaoId: number   //领取后获得的称号
    shangzhen: number   //需要上阵的弟子ID
    zhanwei: number   //需要上阵的弟子ID站位
}

export interface HdOnLineData {
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    list: {
        [dc: string]: {
            dc: string  //档次
            fenzhong: number  //分钟
            items: number[][]  //奖励
        }
    }
}

export interface HdOnLineOut {
    rwd: { [dc: string]: number };
    ontime: number; //在线时长
    isOver: number  //是否结束
}

export interface HdClubPkData {
    zbtime: number   //阶段-准备时长（秒）
    pktime: number   //阶段-战斗时长（秒）
    memcount: number   //仙盟入选最低人数
    need1: number[]   //战斗消耗的混战令
    need2: number[]   //战斗消耗的挑战令
    baseJfOne: number   //个人初始积分
    baseScore: number   //本次匹配基础积分
    tiliCd: number   //体力恢复时长
    tiliMax: number   //体力最大值
    pipei: number   //匹配与自己排名接近的仙盟范围n
    jlMax: number   //战斗精力值
    jlSub: number   //每次战斗精力值衰减
    jlEp: number[]   //每5点精力值衰减万分之100的属性
    gongxun: number[]   //参与就能获得功勋[体力，混战令，挑战令]
    huifu: number[]   //每击杀几次回复百分比血量
    Ia: number   //单场胜利基础积分
    Ib: number   //积分系数（基数100）
    Ik: number   //废弃
    failXs: number   //击败积分系数配置（基数100）
    upgonggao: number   //击杀多少人才上公告
    pkn: number[][]   //场次积分加成第n-m场加成百分比（基数100）
    kuaType: number   //跨服类型 0:无跨服，1:普通跨服，2:根据周跨服
    week: number[]   //生效周几
    showWeek: number[]   //展示周几
    kuaNum: number   //跨服区服个数 kuaType = 1|2生效
    hdRankKey: string   //通用字段-排行榜key 技术填写，与hdRank_排行奖励 搭配
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    fightAllNeed: number   //积分累计到多少开启一键挑战
    skipFightNeed: number   //跳过战斗需要连打几场开启
    itemCall: number[]   //通用字段-活动结束后删除道具 填道具ID
    addep: {
        [dc: string]: {
            dc: string  //档次
            type: number  //选择类型
            ep: number  //属性加成[属性key,万分比]
            need: number[]  //购买消耗
            pinzhi: number  //品质
        }
    }
    gift: {
        [id: string]: {
            id: string  //档位ID
            title: string  //礼包名称
            need: number[]  //消耗
            item: number[][]  //获得
            limit: number  //限购次数
            reset: string  //刷新规则0：永久day：每日
        }
    }

    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[] //前面是次数，后面是累计充值
        }
    }

    duihuan: {
        [id: string]: {
            id: string  //档位ID
            need: number[]  //消耗
            item: number[]  //获得
            limit: number  //限购次数
            leiji: number  //累计功勋多少开启
            reset: string  //刷新规则0：永久day：每日
        }
    }
    hdRank: {
        round: number  //轮次
        pm: [number, number]  //排名区间
        items: number[][]  //成员奖励
    }[]
    hdRankClub: {
        round: number  //轮次  
        pm: [number, number]  //排名区间
        LeaderItems: number[][]  //盟主奖励
        items: number[][]  //成员奖励
    }[]
    oneCj: {
        [id: string]: {
            id: string  //档位ID
            kind: string  //任务类型
            count: number  //需求进度
            item: number[][]  //获得
        }
    }
    clubCj: {
        [id: string]: {
            id: string  //档位ID
            kind: string  //任务类型
            count: number  //需求进度
            item: number[][]  //获得
        }
    }
}


export interface HdClubPkOut {
    zige: number  //资格证0无 1有
    state: number  //1准备阶段 2战斗阶段 3展示阶段
    stateTime: number  //当前阶段结束时间
    sType: number  //没有资格的类型 1宗门人数不足 2匹配时还没有宗门 3战斗阶段退出宗门

    tili: number;
    cdTime: number; //最后一次恢复体力的时间点
    gongxun: number  //累计功勋
    tiaoguo: number //跳过
    tgNum: number //打过多少人
    gift: {  //礼包
        [dc: string]: number
    }
    duihuan: {  //兑换
        [dc: string]: number
    }
    oneCjHook: {  //个人成就进度
        [kind: string]: number
    }
    oneCj: {  //个人成就领取奖励
        [dc: string]: number
    }
    clubCj: {  //工会成就领取奖励
        [dc: string]: number
    }
    //跨服列表  区服ID
    kuaList: string[]

    //战斗中
    jingli: number  //当前精力值
    pkCid: string  //挑选的工会ID
    pkClubInfo: {  //挑战的工会信息
        sid: string  //工会区服
        name: string  //工会ID
        rid: number  //公会排名
        flag: string;//旗帜
    }
    killMem: string[]  //已经击杀的成员
    liveMem: string[]  //活的的成员
    pkMem: string[]  //挑战的成员列表
    pkMemUsers: FUserPk3[] //挑战成员列表信息
    addEps: { [key: string]: number } //已经加成的属性
    xzList: {
        [xzType: string]: string  //选择类型 : 配置档次
    }
    ishf: number  //0没有触发回复 1触发回复该弹窗 2触发回复已弹出
    gx: number  //本轮功勋
    fClubjf: number  //本轮敌方公会扣除积分
    allJf: number //本轮总积分
    hp: number //当前剩余血量
    hp_max: number //最大血量
    teams: { [iid: string]: FightTeam }  //自身阵容

    bugNum: number; //购买次数
    bugCons: number; //购买金额
}

//仙盟混战 - 小场战斗结果
export interface HdClubPkEndOne {
    win: number //1剩0负
    jifen: number  //单场积分
    all: number //本轮获得的总积分
    user: FUserInfo //我方信息
    m_hp_max: number //我方最大血量
    m_hp: number  //我方剩余血量
    fuser: FUserInfo //对方信息
    f_hp_max: number //对方最大血量
    f_hp: number  //对方剩余血量
}




export interface HdXuanTianDouFaData {
    kuaType: number   //跨服类型：1普通跨服 2周跨服
    kuaNum: number   //几个区一跨
    week: number[]   //生效周，比赛时间
    showWeek: number[]   //展示周，活动入口展示时间
    itemCall: number[]   //道具回收
    hdRankKey: string   //个人排行奖励
    top: number   //竞技场排名前50名（包含）的玩家,获得竞技场的资格
    upOpenTime: number   //晋级赛开始时间 = 活动正式开始时间 + upOpenTime
    peakOpenTime: number   //巅峰赛开始时间 = 活动正式开始时间 + peakOpenTime
    upGap: number   //晋级赛轮次间隔时间（秒）
    peakGap: number   //巅峰赛轮次间隔时间（秒）
    fightTime: number   //战斗时间（秒）
    guessItem1: number[]   //8进4竞猜奖励
    guessItem2: number[]   //4进2竞猜奖励
    guessItem3: number[]   //决赛竞猜奖励
    npcMaxlevel: number   //npc最大等级
    hdRank: {
        round: number  //轮次
        pm: [number, number]  //排名区间
        desc: string  //排名文本描述
        items: number[][]  //奖励
    }[]
    duihuan: {
        [id: string]: {
            id: string  //档次
            need: number[]  //需要多少
            item: number[]  //兑换道具
            limit: number  //限购
            px: number  //排序
            reset: string  //刷新规则0：永久day：每日week：每周
        }
    }
}





export interface HdXuanTianDouFaOut {
    upBeInvited: number; //是否接受到邀请 0默认 1被邀请 2没资格
    peakBeInvited: number; //是否接受到邀请 0默认 1被邀请 2没资格
    guessInfo: {
        [round: number]: {
            uid: string; //竞猜数量
            statue: number;//是否结算 0默认 1中 2失
        }
    };
    groupNum: number; //分组数量,
    groupInfo: {
        score: number; // 斗法积分
        wins: number; // 胜场数
        user: FUserInfo;
        isLose: number; //输了没 0正常 1输了
    }[],
    groupIndex: number, //当前分组索引
    round: number,
    step: number,
    win: number, //当前场次是否赢了 -1没结果 0输了 1赢了
    enemy: string, //对手
    myRank: number, //排名 512-256-128...1， 0为默认 -1为未参与比赛
    sids: string[], //参与的区服IDs
    fightStatus: number //战斗状态 0未开始 1进行中 2准备中
    record?: number[]; //巅峰赛输赢记录
    peaksUsers?: FUserInfo[]; //巅峰赛玩家信息
    guessGame?: { //当前轮次的竞赛信息
        round: number,
        step: number,
        user: FUserInfo,
        fuser: FUserInfo,
    }
}
export interface SevXuanTianDouFaLogsOut {
    logs: {
        player1: FUserInfo,
        player2: FUserInfo,
        round: number,
        step: number,
        win: number, //1：player1赢 0：player2赢
    }[]
}
export interface SevXuanTianDouFaOtherGroupOut {
    groupInfo: {
        score: number; // 斗法积分
        wins: number; // 胜场数
        isLose: number; // 0正常 1输了
        user: FUserInfo;
    }[],
}




export interface HdBanBenFuLiData {
    list: {
        [id: string]: {
            id: string  //特权卡ID
            name: string  //特权名称
            days: number  //持续天数 0 永久 30月
            time: number[]  //购买时间（秒）
            sort: number  //排序
            banner: string  //图片
            kaiqi: number  //开启id
        }
    }
    step: {
        [cid: string]: {
            [step: string]: {
                cid: string  //特权卡ID
                step: number  //阶级
                need: number[]  //购买价格
                function: number[][]  //特权
            }
        }
    }
}




export interface HdBanBenFuLiOut {
    days: number; //累计登录天数
    cards: {
        [id: string]: {
            endTime: number,
            dailyRwdTime: number,
            step: number, //阶级
        }
    }; //已购买的特权卡
}

export interface HdHeFuData {
    signbuyNeed: number[]   //解锁代金券签到的价格
    signbuyTitle: string   //解锁代金券礼包名称
    signbuyItem: number[]   //解锁代金券签到后立即获得的奖励
    khflbuyNeedHaohua: number[]   //狂欢福利，解锁豪华福利的价格
    khflHaohuaTitle: string   //礼包名称
    khflHaohuaItem: number[]   //解锁豪华福利后立即获得的奖励
    khflbuyNeedZhizun: number[]   //狂欢福利，解锁至尊福利的价格
    khflZhizunTitle: string   //礼包名称
    khflZhizunItem: number[]   //解锁至尊福利到后立即获得的奖励
    khflItem: number[]   //狂欢福利，需要提交的道具
    khflJifenExchange: number   //狂欢福利，每提交1个道具转化成的狂欢积分数量
    shzItem: number[]   //神藏降临，攻击结界需要消耗的道具
    zongzhuRwd: number   //每个破封符造成的伤害
    hgsyItem: number[]   //欢歌盛宴，抽奖需要消耗的道具
    hgsyXiyouBaodi: number   //欢歌盛宴，稀有奖励保底次数
    hgsyExtraRwd: number[]   //欢歌盛宴，每次抽奖给的额外奖励
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    shopItem: number[]   //狂欢币
    showPro: number[]   //前端概率展示[大奖，限量，普通]
    itemCall: number[]   //要回收的道具
    hgsyRwd: {
        [xuhao: string]: {
            xuhao: string  //序号
            rwd: number[]  //奖励
            weight: number  //随机权重
            count: number  //次数限制(0表示无限)
        }
    }
    hgsyDajiang: {
        [id: string]: {
            id: string  //序号
            xuhao: number  //大奖类型
            count: number  //大奖次数要求
            item: number[]  //大奖
            baodi: number  //保底次数
            limit: number  //次数限制
            weight: number  //权重
        }
    }
    shzLeiji: {
        [dc: string]: {
            dc: string  //档次
            count: number  //累计次数
            rwd: number[]  //累计次数奖励
        }
    }
    khflLeiji: {
        [dc: string]: {
            dc: string  //档次
            jifen: number  //狂欢积分数量要求
            Rwd: number[]  //奖励
        }
    }
    shop: {
        [dc: string]: {
            dc: string  //档次
            need: number[]  //需要的道具
            items: number[]  //可兑换的道具
            limit: number  //限制兑换次数
            lockneed: number  //解锁需要的狂欢币消耗
        }
    }
    khflRwd: {
        [dc: string]: {
            dc: string  //档次
            jifen: number  //狂欢积分数量要求
            baseRwd: number[]  //基础奖励
            haohuaRwd: number[]  //豪华奖励
            zhizunRwd: number[][]  //至尊奖励
        }
    }
    shzZhuli: {
        [id: string]: {
            id: string  //助力成就id
            type: string  //助力成就类型
            need: number  //需要完成进度
            items: number[]  //助力奖励
            icon: string  //助力图标
            desc: string  //助力描述文本
            jumpid: string  //跳转id
            jump: string  //跳转按钮文本
        }
    }
    ycgift: {
        [dc: string]: {
            dc: string  //档次
            tiaojian: number[]  //[]中，第一位是次数，第二位是活动中买其他礼包的累积充值，第三位是游戏内的累积充值
        }
    }
    gift: {
        [dc: string]: {
            dc: string  //档次
            title: string  //礼包名称
            need: number[]  //需求
            rwd: number[][]  //礼包内容
            limit: number  //限制
            dayLimit: number  //每日限制
        }
    }
    sign: {
        [day: string]: {
            day: string  //天数
            baseRwd: number[]  //基础签到奖励
            djqRwd: number[]  //代金券签到奖励
        }
    }
    tiaozhan: {
        [id: string]: {
            id: string  //关卡id
            name: string  //关卡名称
            unlocktime: number  //解锁时间
            zuid: string  //编队id
            rwd: number[][]  //首通奖励
            scale: number  //UI缩放比例(boss)
        }
    }
    shzJiejie: {
        [id: string]: {
            id: string  //结界层数
            hp: number  //结界血量
            rwd: number[]  //击破奖励
        }
    }
    shzBuff: {
        [dc: string]: {
            dc: string  //档次
            renshuRange: number  //参与人数
            damagebuff: number  //伤害加成（百分比）
        }
    }
    task: {
        [dc: string]: {
            dc: string  //档次dc
            kind: string  //活动种类
            need: number  //需要完成进度
            items: number[][]  //抽中道具
        }
    }
    hgsyLeiji: {
        [dc: string]: {
            dc: string  //档次
            count: number  //累计次数
            rwd: number[]  //累计次数奖励
        }
    }
}





export interface HdHeFuOut {
    signRecord: {
        [key: number]: {
            base: number,//基础 0默认状态 1当天未登录,需补签 2当天已登录，可以领取奖励 3已领取奖励
            djq: number,//高级 0默认状态 1当天未登录,需补签 2当天已登录，可以领取奖励 3已领取奖励
        }
    }; //签到记录
    advanceLockStatus: number; //高级签到 开启状态 0未解锁 1解锁
    khflHaoHuaStatus: number; //狂欢福利-豪华福利状态 0未解锁 1解锁
    khflZhiZunStatus: number; //狂欢福利-至尊福利状态 0未解锁 1解锁
    khflScore: number; //狂欢积分
    chouQuTimes: number; //狂欢盛宴-抽取次数
    chouTimesRwd: {
        //狂欢盛宴-累计抽取次数奖励领取记录
        [dc: string]: number;
    },
    pickBigRwds: {
        //狂欢盛宴 - 用户选的自选大奖 {大奖类别: 大奖索引
        [xuhao: number]: string;
    },
    bigRwdRecord: {
        //大奖相关记录，保底次数，已抽取过几次
        [brid: string]: {
            baodi: number,
            times: number,
        };
    },
    xyRwdRecord: {
        //稀有奖励-已抽取过几次
        [brid: string]: number;
    },
    xyBaoDi: number; //狂欢盛宴 - 稀有保底次数
    khflRwd: {
        //狂欢福利奖励领取记录
        [dc: string]: {
            base: number,
            haohua: number,
            zhizun: number,
        };
    },
    khflSocreRwd: {
        //狂欢福利-累计积分奖励领取记录
        [dc: string]: number;
    },
    hook: {
        //完成进度
        [kind: string]: number;
    };
    taskRwd: {
        //任务领取记录
        [id: string]: number; // 已领取档次
    };
    duihuan: { [dc: string]: number }; //已经兑换档次列表
    shopItemCost: number; //狂欢币消耗数量
    //礼包购买
    gift: {
        [id: string]: number;
    };
    //礼包购买
    giftDay: {
        [id: string]: number;
    };
    //助力奖励领取记录
    zlRwdRecord: {
        [id: string]: number;
    };
    //助力奖励最大达成人数1
    zlRwdMax: {
        [id: string]: number;
    };
    //神藏结界-攻击次数
    szjjAtkCount: number;
    //神藏结界- 领取到的最高一层
    szjjRwd: number;
    //神藏结界-攻击累计次数奖励领取记录
    szjjAtkRwd: {
        //任务领取记录
        [id: string]: number; // 已领取档次
    };
    //合服挑战-关卡状态记录
    tzgqRecord: {
        [id: string]: number; // 0未解锁 1已解锁 2通关
    };
    //下次出大奖的次数
    nextDaJiangNeed: number;
    //已经出了几次大奖
    daJiangCount: number;
    //当前的挑战关卡
    currentTzGq: string;
}

export interface SevHeFuDaoYouZhuLiRecordsOut {
    records: {
        iid: number; //唯一标识
        user: FUserInfo; //添加的用户
        time: number; //添加的时间
        count: number; //被领取了几次
        state: 0 | 1; //0未领取 1已领取
    }[],
}

//合服活动-神藏结界输出
export interface SevHeFuShenZangJieJieOut {
    //结界id
    id: number,
    //总造成伤害
    damage: number,
    //总攻击次数
    atkCount: number,
    //是否完成
    isFinish: 0 | 1,
}

export interface HdJiuXiaoTianShuData {
    card: {
        [id: string]: {
            id: string  //特权卡id
            name: string  //特权卡名称
            title: string  //特权卡奖励title
            icon: string  //特权卡奖励图片
            days: number  //持续天数
            need: number[]  //购买价格
            buyRwd: number[][]  //购买奖励
            dayRwd: number[][]  //每日奖励
            kind: string  //属性奖励条件类型
            desc: string  //属性奖励描述
            epsNeed: number  //属性奖励条件要求
            count: number  //属性奖励次数
            eps: { [key: string]: number }  //属性奖励
            privilege: number[][]  //特权列表
        }
    }
    privilege: {
        [id: string]: {
            id: string  //特权类型id
            desc: string  //特权描述
        }
    }
}


export interface HdJiuXiaoTianShuOut {
    cards: {
        [id: string]: {
            expireTime: number; //购买过期时间 0 未购买 >0 过期时间 <0 永久
            lastTime: number; //上次领取时间
            count: number; //属性条件次数
        };
    };
    dailyTaskRwd: number, //日常任务进度奖励增加x%
    zongMenTaskRwd: number, //宗门任务进度奖励增加x%
    zongMenBossRwd: number, //宗门BOSS宝箱奖励增加x%
    zongMenXuanShangRwd: number, //宗门悬赏奖励增加x%
    daoYouRwd: number, //道友升级奖励增加x%
    daoWenFenJie: number, //道纹分解获得经验增加x%
    huoBanEps: number, //伙伴属性额外增加x%【基础值】
    shouLingEps: number, //兽灵属性额外增加x%【基础值】
    daoWenEps: number, //道纹属性额外增加x%【佩戴的基础值】
    shiJianEps: number, //世家属性额外增加x%【基础值】
    guZiEps: number, //古字属性额外增加x%【佩戴的基础值】
}


export interface HdActPreData {
    actpre_daily_rwd: number[]   //每日奖励
    actpre: {
        [id: string]: {
            id: string  //索引
            hangid: string  //行数
            hdkey: string  //活动key
            name: string  //活动名称
            desc: string  //活动介绍
            type: string  //活动类型
            icon: string  //活动图标
            kaiqi: string  //开启id
            items: number[][]  //奖励预览
        }
    }
}

export interface HdActPreOut {
    dailyRwd: number   //每日奖励 0未领取 1已领取
    actpre: {
        [id: string]:
        {
            start: number;
            end: number;
            id: string;
            hdcid: string
        }[]
    }
}
export interface HdZhangJieEpsData {
    EpsPara: number   //系数A（百分比），难度系数
    EpsParaMin: number   //系数B（百分比）
    eps: string[]   //生效属性
    expectDay: {
        id: string  //章节id
        day: number  //期望通过的开服天数
    }[]
}

export interface HdXiuWeiShenZaoData {
    costItem: number   //消耗道具ID
    need: number[]   //价格
    levels: {
        [id: string]: {
            id: string  //索引
            need: number  //消耗
            num_max: number  //深造次数上限
            up: number  //提升万分比
        }
    }
}


export interface HdXiuWeiShenZaoOut {
    isBuy: number; //是否购买 0未购买 1已购买
    level: number; //等级
    costNum: number; //消耗次数
    dailyCount: number; //每日次数
}


export interface HdTianDengData {
    show: number   //活动提前结束时间，比如21-23号的活动，这里配置86400（一天），正常活动时间为21-22号 22-23号为活动结束展示时间
    freeNum: number   //每日免费祈愿次数
    freeRwd: number[][]   //免费祈愿奖励
    jinduRobot: number[]   //每隔x秒随机增加范围进度值，[每隔x秒，范围1，范围2]
    kuaNum: number   //跨服区服个数
    jiezhiTime: number   //开奖前x秒截止礼包购买
    kuaType: number   //普通跨服
    dalayTime: number   //延迟多久开奖
    jindu: {
        [dc: string]: {
            dc: string  //档次
            need: number  //进度
            rwd: number[][]  //进度奖励
        }
    }
    libao: {
        [dc: string]: {
            dc: string  //档次
            need: number[]  //进度
            rwd: number[][]  //礼包奖励
            rwd2: number[][]  //天选奖励
            members: number[]  //中奖人数[默认人数，每增加x人购买多1个中奖名额]
        }
    }
}




export interface HdTianDengOut {
    giftDaily: { [dc: string]: number };//礼包购买记录 档次：1:购买 0未购买
    processRecord: { [dc: string]: number };//祈愿进度奖励领取记录 1:已领取 0未领取
    free: number;//免费祈愿：1:已祈愿 0未祈愿
    codes: { //我的中奖码
        [dc: string]:  //档次
        {
            [day: string]: {
                code: string, //祈愿码
                state: number, //状态 0默认 1中了 2没中
            }
        }
    };
    kuaList: string[]; //参与的区服
    paomas: string[]; //需要发送的跑马灯
}


export interface SevTianDengOut {
    winner: {
        [dc: string]: {
            [day: string]: {
                name: string,
                power: number,
                code: string,
            }
        }
    },//赢家
    shower: { [dc: string]: { [day: string]: FUserInfo } }, //展示赢家
    process: number, //公共进度
}
